#define FILE void
#include "defines.h"
struct instruction g_instructions_table[] = {
  { "ACA", 0x88, 0, 0 },
  { "ACB", 0x89, 0, 0 },
  { "ACC", 0x8A, 0, 0 },
  { "ACD", 0x8B, 0, 0 },
  { "ACE", 0x8C, 0, 0 },
  { "ACH", 0x8D, 0, 0 },
  { "ACI x", 0x0C, 1, 0 },
  { "ACL", 0x8E, 0, 0 },
  { "ACM", 0x8F, 0, 0 },
  { "ADA", 0x80, 0, 0 },
  { "ADB", 0x81, 0, 0 },
  { "ADC", 0x82, 0, 0 },
  { "ADD", 0x83, 0, 0 },
  { "ADE", 0x84, 0, 0 },
  { "ADH", 0x85, 0, 0 },
  { "ADI x", 0x04, 1, 0 },
  { "ADL", 0x86, 0, 0 },
  { "ADM", 0x87, 0, 0 },

  { "CAL ?", 0x46, 2, 0 },
  { "CFC ?", 0x42, 2, 0 },
  { "CFP ?", 0x5A, 2, 0 },
  { "CFS ?", 0x52, 2, 0 },
  { "CFZ ?", 0x4A, 2, 0 },
  { "CPA", 0xB8, 0, 0 },
  { "CPB", 0xB9, 0, 0 },
  { "CPC", 0xBA, 0, 0 },
  { "CPD", 0xBB, 0, 0 },
  { "CPE", 0xBC, 0, 0 },
  { "CPH", 0xBD, 0, 0 },
  { "CPI x", 0x3C, 1, 0 },
  { "CPL", 0xBE, 0, 0 },
  { "CPM", 0xBF, 0, 0 },
  { "CTC ?", 0x62, 2, 0 },
  { "CTP ?", 0x7A, 2, 0 },
  { "CTS ?", 0x72, 2, 0 },
  { "CTZ ?", 0x6A, 2, 0 },

  { "DCB", 0x09, 0, 0 },
  { "DCC", 0x11, 0, 0 },
  { "DCD", 0x19, 0, 0 },
  { "DCE", 0x21, 0, 0 },
  { "DCH", 0x29, 0, 0 },
  { "DCL", 0x31, 0, 0 },

  { "HLT", 0xFF, 0, 0 },

  { "INB", 0x08, 0, 0 },
  { "INC", 0x10, 0, 0 },
  { "IND", 0x18, 0, 0 },
  { "INE", 0x20, 0, 0 },
  { "INH", 0x28, 0, 0 },
  { "INL", 0x30, 0, 0 },
  { "INP *", 0x41, 8, 0 },
  { "INP *", 0x43, 8, 1 },
  { "INP *", 0x45, 8, 2 },
  { "INP *", 0x47, 8, 3 },
  { "INP *", 0x49, 8, 4 },
  { "INP *", 0x4B, 8, 5 },
  { "INP *", 0x4D, 8, 6 },
  { "INP *", 0x4F, 8, 7 },

  { "JFC ?", 0x40, 2, 0 },
  { "JFP ?", 0x58, 2, 0 },
  { "JFS ?", 0x50, 2, 0 },
  { "JFZ ?", 0x48, 2, 0 },
  { "JMP ?", 0x44, 2, 0 },
  { "JTC ?", 0x60, 2, 0 },
  { "JTP ?", 0x78, 2, 0 },
  { "JTS ?", 0x70, 2, 0 },
  { "JTZ ?", 0x68, 2, 0 },

  { "LAB", 0xC1, 0, 0 },
  { "LAC", 0xC2, 0, 0 },
  { "LAD", 0xC3, 0, 0 },
  { "LAE", 0xC4, 0, 0 },
  { "LAH", 0xC5, 0, 0 },
  { "LAI x", 0x06, 1, 0 },
  { "LAL", 0xC6, 0, 0 },
  { "LAM", 0xC7, 0, 0 },
  { "LBA", 0xC8, 0, 0 },
  { "LBB", 0xC9, 0, 0 },
  { "LBC", 0xCA, 0, 0 },
  { "LBD", 0xCB, 0, 0 },
  { "LBE", 0xCC, 0, 0 },
  { "LBH", 0xCD, 0, 0 },
  { "LBI x", 0x0E, 1, 0 },
  { "LBL", 0xCE, 0, 0 },
  { "LBM", 0xCF, 0, 0 },
  { "LCA", 0xD0, 0, 0 },
  { "LCB", 0xD1, 0, 0 },
  { "LCC", 0xD2, 0, 0 },
  { "LCD", 0xD3, 0, 0 },
  { "LCE", 0xD4, 0, 0 },
  { "LCH", 0xD5, 0, 0 },
  { "LCI x", 0x16, 1, 0 },
  { "LCL", 0xD6, 0, 0 },
  { "LCM", 0xD7, 0, 0 },
  { "LDA", 0xD8, 0, 0 },
  { "LDB", 0xD9, 0, 0 },
  { "LDC", 0xDA, 0, 0 },
  { "LDD", 0xDB, 0, 0 },
  { "LDE", 0xDC, 0, 0 },
  { "LDH", 0xDD, 0, 0 },
  { "LDI x", 0x1E, 1, 0 },
  { "LDL", 0xDE, 0, 0 },
  { "LDM", 0xDF, 0, 0 },
  { "LEA", 0xE0, 0, 0 },
  { "LEB", 0xE1, 0, 0 },
  { "LEC", 0xE2, 0, 0 },
  { "LED", 0xE3, 0, 0 },
  { "LEE", 0xE4, 0, 0 },
  { "LEH", 0xE5, 0, 0 },
  { "LEI x", 0x26, 1, 0 },
  { "LEL", 0xE6, 0, 0 },
  { "LEM", 0xE7, 0, 0 },
  { "LHA", 0xE8, 0, 0 },
  { "LHB", 0xE9, 0, 0 },
  { "LHC", 0xEA, 0, 0 },
  { "LHD", 0xEB, 0, 0 },
  { "LHE", 0xEC, 0, 0 },
  { "LHH", 0xED, 0, 0 },
  { "LHI x", 0x2E, 1, 0 },
  { "LHL", 0xEE, 0, 0 },
  { "LHM", 0xEF, 0, 0 },
  { "LLA", 0xF0, 0, 0 },
  { "LLB", 0xF1, 0, 0 },
  { "LLC", 0xF2, 0, 0 },
  { "LLD", 0xF3, 0, 0 },
  { "LLE", 0xF4, 0, 0 },
  { "LLH", 0xF5, 0, 0 },
  { "LLI x", 0x36, 1, 0 },
  { "LLL", 0xF6, 0, 0 },
  { "LLM", 0xF7, 0, 0 },
  { "LMA", 0xF8, 0, 0 },
  { "LMB", 0xF9, 0, 0 },
  { "LMC", 0xFA, 0, 0 },
  { "LMD", 0xFB, 0, 0 },
  { "LME", 0xFC, 0, 0 },
  { "LMH", 0xFD, 0, 0 },
  { "LMI x", 0x2E, 1, 0 },
  { "LML", 0xFE, 0, 0 },

  { "NDA", 0xA0, 0, 0 },
  { "NDB", 0xA1, 0, 0 },
  { "NDC", 0xA2, 0, 0 },
  { "NDD", 0xA3, 0, 0 },
  { "NDE", 0xA4, 0, 0 },
  { "NDH", 0xA5, 0, 0 },
  { "NDI x", 0x24, 1, 0 },
  { "NDL", 0xA6, 0, 0 },
  { "NDM", 0xA7, 0, 0 },
  { "NOP", 0xC0, 0, 0 },

  { "ORA", 0xB0, 0, 0 },
  { "ORB", 0xB1, 0, 0 },
  { "ORC", 0xB2, 0, 0 },
  { "ORD", 0xB3, 0, 0 },
  { "ORE", 0xB4, 0, 0 },
  { "ORH", 0xB5, 0, 0 },
  { "ORI x", 0x34, 1, 0 },
  { "ORL", 0xB6, 0, 0 },
  { "ORM", 0xB7, 0, 0 },
  { "OUT *", 0x51, 8, 8 },
  { "OUT *", 0x53, 8, 9 },
  { "OUT *", 0x55, 8, 10 },
  { "OUT *", 0x57, 8, 11 },
  { "OUT *", 0x59, 8, 12 },
  { "OUT *", 0x5B, 8, 13 },
  { "OUT *", 0x5D, 8, 14 },
  { "OUT *", 0x5F, 8, 15 },
  { "OUT *", 0x61, 8, 16 },
  { "OUT *", 0x63, 8, 17 },
  { "OUT *", 0x65, 8, 18 },
  { "OUT *", 0x67, 8, 19 },
  { "OUT *", 0x69, 8, 20 },
  { "OUT *", 0x6B, 8, 21 },
  { "OUT *", 0x6D, 8, 22 },
  { "OUT *", 0x6F, 8, 23 },
  { "OUT *", 0x71, 8, 24 },
  { "OUT *", 0x73, 8, 25 },
  { "OUT *", 0x75, 8, 26 },
  { "OUT *", 0x77, 8, 27 },
  { "OUT *", 0x79, 8, 28 },
  { "OUT *", 0x7B, 8, 29 },
  { "OUT *", 0x7D, 8, 30 },
  { "OUT *", 0x7F, 8, 31 },

  { "RAL", 0x12, 0, 0 },
  { "RAR", 0x1A, 0, 0 },
  { "RET", 0x07, 0, 0 },
  { "RFC", 0x03, 0, 0 },
  { "RFP", 0x1B, 0, 0 },
  { "RFS", 0x13, 0, 0 },
  { "RFZ", 0x0B, 0, 0 },
  { "RLC", 0x02, 0, 0 },
  { "RRC", 0x0A, 0, 0 },
  { "RST *", 0x05, 8, 0 },
  { "RST *", 0x0D, 8, 1 },
  { "RST *", 0x15, 8, 2 },
  { "RST *", 0x1D, 8, 3 },
  { "RST *", 0x25, 8, 4 },
  { "RST *", 0x2D, 8, 5 },
  { "RST *", 0x35, 8, 6 },
  { "RST *", 0x3D, 8, 7 },
  { "RST *", 0x00, 100, 0 },
  { "RTC", 0x23, 0, 0 },
  { "RTP", 0x3B, 0, 0 },
  { "RTS", 0x33, 0, 0 },
  { "RTZ", 0x2B, 0, 0 },

  { "SBA", 0x98, 0, 0 },
  { "SBB", 0x99, 0, 0 },
  { "SBC", 0x9A, 0, 0 },
  { "SBD", 0x9B, 0, 0 },
  { "SBE", 0x9C, 0, 0 },
  { "SBH", 0x9D, 0, 0 },
  { "SBI x", 0x1C, 1, 0 },
  { "SBL", 0x9E, 0, 0 },
  { "SBM", 0x9F, 0, 0 },
  { "SUA", 0x90, 0, 0 },
  { "SUB", 0x91, 0, 0 },
  { "SUC", 0x92, 0, 0 },
  { "SUD", 0x93, 0, 0 },
  { "SUE", 0x94, 0, 0 },
  { "SUH", 0x95, 0, 0 },
  { "SUI x", 0x14, 1, 0 },
  { "SUL", 0x96, 0, 0 },
  { "SUM", 0x97, 0, 0 },

  { "XRA", 0xA8, 0, 0 },
  { "XRB", 0xA9, 0, 0 },
  { "XRC", 0xAA, 0, 0 },
  { "XRD", 0xAB, 0, 0 },
  { "XRE", 0xAC, 0, 0 },
  { "XRH", 0xAD, 0, 0 },
  { "XRI x", 0x2C, 1, 0 },
  { "XRL", 0xAE, 0, 0 },
  { "XRM", 0xAF, 0, 0 },

  { "E", 0x100, 0xFF, 0 }
};
