#define FILE void
#include "defines.h"

/* got the defines from https://stackoverflow.com/questions/18244726/why-doesnt-c-have-binary-literals */
#define B0_(X) ((X) % 8 + B1_((X)/8) * 2)
#define B1_(X) ((X) % 8 + B2_((X)/8) * 2)
#define B2_(X) ((X) % 8 + B3_((X)/8) * 2)
#define B3_(X) ((X) % 8 + B4_((X)/8) * 2)
#define B4_(X) ((X) % 8 + B5_((X)/8) * 2)
#define B5_(X) ((X) % 8 + B6_((X)/8) * 2)
#define B6_(X) ((X) % 8 + B7_((X)/8) * 2)
#define B7_(X) ((X) % 8)
#define B_(x) B0_(0##x)

struct instruction g_instructions_table[] = {
  { "ABX", 0x3A, 0, 0, 0 },

  { "ADCA #x", 0x89, 1, 0, 0 },
  { "ADCA,X", 0xA9, 9, 0, B_(10000100) },
  { "ADCA,Y", 0xA9, 9, 0, B_(10100100) },
  { "ADCA,U", 0xA9, 9, 0, B_(11000100) },
  { "ADCA,S", 0xA9, 9, 0, B_(11100100) },
  { "ADCA A,X", 0xA9, 9, 0, B_(10000110) },
  { "ADCA A,Y", 0xA9, 9, 0, B_(10100110) },
  { "ADCA A,U", 0xA9, 9, 0, B_(11000110) },
  { "ADCA A,S", 0xA9, 9, 0, B_(11100110) },
  { "ADCA B,X", 0xA9, 9, 0, B_(10000101) },
  { "ADCA B,Y", 0xA9, 9, 0, B_(10100101) },
  { "ADCA B,U", 0xA9, 9, 0, B_(11000101) },
  { "ADCA B,S", 0xA9, 9, 0, B_(11100101) },
  { "ADCA D,X", 0xA9, 9, 0, B_(10001011) },
  { "ADCA D,Y", 0xA9, 9, 0, B_(10101011) },
  { "ADCA D,U", 0xA9, 9, 0, B_(11001011) },
  { "ADCA D,S", 0xA9, 9, 0, B_(11101011) },
  { "ADCA,X+", 0xA9, 9, 0, B_(10000000) },
  { "ADCA,Y+", 0xA9, 9, 0, B_(10100000) },
  { "ADCA,U+", 0xA9, 9, 0, B_(11000000) },
  { "ADCA,S+", 0xA9, 9, 0, B_(11100000) },
  { "ADCA,X++", 0xA9, 9, 0, B_(10000001) },
  { "ADCA,Y++", 0xA9, 9, 0, B_(10100001) },
  { "ADCA,U++", 0xA9, 9, 0, B_(11000001) },
  { "ADCA,S++", 0xA9, 9, 0, B_(11100001) },
  { "ADCA,-X", 0xA9, 9, 0, B_(10000010) },
  { "ADCA,-Y", 0xA9, 9, 0, B_(10100010) },
  { "ADCA,-U", 0xA9, 9, 0, B_(11000010) },
  { "ADCA,-S", 0xA9, 9, 0, B_(11100010) },
  { "ADCA,--X", 0xA9, 9, 0, B_(10000011) },
  { "ADCA,--Y", 0xA9, 9, 0, B_(10100011) },
  { "ADCA,--U", 0xA9, 9, 0, B_(11000011) },
  { "ADCA,--S", 0xA9, 9, 0, B_(11100011) },
  { "ADCA (,X)", 0xA9, 9, 0, B_(10010100) },
  { "ADCA (,Y)", 0xA9, 9, 0, B_(10110100) },
  { "ADCA (,U)", 0xA9, 9, 0, B_(11010100) },
  { "ADCA (,S)", 0xA9, 9, 0, B_(11110100) },
  { "ADCA (A,X)", 0xA9, 9, 0, B_(10010110) },
  { "ADCA (A,Y)", 0xA9, 9, 0, B_(10110110) },
  { "ADCA (A,U)", 0xA9, 9, 0, B_(11010110) },
  { "ADCA (A,S)", 0xA9, 9, 0, B_(11110110) },
  { "ADCA (B,X)", 0xA9, 9, 0, B_(10010101) },
  { "ADCA (B,Y)", 0xA9, 9, 0, B_(10110101) },
  { "ADCA (B,U)", 0xA9, 9, 0, B_(11010101) },
  { "ADCA (B,S)", 0xA9, 9, 0, B_(11110101) },
  { "ADCA (D,X)", 0xA9, 9, 0, B_(10011011) },
  { "ADCA (D,Y)", 0xA9, 9, 0, B_(10111011) },
  { "ADCA (D,U)", 0xA9, 9, 0, B_(11011011) },
  { "ADCA (D,S)", 0xA9, 9, 0, B_(11111011) },
  { "ADCA (,X++)", 0xA9, 9, 0, B_(10010001) },
  { "ADCA (,Y++)", 0xA9, 9, 0, B_(10110001) },
  { "ADCA (,U++)", 0xA9, 9, 0, B_(11010001) },
  { "ADCA (,S++)", 0xA9, 9, 0, B_(11110001) },
  { "ADCA (,--X)", 0xA9, 9, 0, B_(10010011) },
  { "ADCA (,--Y)", 0xA9, 9, 0, B_(10110011) },
  { "ADCA (,--U)", 0xA9, 9, 0, B_(11010011) },
  { "ADCA (,--S)", 0xA9, 9, 0, B_(11110011) },
  { "ADCA (x,X)", 0xA9, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ADCA (x,Y)", 0xA9, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ADCA (x,U)", 0xA9, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ADCA (x,S)", 0xA9, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ADCA (?,X)", 0xA9, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ADCA (?,Y)", 0xA9, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ADCA (?,U)", 0xA9, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ADCA (?,S)", 0xA9, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ADCA (x,PCR)", 0xA9, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ADCA (?,PCR)", 0xA9, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ADCA (?)", 0xA9, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ADCA s,X", 0xA9, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ADCA s,Y", 0xA9, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ADCA s,U", 0xA9, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ADCA s,S", 0xA9, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ADCA x,X", 0xA9, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ADCA x,Y", 0xA9, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ADCA x,U", 0xA9, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ADCA x,S", 0xA9, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ADCA ?,X", 0xA9, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ADCA ?,Y", 0xA9, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ADCA ?,U", 0xA9, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ADCA ?,S", 0xA9, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ADCA x,PCR", 0xA9, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ADCA ?,PCR", 0xA9, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ADCA x", 0x99, 4, 1, 0 },
  { "ADCA ?", 0xB9, 2, 0, 0 },

  { "ADCB #x", 0xC9, 1, 0, 0 },
  { "ADCB,X", 0xE9, 9, 0, B_(10000100) },
  { "ADCB,Y", 0xE9, 9, 0, B_(10100100) },
  { "ADCB,U", 0xE9, 9, 0, B_(11000100) },
  { "ADCB,S", 0xE9, 9, 0, B_(11100100) }, /* 0xE4 */
  { "ADCB A,X", 0xE9, 9, 0, B_(10000110) },
  { "ADCB A,Y", 0xE9, 9, 0, B_(10100110) },
  { "ADCB A,U", 0xE9, 9, 0, B_(11000110) },
  { "ADCB A,S", 0xE9, 9, 0, B_(11100110) }, /* 0xE6 */
  { "ADCB B,X", 0xE9, 9, 0, B_(10000101) },
  { "ADCB B,Y", 0xE9, 9, 0, B_(10100101) },
  { "ADCB B,U", 0xE9, 9, 0, B_(11000101) },
  { "ADCB B,S", 0xE9, 9, 0, B_(11100101) }, /* 0xE5 */
  { "ADCB D,X", 0xE9, 9, 0, B_(10001011) },
  { "ADCB D,Y", 0xE9, 9, 0, B_(10101011) },
  { "ADCB D,U", 0xE9, 9, 0, B_(11001011) },
  { "ADCB D,S", 0xE9, 9, 0, B_(11101011) },
  { "ADCB,X+", 0xE9, 9, 0, B_(10000000) },
  { "ADCB,Y+", 0xE9, 9, 0, B_(10100000) },
  { "ADCB,U+", 0xE9, 9, 0, B_(11000000) },
  { "ADCB,S+", 0xE9, 9, 0, B_(11100000) }, /* 0xE0 */
  { "ADCB,X++", 0xE9, 9, 0, B_(10000001) },
  { "ADCB,Y++", 0xE9, 9, 0, B_(10100001) },
  { "ADCB,U++", 0xE9, 9, 0, B_(11000001) },
  { "ADCB,S++", 0xE9, 9, 0, B_(11100001) }, /* 0xE1 */
  { "ADCB,-X", 0xE9, 9, 0, B_(10000010) },
  { "ADCB,-Y", 0xE9, 9, 0, B_(10100010) },
  { "ADCB,-U", 0xE9, 9, 0, B_(11000010) },
  { "ADCB,-S", 0xE9, 9, 0, B_(11100010) }, /* 0xE2 */
  { "ADCB,--X", 0xE9, 9, 0, B_(10000011) },
  { "ADCB,--Y", 0xE9, 9, 0, B_(10100011) },
  { "ADCB,--U", 0xE9, 9, 0, B_(11000011) },
  { "ADCB,--S", 0xE9, 9, 0, B_(11100011) }, /* 0xE3 */
  { "ADCB (,X)", 0xE9, 9, 0, B_(10010100) },
  { "ADCB (,Y)", 0xE9, 9, 0, B_(10110100) },
  { "ADCB (,U)", 0xE9, 9, 0, B_(11010100) },
  { "ADCB (,S)", 0xE9, 9, 0, B_(11110100) }, /* 0xF4 */
  { "ADCB (A,X)", 0xE9, 9, 0, B_(10010110) },
  { "ADCB (A,Y)", 0xE9, 9, 0, B_(10110110) },
  { "ADCB (A,U)", 0xE9, 9, 0, B_(11010110) },
  { "ADCB (A,S)", 0xE9, 9, 0, B_(11110110) }, /* 0xF6 */
  { "ADCB (B,X)", 0xE9, 9, 0, B_(10010101) },
  { "ADCB (B,Y)", 0xE9, 9, 0, B_(10110101) },
  { "ADCB (B,U)", 0xE9, 9, 0, B_(11010101) },
  { "ADCB (B,S)", 0xE9, 9, 0, B_(11110101) }, /* 0xF5 */
  { "ADCB (D,X)", 0xE9, 9, 0, B_(10011011) },
  { "ADCB (D,Y)", 0xE9, 9, 0, B_(10111011) },
  { "ADCB (D,U)", 0xE9, 9, 0, B_(11011011) },
  { "ADCB (D,S)", 0xE9, 9, 0, B_(11111011) }, /* 0xFB */
  { "ADCB (,X++)", 0xE9, 9, 0, B_(10010001) },
  { "ADCB (,Y++)", 0xE9, 9, 0, B_(10110001) },
  { "ADCB (,U++)", 0xE9, 9, 0, B_(11010001) },
  { "ADCB (,S++)", 0xE9, 9, 0, B_(11110001) }, /* 0xF1 */
  { "ADCB (,--X)", 0xE9, 9, 0, B_(10010011) },
  { "ADCB (,--Y)", 0xE9, 9, 0, B_(10110011) },
  { "ADCB (,--U)", 0xE9, 9, 0, B_(11010011) },
  { "ADCB (,--S)", 0xE9, 9, 0, B_(11110011) }, /* 0xF3 */
  { "ADCB (x,X)", 0xE9, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ADCB (x,Y)", 0xE9, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ADCB (x,U)", 0xE9, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ADCB (x,S)", 0xE9, 7, 1, B_(11111000) }, /* 8-bit offset */ /* 0xF8 */
  { "ADCB (?,X)", 0xE9, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ADCB (?,Y)", 0xE9, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ADCB (?,U)", 0xE9, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ADCB (?,S)", 0xE9, 8, 0, B_(11111001) }, /* 16-bit offset */ /* 0xF9 */
  { "ADCB (x,PCR)", 0xE9, 7, 1, B_(10011100) }, /* 8-bit offset */ /* 0x9C */
  { "ADCB (?,PCR)", 0xE9, 8, 0, B_(10011101) }, /* 16-bit offset */ /* 0x9D */
  { "ADCB (?)", 0xE9, 8, 0, B_(10011111) }, /* 16-bit offset */ /* 0x9F */
  { "ADCB s,X", 0xE9, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ADCB s,Y", 0xE9, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ADCB s,U", 0xE9, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ADCB s,S", 0xE9, 6, 1, B_(01100000) }, /* 5-bit offset */ /* 0x60 */
  { "ADCB x,X", 0xE9, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ADCB x,Y", 0xE9, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ADCB x,U", 0xE9, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ADCB x,S", 0xE9, 7, 1, B_(11101000) }, /* 8-bit offset */ /* 0xE8 */
  { "ADCB ?,X", 0xE9, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ADCB ?,Y", 0xE9, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ADCB ?,U", 0xE9, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ADCB ?,S", 0xE9, 8, 0, B_(11101001) }, /* 16-bit offset */ /* 0xE9 */
  { "ADCB x,PCR", 0xE9, 7, 1, B_(10001100) }, /* 8-bit offset */ /* 0x8C */
  { "ADCB ?,PCR", 0xE9, 8, 0, B_(10001101) }, /* 16-bit offset */ /* 0x8D */
  { "ADCB x", 0xD9, 4, 1, 0 },
  { "ADCB ?", 0xF9, 2, 0, 0 },

  { "ADDA #x", 0x8B, 1, 0, 0 },
  { "ADDA,X", 0xAB, 9, 0, B_(10000100) },
  { "ADDA,Y", 0xAB, 9, 0, B_(10100100) },
  { "ADDA,U", 0xAB, 9, 0, B_(11000100) },
  { "ADDA,S", 0xAB, 9, 0, B_(11100100) },
  { "ADDA A,X", 0xAB, 9, 0, B_(10000110) },
  { "ADDA A,Y", 0xAB, 9, 0, B_(10100110) },
  { "ADDA A,U", 0xAB, 9, 0, B_(11000110) },
  { "ADDA A,S", 0xAB, 9, 0, B_(11100110) },
  { "ADDA B,X", 0xAB, 9, 0, B_(10000101) },
  { "ADDA B,Y", 0xAB, 9, 0, B_(10100101) },
  { "ADDA B,U", 0xAB, 9, 0, B_(11000101) },
  { "ADDA B,S", 0xAB, 9, 0, B_(11100101) },
  { "ADDA D,X", 0xAB, 9, 0, B_(10001011) },
  { "ADDA D,Y", 0xAB, 9, 0, B_(10101011) },
  { "ADDA D,U", 0xAB, 9, 0, B_(11001011) },
  { "ADDA D,S", 0xAB, 9, 0, B_(11101011) },
  { "ADDA,X+", 0xAB, 9, 0, B_(10000000) },
  { "ADDA,Y+", 0xAB, 9, 0, B_(10100000) },
  { "ADDA,U+", 0xAB, 9, 0, B_(11000000) },
  { "ADDA,S+", 0xAB, 9, 0, B_(11100000) },
  { "ADDA,X++", 0xAB, 9, 0, B_(10000001) },
  { "ADDA,Y++", 0xAB, 9, 0, B_(10100001) },
  { "ADDA,U++", 0xAB, 9, 0, B_(11000001) },
  { "ADDA,S++", 0xAB, 9, 0, B_(11100001) },
  { "ADDA,-X", 0xAB, 9, 0, B_(10000010) },
  { "ADDA,-Y", 0xAB, 9, 0, B_(10100010) },
  { "ADDA,-U", 0xAB, 9, 0, B_(11000010) },
  { "ADDA,-S", 0xAB, 9, 0, B_(11100010) },
  { "ADDA,--X", 0xAB, 9, 0, B_(10000011) },
  { "ADDA,--Y", 0xAB, 9, 0, B_(10100011) },
  { "ADDA,--U", 0xAB, 9, 0, B_(11000011) },
  { "ADDA,--S", 0xAB, 9, 0, B_(11100011) },
  { "ADDA (,X)", 0xAB, 9, 0, B_(10010100) },
  { "ADDA (,Y)", 0xAB, 9, 0, B_(10110100) },
  { "ADDA (,U)", 0xAB, 9, 0, B_(11010100) },
  { "ADDA (,S)", 0xAB, 9, 0, B_(11110100) },
  { "ADDA (A,X)", 0xAB, 9, 0, B_(10010110) },
  { "ADDA (A,Y)", 0xAB, 9, 0, B_(10110110) },
  { "ADDA (A,U)", 0xAB, 9, 0, B_(11010110) },
  { "ADDA (A,S)", 0xAB, 9, 0, B_(11110110) },
  { "ADDA (B,X)", 0xAB, 9, 0, B_(10010101) },
  { "ADDA (B,Y)", 0xAB, 9, 0, B_(10110101) },
  { "ADDA (B,U)", 0xAB, 9, 0, B_(11010101) },
  { "ADDA (B,S)", 0xAB, 9, 0, B_(11110101) },
  { "ADDA (D,X)", 0xAB, 9, 0, B_(10011011) },
  { "ADDA (D,Y)", 0xAB, 9, 0, B_(10111011) },
  { "ADDA (D,U)", 0xAB, 9, 0, B_(11011011) },
  { "ADDA (D,S)", 0xAB, 9, 0, B_(11111011) },
  { "ADDA (,X++)", 0xAB, 9, 0, B_(10010001) },
  { "ADDA (,Y++)", 0xAB, 9, 0, B_(10110001) },
  { "ADDA (,U++)", 0xAB, 9, 0, B_(11010001) },
  { "ADDA (,S++)", 0xAB, 9, 0, B_(11110001) },
  { "ADDA (,--X)", 0xAB, 9, 0, B_(10010011) },
  { "ADDA (,--Y)", 0xAB, 9, 0, B_(10110011) },
  { "ADDA (,--U)", 0xAB, 9, 0, B_(11010011) },
  { "ADDA (,--S)", 0xAB, 9, 0, B_(11110011) },
  { "ADDA (x,X)", 0xAB, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ADDA (x,Y)", 0xAB, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ADDA (x,U)", 0xAB, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ADDA (x,S)", 0xAB, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ADDA (?,X)", 0xAB, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ADDA (?,Y)", 0xAB, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ADDA (?,U)", 0xAB, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ADDA (?,S)", 0xAB, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ADDA (x,PCR)", 0xAB, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ADDA (?,PCR)", 0xAB, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ADDA (?)", 0xAB, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ADDA s,X", 0xAB, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ADDA s,Y", 0xAB, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ADDA s,U", 0xAB, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ADDA s,S", 0xAB, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ADDA x,X", 0xAB, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ADDA x,Y", 0xAB, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ADDA x,U", 0xAB, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ADDA x,S", 0xAB, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ADDA ?,X", 0xAB, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ADDA ?,Y", 0xAB, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ADDA ?,U", 0xAB, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ADDA ?,S", 0xAB, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ADDA x,PCR", 0xAB, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ADDA ?,PCR", 0xAB, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ADDA x", 0x9B, 4, 1, 0 },
  { "ADDA ?", 0xBB, 2, 0, 0 },

  { "ADDB #x", 0xCB, 1, 0, 0 },
  { "ADDB,X", 0xEB, 9, 0, B_(10000100) },
  { "ADDB,Y", 0xEB, 9, 0, B_(10100100) },
  { "ADDB,U", 0xEB, 9, 0, B_(11000100) },
  { "ADDB,S", 0xEB, 9, 0, B_(11100100) },
  { "ADDB A,X", 0xEB, 9, 0, B_(10000110) },
  { "ADDB A,Y", 0xEB, 9, 0, B_(10100110) },
  { "ADDB A,U", 0xEB, 9, 0, B_(11000110) },
  { "ADDB A,S", 0xEB, 9, 0, B_(11100110) },
  { "ADDB B,X", 0xEB, 9, 0, B_(10000101) },
  { "ADDB B,Y", 0xEB, 9, 0, B_(10100101) },
  { "ADDB B,U", 0xEB, 9, 0, B_(11000101) },
  { "ADDB B,S", 0xEB, 9, 0, B_(11100101) },
  { "ADDB D,X", 0xEB, 9, 0, B_(10001011) },
  { "ADDB D,Y", 0xEB, 9, 0, B_(10101011) },
  { "ADDB D,U", 0xEB, 9, 0, B_(11001011) },
  { "ADDB D,S", 0xEB, 9, 0, B_(11101011) },
  { "ADDB,X+", 0xEB, 9, 0, B_(10000000) },
  { "ADDB,Y+", 0xEB, 9, 0, B_(10100000) },
  { "ADDB,U+", 0xEB, 9, 0, B_(11000000) },
  { "ADDB,S+", 0xEB, 9, 0, B_(11100000) },
  { "ADDB,X++", 0xEB, 9, 0, B_(10000001) },
  { "ADDB,Y++", 0xEB, 9, 0, B_(10100001) },
  { "ADDB,U++", 0xEB, 9, 0, B_(11000001) },
  { "ADDB,S++", 0xEB, 9, 0, B_(11100001) },
  { "ADDB,-X", 0xEB, 9, 0, B_(10000010) },
  { "ADDB,-Y", 0xEB, 9, 0, B_(10100010) },
  { "ADDB,-U", 0xEB, 9, 0, B_(11000010) },
  { "ADDB,-S", 0xEB, 9, 0, B_(11100010) },
  { "ADDB,--X", 0xEB, 9, 0, B_(10000011) },
  { "ADDB,--Y", 0xEB, 9, 0, B_(10100011) },
  { "ADDB,--U", 0xEB, 9, 0, B_(11000011) },
  { "ADDB,--S", 0xEB, 9, 0, B_(11100011) },
  { "ADDB (,X)", 0xEB, 9, 0, B_(10010100) },
  { "ADDB (,Y)", 0xEB, 9, 0, B_(10110100) },
  { "ADDB (,U)", 0xEB, 9, 0, B_(11010100) },
  { "ADDB (,S)", 0xEB, 9, 0, B_(11110100) },
  { "ADDB (A,X)", 0xEB, 9, 0, B_(10010110) },
  { "ADDB (A,Y)", 0xEB, 9, 0, B_(10110110) },
  { "ADDB (A,U)", 0xEB, 9, 0, B_(11010110) },
  { "ADDB (A,S)", 0xEB, 9, 0, B_(11110110) },
  { "ADDB (B,X)", 0xEB, 9, 0, B_(10010101) },
  { "ADDB (B,Y)", 0xEB, 9, 0, B_(10110101) },
  { "ADDB (B,U)", 0xEB, 9, 0, B_(11010101) },
  { "ADDB (B,S)", 0xEB, 9, 0, B_(11110101) },
  { "ADDB (D,X)", 0xEB, 9, 0, B_(10011011) },
  { "ADDB (D,Y)", 0xEB, 9, 0, B_(10111011) },
  { "ADDB (D,U)", 0xEB, 9, 0, B_(11011011) },
  { "ADDB (D,S)", 0xEB, 9, 0, B_(11111011) },
  { "ADDB (,X++)", 0xEB, 9, 0, B_(10010001) },
  { "ADDB (,Y++)", 0xEB, 9, 0, B_(10110001) },
  { "ADDB (,U++)", 0xEB, 9, 0, B_(11010001) },
  { "ADDB (,S++)", 0xEB, 9, 0, B_(11110001) },
  { "ADDB (,--X)", 0xEB, 9, 0, B_(10010011) },
  { "ADDB (,--Y)", 0xEB, 9, 0, B_(10110011) },
  { "ADDB (,--U)", 0xEB, 9, 0, B_(11010011) },
  { "ADDB (,--S)", 0xEB, 9, 0, B_(11110011) },
  { "ADDB (x,X)", 0xEB, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ADDB (x,Y)", 0xEB, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ADDB (x,U)", 0xEB, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ADDB (x,S)", 0xEB, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ADDB (?,X)", 0xEB, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ADDB (?,Y)", 0xEB, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ADDB (?,U)", 0xEB, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ADDB (?,S)", 0xEB, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ADDB (x,PCR)", 0xEB, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ADDB (?,PCR)", 0xEB, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ADDB (?)", 0xEB, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ADDB s,X", 0xEB, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ADDB s,Y", 0xEB, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ADDB s,U", 0xEB, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ADDB s,S", 0xEB, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ADDB x,X", 0xEB, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ADDB x,Y", 0xEB, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ADDB x,U", 0xEB, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ADDB x,S", 0xEB, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ADDB ?,X", 0xEB, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ADDB ?,Y", 0xEB, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ADDB ?,U", 0xEB, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ADDB ?,S", 0xEB, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ADDB x,PCR", 0xEB, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ADDB ?,PCR", 0xEB, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ADDB x", 0xDB, 4, 1, 0 },
  { "ADDB ?", 0xFB, 2, 0, 0 },

  { "ADDD #x", 0xC3, 1, 0, 0 },
  { "ADDD,X", 0xE3, 9, 0, B_(10000100) },
  { "ADDD,Y", 0xE3, 9, 0, B_(10100100) },
  { "ADDD,U", 0xE3, 9, 0, B_(11000100) },
  { "ADDD,S", 0xE3, 9, 0, B_(11100100) },
  { "ADDD A,X", 0xE3, 9, 0, B_(10000110) },
  { "ADDD A,Y", 0xE3, 9, 0, B_(10100110) },
  { "ADDD A,U", 0xE3, 9, 0, B_(11000110) },
  { "ADDD A,S", 0xE3, 9, 0, B_(11100110) },
  { "ADDD B,X", 0xE3, 9, 0, B_(10000101) },
  { "ADDD B,Y", 0xE3, 9, 0, B_(10100101) },
  { "ADDD B,U", 0xE3, 9, 0, B_(11000101) },
  { "ADDD B,S", 0xE3, 9, 0, B_(11100101) },
  { "ADDD D,X", 0xE3, 9, 0, B_(10001011) },
  { "ADDD D,Y", 0xE3, 9, 0, B_(10101011) },
  { "ADDD D,U", 0xE3, 9, 0, B_(11001011) },
  { "ADDD D,S", 0xE3, 9, 0, B_(11101011) },
  { "ADDD,X+", 0xE3, 9, 0, B_(10000000) },
  { "ADDD,Y+", 0xE3, 9, 0, B_(10100000) },
  { "ADDD,U+", 0xE3, 9, 0, B_(11000000) },
  { "ADDD,S+", 0xE3, 9, 0, B_(11100000) },
  { "ADDD,X++", 0xE3, 9, 0, B_(10000001) },
  { "ADDD,Y++", 0xE3, 9, 0, B_(10100001) },
  { "ADDD,U++", 0xE3, 9, 0, B_(11000001) },
  { "ADDD,S++", 0xE3, 9, 0, B_(11100001) },
  { "ADDD,-X", 0xE3, 9, 0, B_(10000010) },
  { "ADDD,-Y", 0xE3, 9, 0, B_(10100010) },
  { "ADDD,-U", 0xE3, 9, 0, B_(11000010) },
  { "ADDD,-S", 0xE3, 9, 0, B_(11100010) },
  { "ADDD,--X", 0xE3, 9, 0, B_(10000011) },
  { "ADDD,--Y", 0xE3, 9, 0, B_(10100011) },
  { "ADDD,--U", 0xE3, 9, 0, B_(11000011) },
  { "ADDD,--S", 0xE3, 9, 0, B_(11100011) },
  { "ADDD (,X)", 0xE3, 9, 0, B_(10010100) },
  { "ADDD (,Y)", 0xE3, 9, 0, B_(10110100) },
  { "ADDD (,U)", 0xE3, 9, 0, B_(11010100) },
  { "ADDD (,S)", 0xE3, 9, 0, B_(11110100) },
  { "ADDD (A,X)", 0xE3, 9, 0, B_(10010110) },
  { "ADDD (A,Y)", 0xE3, 9, 0, B_(10110110) },
  { "ADDD (A,U)", 0xE3, 9, 0, B_(11010110) },
  { "ADDD (A,S)", 0xE3, 9, 0, B_(11110110) },
  { "ADDD (B,X)", 0xE3, 9, 0, B_(10010101) },
  { "ADDD (B,Y)", 0xE3, 9, 0, B_(10110101) },
  { "ADDD (B,U)", 0xE3, 9, 0, B_(11010101) },
  { "ADDD (B,S)", 0xE3, 9, 0, B_(11110101) },
  { "ADDD (D,X)", 0xE3, 9, 0, B_(10011011) },
  { "ADDD (D,Y)", 0xE3, 9, 0, B_(10111011) },
  { "ADDD (D,U)", 0xE3, 9, 0, B_(11011011) },
  { "ADDD (D,S)", 0xE3, 9, 0, B_(11111011) },
  { "ADDD (,X++)", 0xE3, 9, 0, B_(10010001) },
  { "ADDD (,Y++)", 0xE3, 9, 0, B_(10110001) },
  { "ADDD (,U++)", 0xE3, 9, 0, B_(11010001) },
  { "ADDD (,S++)", 0xE3, 9, 0, B_(11110001) },
  { "ADDD (,--X)", 0xE3, 9, 0, B_(10010011) },
  { "ADDD (,--Y)", 0xE3, 9, 0, B_(10110011) },
  { "ADDD (,--U)", 0xE3, 9, 0, B_(11010011) },
  { "ADDD (,--S)", 0xE3, 9, 0, B_(11110011) },
  { "ADDD (x,X)", 0xE3, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ADDD (x,Y)", 0xE3, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ADDD (x,U)", 0xE3, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ADDD (x,S)", 0xE3, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ADDD (?,X)", 0xE3, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ADDD (?,Y)", 0xE3, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ADDD (?,U)", 0xE3, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ADDD (?,S)", 0xE3, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ADDD (x,PCR)", 0xE3, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ADDD (?,PCR)", 0xE3, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ADDD (?)", 0xE3, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ADDD s,X", 0xE3, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ADDD s,Y", 0xE3, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ADDD s,U", 0xE3, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ADDD s,S", 0xE3, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ADDD x,X", 0xE3, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ADDD x,Y", 0xE3, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ADDD x,U", 0xE3, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ADDD x,S", 0xE3, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ADDD ?,X", 0xE3, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ADDD ?,Y", 0xE3, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ADDD ?,U", 0xE3, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ADDD ?,S", 0xE3, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ADDD x,PCR", 0xE3, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ADDD ?,PCR", 0xE3, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ADDD x", 0xD3, 4, 1, 0 },
  { "ADDD ?", 0xF3, 2, 0, 0 },

  { "ANDA #x", 0x84, 1, 0, 0 },
  { "ANDA,X", 0xA4, 9, 0, B_(10000100) },
  { "ANDA,Y", 0xA4, 9, 0, B_(10100100) },
  { "ANDA,U", 0xA4, 9, 0, B_(11000100) },
  { "ANDA,S", 0xA4, 9, 0, B_(11100100) },
  { "ANDA A,X", 0xA4, 9, 0, B_(10000110) },
  { "ANDA A,Y", 0xA4, 9, 0, B_(10100110) },
  { "ANDA A,U", 0xA4, 9, 0, B_(11000110) },
  { "ANDA A,S", 0xA4, 9, 0, B_(11100110) },
  { "ANDA B,X", 0xA4, 9, 0, B_(10000101) },
  { "ANDA B,Y", 0xA4, 9, 0, B_(10100101) },
  { "ANDA B,U", 0xA4, 9, 0, B_(11000101) },
  { "ANDA B,S", 0xA4, 9, 0, B_(11100101) },
  { "ANDA D,X", 0xA4, 9, 0, B_(10001011) },
  { "ANDA D,Y", 0xA4, 9, 0, B_(10101011) },
  { "ANDA D,U", 0xA4, 9, 0, B_(11001011) },
  { "ANDA D,S", 0xA4, 9, 0, B_(11101011) },
  { "ANDA,X+", 0xA4, 9, 0, B_(10000000) },
  { "ANDA,Y+", 0xA4, 9, 0, B_(10100000) },
  { "ANDA,U+", 0xA4, 9, 0, B_(11000000) },
  { "ANDA,S+", 0xA4, 9, 0, B_(11100000) },
  { "ANDA,X++", 0xA4, 9, 0, B_(10000001) },
  { "ANDA,Y++", 0xA4, 9, 0, B_(10100001) },
  { "ANDA,U++", 0xA4, 9, 0, B_(11000001) },
  { "ANDA,S++", 0xA4, 9, 0, B_(11100001) },
  { "ANDA,-X", 0xA4, 9, 0, B_(10000010) },
  { "ANDA,-Y", 0xA4, 9, 0, B_(10100010) },
  { "ANDA,-U", 0xA4, 9, 0, B_(11000010) },
  { "ANDA,-S", 0xA4, 9, 0, B_(11100010) },
  { "ANDA,--X", 0xA4, 9, 0, B_(10000011) },
  { "ANDA,--Y", 0xA4, 9, 0, B_(10100011) },
  { "ANDA,--U", 0xA4, 9, 0, B_(11000011) },
  { "ANDA,--S", 0xA4, 9, 0, B_(11100011) },
  { "ANDA (,X)", 0xA4, 9, 0, B_(10010100) },
  { "ANDA (,Y)", 0xA4, 9, 0, B_(10110100) },
  { "ANDA (,U)", 0xA4, 9, 0, B_(11010100) },
  { "ANDA (,S)", 0xA4, 9, 0, B_(11110100) },
  { "ANDA (A,X)", 0xA4, 9, 0, B_(10010110) },
  { "ANDA (A,Y)", 0xA4, 9, 0, B_(10110110) },
  { "ANDA (A,U)", 0xA4, 9, 0, B_(11010110) },
  { "ANDA (A,S)", 0xA4, 9, 0, B_(11110110) },
  { "ANDA (B,X)", 0xA4, 9, 0, B_(10010101) },
  { "ANDA (B,Y)", 0xA4, 9, 0, B_(10110101) },
  { "ANDA (B,U)", 0xA4, 9, 0, B_(11010101) },
  { "ANDA (B,S)", 0xA4, 9, 0, B_(11110101) },
  { "ANDA (D,X)", 0xA4, 9, 0, B_(10011011) },
  { "ANDA (D,Y)", 0xA4, 9, 0, B_(10111011) },
  { "ANDA (D,U)", 0xA4, 9, 0, B_(11011011) },
  { "ANDA (D,S)", 0xA4, 9, 0, B_(11111011) },
  { "ANDA (,X++)", 0xA4, 9, 0, B_(10010001) },
  { "ANDA (,Y++)", 0xA4, 9, 0, B_(10110001) },
  { "ANDA (,U++)", 0xA4, 9, 0, B_(11010001) },
  { "ANDA (,S++)", 0xA4, 9, 0, B_(11110001) },
  { "ANDA (,--X)", 0xA4, 9, 0, B_(10010011) },
  { "ANDA (,--Y)", 0xA4, 9, 0, B_(10110011) },
  { "ANDA (,--U)", 0xA4, 9, 0, B_(11010011) },
  { "ANDA (,--S)", 0xA4, 9, 0, B_(11110011) },
  { "ANDA (x,X)", 0xA4, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ANDA (x,Y)", 0xA4, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ANDA (x,U)", 0xA4, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ANDA (x,S)", 0xA4, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ANDA (?,X)", 0xA4, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ANDA (?,Y)", 0xA4, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ANDA (?,U)", 0xA4, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ANDA (?,S)", 0xA4, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ANDA (x,PCR)", 0xA4, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ANDA (?,PCR)", 0xA4, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ANDA (?)", 0xA4, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ANDA s,X", 0xA4, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ANDA s,Y", 0xA4, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ANDA s,U", 0xA4, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ANDA s,S", 0xA4, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ANDA x,X", 0xA4, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ANDA x,Y", 0xA4, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ANDA x,U", 0xA4, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ANDA x,S", 0xA4, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ANDA ?,X", 0xA4, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ANDA ?,Y", 0xA4, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ANDA ?,U", 0xA4, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ANDA ?,S", 0xA4, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ANDA x,PCR", 0xA4, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ANDA ?,PCR", 0xA4, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ANDA x", 0x94, 4, 1, 0 },
  { "ANDA ?", 0xB4, 2, 0, 0 },

  { "ANDB #x", 0xC4, 1, 0, 0 },
  { "ANDB,X", 0xE4, 9, 0, B_(10000100) },
  { "ANDB,Y", 0xE4, 9, 0, B_(10100100) },
  { "ANDB,U", 0xE4, 9, 0, B_(11000100) },
  { "ANDB,S", 0xE4, 9, 0, B_(11100100) },
  { "ANDB A,X", 0xE4, 9, 0, B_(10000110) },
  { "ANDB A,Y", 0xE4, 9, 0, B_(10100110) },
  { "ANDB A,U", 0xE4, 9, 0, B_(11000110) },
  { "ANDB A,S", 0xE4, 9, 0, B_(11100110) },
  { "ANDB B,X", 0xE4, 9, 0, B_(10000101) },
  { "ANDB B,Y", 0xE4, 9, 0, B_(10100101) },
  { "ANDB B,U", 0xE4, 9, 0, B_(11000101) },
  { "ANDB B,S", 0xE4, 9, 0, B_(11100101) },
  { "ANDB D,X", 0xE4, 9, 0, B_(10001011) },
  { "ANDB D,Y", 0xE4, 9, 0, B_(10101011) },
  { "ANDB D,U", 0xE4, 9, 0, B_(11001011) },
  { "ANDB D,S", 0xE4, 9, 0, B_(11101011) },
  { "ANDB,X+", 0xE4, 9, 0, B_(10000000) },
  { "ANDB,Y+", 0xE4, 9, 0, B_(10100000) },
  { "ANDB,U+", 0xE4, 9, 0, B_(11000000) },
  { "ANDB,S+", 0xE4, 9, 0, B_(11100000) },
  { "ANDB,X++", 0xE4, 9, 0, B_(10000001) },
  { "ANDB,Y++", 0xE4, 9, 0, B_(10100001) },
  { "ANDB,U++", 0xE4, 9, 0, B_(11000001) },
  { "ANDB,S++", 0xE4, 9, 0, B_(11100001) },
  { "ANDB,-X", 0xE4, 9, 0, B_(10000010) },
  { "ANDB,-Y", 0xE4, 9, 0, B_(10100010) },
  { "ANDB,-U", 0xE4, 9, 0, B_(11000010) },
  { "ANDB,-S", 0xE4, 9, 0, B_(11100010) },
  { "ANDB,--X", 0xE4, 9, 0, B_(10000011) },
  { "ANDB,--Y", 0xE4, 9, 0, B_(10100011) },
  { "ANDB,--U", 0xE4, 9, 0, B_(11000011) },
  { "ANDB,--S", 0xE4, 9, 0, B_(11100011) },
  { "ANDB (,X)", 0xE4, 9, 0, B_(10010100) },
  { "ANDB (,Y)", 0xE4, 9, 0, B_(10110100) },
  { "ANDB (,U)", 0xE4, 9, 0, B_(11010100) },
  { "ANDB (,S)", 0xE4, 9, 0, B_(11110100) },
  { "ANDB (A,X)", 0xE4, 9, 0, B_(10010110) },
  { "ANDB (A,Y)", 0xE4, 9, 0, B_(10110110) },
  { "ANDB (A,U)", 0xE4, 9, 0, B_(11010110) },
  { "ANDB (A,S)", 0xE4, 9, 0, B_(11110110) },
  { "ANDB (B,X)", 0xE4, 9, 0, B_(10010101) },
  { "ANDB (B,Y)", 0xE4, 9, 0, B_(10110101) },
  { "ANDB (B,U)", 0xE4, 9, 0, B_(11010101) },
  { "ANDB (B,S)", 0xE4, 9, 0, B_(11110101) },
  { "ANDB (D,X)", 0xE4, 9, 0, B_(10011011) },
  { "ANDB (D,Y)", 0xE4, 9, 0, B_(10111011) },
  { "ANDB (D,U)", 0xE4, 9, 0, B_(11011011) },
  { "ANDB (D,S)", 0xE4, 9, 0, B_(11111011) },
  { "ANDB (,X++)", 0xE4, 9, 0, B_(10010001) },
  { "ANDB (,Y++)", 0xE4, 9, 0, B_(10110001) },
  { "ANDB (,U++)", 0xE4, 9, 0, B_(11010001) },
  { "ANDB (,S++)", 0xE4, 9, 0, B_(11110001) },
  { "ANDB (,--X)", 0xE4, 9, 0, B_(10010011) },
  { "ANDB (,--Y)", 0xE4, 9, 0, B_(10110011) },
  { "ANDB (,--U)", 0xE4, 9, 0, B_(11010011) },
  { "ANDB (,--S)", 0xE4, 9, 0, B_(11110011) },
  { "ANDB (x,X)", 0xE4, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ANDB (x,Y)", 0xE4, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ANDB (x,U)", 0xE4, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ANDB (x,S)", 0xE4, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ANDB (?,X)", 0xE4, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ANDB (?,Y)", 0xE4, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ANDB (?,U)", 0xE4, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ANDB (?,S)", 0xE4, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ANDB (x,PCR)", 0xE4, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ANDB (?,PCR)", 0xE4, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ANDB (?)", 0xE4, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ANDB s,X", 0xE4, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ANDB s,Y", 0xE4, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ANDB s,U", 0xE4, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ANDB s,S", 0xE4, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ANDB x,X", 0xE4, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ANDB x,Y", 0xE4, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ANDB x,U", 0xE4, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ANDB x,S", 0xE4, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ANDB ?,X", 0xE4, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ANDB ?,Y", 0xE4, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ANDB ?,U", 0xE4, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ANDB ?,S", 0xE4, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ANDB x,PCR", 0xE4, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ANDB ?,PCR", 0xE4, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ANDB x", 0xD4, 4, 1, 0 },
  { "ANDB ?", 0xF4, 2, 0, 0 },

  { "ANDCC #x", 0x1C, 1, 0, 0 },

  { "ASLA", 0x48, 0, 0, 0 },
  { "ASLB", 0x58, 0, 0, 0 },
  { "ASL,X", 0x68, 9, 0, B_(10000100) },
  { "ASL,Y", 0x68, 9, 0, B_(10100100) },
  { "ASL,U", 0x68, 9, 0, B_(11000100) },
  { "ASL,S", 0x68, 9, 0, B_(11100100) },
  { "ASL A,X", 0x68, 9, 0, B_(10000110) },
  { "ASL A,Y", 0x68, 9, 0, B_(10100110) },
  { "ASL A,U", 0x68, 9, 0, B_(11000110) },
  { "ASL A,S", 0x68, 9, 0, B_(11100110) },
  { "ASL B,X", 0x68, 9, 0, B_(10000101) },
  { "ASL B,Y", 0x68, 9, 0, B_(10100101) },
  { "ASL B,U", 0x68, 9, 0, B_(11000101) },
  { "ASL B,S", 0x68, 9, 0, B_(11100101) },
  { "ASL D,X", 0x68, 9, 0, B_(10001011) },
  { "ASL D,Y", 0x68, 9, 0, B_(10101011) },
  { "ASL D,U", 0x68, 9, 0, B_(11001011) },
  { "ASL D,S", 0x68, 9, 0, B_(11101011) },
  { "ASL,X+", 0x68, 9, 0, B_(10000000) },
  { "ASL,Y+", 0x68, 9, 0, B_(10100000) },
  { "ASL,U+", 0x68, 9, 0, B_(11000000) },
  { "ASL,S+", 0x68, 9, 0, B_(11100000) },
  { "ASL,X++", 0x68, 9, 0, B_(10000001) },
  { "ASL,Y++", 0x68, 9, 0, B_(10100001) },
  { "ASL,U++", 0x68, 9, 0, B_(11000001) },
  { "ASL,S++", 0x68, 9, 0, B_(11100001) },
  { "ASL,-X", 0x68, 9, 0, B_(10000010) },
  { "ASL,-Y", 0x68, 9, 0, B_(10100010) },
  { "ASL,-U", 0x68, 9, 0, B_(11000010) },
  { "ASL,-S", 0x68, 9, 0, B_(11100010) },
  { "ASL,--X", 0x68, 9, 0, B_(10000011) },
  { "ASL,--Y", 0x68, 9, 0, B_(10100011) },
  { "ASL,--U", 0x68, 9, 0, B_(11000011) },
  { "ASL,--S", 0x68, 9, 0, B_(11100011) },
  { "ASL (,X)", 0x68, 9, 0, B_(10010100) },
  { "ASL (,Y)", 0x68, 9, 0, B_(10110100) },
  { "ASL (,U)", 0x68, 9, 0, B_(11010100) },
  { "ASL (,S)", 0x68, 9, 0, B_(11110100) },
  { "ASL (A,X)", 0x68, 9, 0, B_(10010110) },
  { "ASL (A,Y)", 0x68, 9, 0, B_(10110110) },
  { "ASL (A,U)", 0x68, 9, 0, B_(11010110) },
  { "ASL (A,S)", 0x68, 9, 0, B_(11110110) },
  { "ASL (B,X)", 0x68, 9, 0, B_(10010101) },
  { "ASL (B,Y)", 0x68, 9, 0, B_(10110101) },
  { "ASL (B,U)", 0x68, 9, 0, B_(11010101) },
  { "ASL (B,S)", 0x68, 9, 0, B_(11110101) },
  { "ASL (D,X)", 0x68, 9, 0, B_(10011011) },
  { "ASL (D,Y)", 0x68, 9, 0, B_(10111011) },
  { "ASL (D,U)", 0x68, 9, 0, B_(11011011) },
  { "ASL (D,S)", 0x68, 9, 0, B_(11111011) },
  { "ASL (,X++)", 0x68, 9, 0, B_(10010001) },
  { "ASL (,Y++)", 0x68, 9, 0, B_(10110001) },
  { "ASL (,U++)", 0x68, 9, 0, B_(11010001) },
  { "ASL (,S++)", 0x68, 9, 0, B_(11110001) },
  { "ASL (,--X)", 0x68, 9, 0, B_(10010011) },
  { "ASL (,--Y)", 0x68, 9, 0, B_(10110011) },
  { "ASL (,--U)", 0x68, 9, 0, B_(11010011) },
  { "ASL (,--S)", 0x68, 9, 0, B_(11110011) },
  { "ASL (x,X)", 0x68, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ASL (x,Y)", 0x68, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ASL (x,U)", 0x68, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ASL (x,S)", 0x68, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ASL (?,X)", 0x68, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ASL (?,Y)", 0x68, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ASL (?,U)", 0x68, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ASL (?,S)", 0x68, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ASL (x,PCR)", 0x68, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ASL (?,PCR)", 0x68, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ASL (?)", 0x68, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ASL s,X", 0x68, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ASL s,Y", 0x68, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ASL s,U", 0x68, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ASL s,S", 0x68, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ASL x,X", 0x68, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ASL x,Y", 0x68, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ASL x,U", 0x68, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ASL x,S", 0x68, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ASL ?,X", 0x68, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ASL ?,Y", 0x68, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ASL ?,U", 0x68, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ASL ?,S", 0x68, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ASL x,PCR", 0x68, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ASL ?,PCR", 0x68, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ASL x", 0x08, 4, 1, 0 },
  { "ASL ?", 0x78, 2, 0, 0 },

  { "ASRA", 0x47, 0, 0, 0 },
  { "ASRB", 0x57, 0, 0, 0 },
  { "ASR,X", 0x67, 9, 0, B_(10000100) },
  { "ASR,Y", 0x67, 9, 0, B_(10100100) },
  { "ASR,U", 0x67, 9, 0, B_(11000100) },
  { "ASR,S", 0x67, 9, 0, B_(11100100) },
  { "ASR A,X", 0x67, 9, 0, B_(10000110) },
  { "ASR A,Y", 0x67, 9, 0, B_(10100110) },
  { "ASR A,U", 0x67, 9, 0, B_(11000110) },
  { "ASR A,S", 0x67, 9, 0, B_(11100110) },
  { "ASR B,X", 0x67, 9, 0, B_(10000101) },
  { "ASR B,Y", 0x67, 9, 0, B_(10100101) },
  { "ASR B,U", 0x67, 9, 0, B_(11000101) },
  { "ASR B,S", 0x67, 9, 0, B_(11100101) },
  { "ASR D,X", 0x67, 9, 0, B_(10001011) },
  { "ASR D,Y", 0x67, 9, 0, B_(10101011) },
  { "ASR D,U", 0x67, 9, 0, B_(11001011) },
  { "ASR D,S", 0x67, 9, 0, B_(11101011) },
  { "ASR,X+", 0x67, 9, 0, B_(10000000) },
  { "ASR,Y+", 0x67, 9, 0, B_(10100000) },
  { "ASR,U+", 0x67, 9, 0, B_(11000000) },
  { "ASR,S+", 0x67, 9, 0, B_(11100000) },
  { "ASR,X++", 0x67, 9, 0, B_(10000001) },
  { "ASR,Y++", 0x67, 9, 0, B_(10100001) },
  { "ASR,U++", 0x67, 9, 0, B_(11000001) },
  { "ASR,S++", 0x67, 9, 0, B_(11100001) },
  { "ASR,-X", 0x67, 9, 0, B_(10000010) },
  { "ASR,-Y", 0x67, 9, 0, B_(10100010) },
  { "ASR,-U", 0x67, 9, 0, B_(11000010) },
  { "ASR,-S", 0x67, 9, 0, B_(11100010) },
  { "ASR,--X", 0x67, 9, 0, B_(10000011) },
  { "ASR,--Y", 0x67, 9, 0, B_(10100011) },
  { "ASR,--U", 0x67, 9, 0, B_(11000011) },
  { "ASR,--S", 0x67, 9, 0, B_(11100011) },
  { "ASR (,X)", 0x67, 9, 0, B_(10010100) },
  { "ASR (,Y)", 0x67, 9, 0, B_(10110100) },
  { "ASR (,U)", 0x67, 9, 0, B_(11010100) },
  { "ASR (,S)", 0x67, 9, 0, B_(11110100) },
  { "ASR (A,X)", 0x67, 9, 0, B_(10010110) },
  { "ASR (A,Y)", 0x67, 9, 0, B_(10110110) },
  { "ASR (A,U)", 0x67, 9, 0, B_(11010110) },
  { "ASR (A,S)", 0x67, 9, 0, B_(11110110) },
  { "ASR (B,X)", 0x67, 9, 0, B_(10010101) },
  { "ASR (B,Y)", 0x67, 9, 0, B_(10110101) },
  { "ASR (B,U)", 0x67, 9, 0, B_(11010101) },
  { "ASR (B,S)", 0x67, 9, 0, B_(11110101) },
  { "ASR (D,X)", 0x67, 9, 0, B_(10011011) },
  { "ASR (D,Y)", 0x67, 9, 0, B_(10111011) },
  { "ASR (D,U)", 0x67, 9, 0, B_(11011011) },
  { "ASR (D,S)", 0x67, 9, 0, B_(11111011) },
  { "ASR (,X++)", 0x67, 9, 0, B_(10010001) },
  { "ASR (,Y++)", 0x67, 9, 0, B_(10110001) },
  { "ASR (,U++)", 0x67, 9, 0, B_(11010001) },
  { "ASR (,S++)", 0x67, 9, 0, B_(11110001) },
  { "ASR (,--X)", 0x67, 9, 0, B_(10010011) },
  { "ASR (,--Y)", 0x67, 9, 0, B_(10110011) },
  { "ASR (,--U)", 0x67, 9, 0, B_(11010011) },
  { "ASR (,--S)", 0x67, 9, 0, B_(11110011) },
  { "ASR (x,X)", 0x67, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ASR (x,Y)", 0x67, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ASR (x,U)", 0x67, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ASR (x,S)", 0x67, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ASR (?,X)", 0x67, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ASR (?,Y)", 0x67, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ASR (?,U)", 0x67, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ASR (?,S)", 0x67, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ASR (x,PCR)", 0x67, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ASR (?,PCR)", 0x67, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ASR (?)", 0x67, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ASR s,X", 0x67, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ASR s,Y", 0x67, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ASR s,U", 0x67, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ASR s,S", 0x67, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ASR x,X", 0x67, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ASR x,Y", 0x67, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ASR x,U", 0x67, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ASR x,S", 0x67, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ASR ?,X", 0x67, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ASR ?,Y", 0x67, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ASR ?,U", 0x67, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ASR ?,S", 0x67, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ASR x,PCR", 0x67, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ASR ?,PCR", 0x67, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ASR x", 0x07, 4, 1, 0 },
  { "ASR ?", 0x77, 2, 0, 0 },

  { "BITA #x", 0x85, 1, 0, 0 },
  { "BITA,X", 0xA5, 9, 0, B_(10000100) },
  { "BITA,Y", 0xA5, 9, 0, B_(10100100) },
  { "BITA,U", 0xA5, 9, 0, B_(11000100) },
  { "BITA,S", 0xA5, 9, 0, B_(11100100) },
  { "BITA A,X", 0xA5, 9, 0, B_(10000110) },
  { "BITA A,Y", 0xA5, 9, 0, B_(10100110) },
  { "BITA A,U", 0xA5, 9, 0, B_(11000110) },
  { "BITA A,S", 0xA5, 9, 0, B_(11100110) },
  { "BITA B,X", 0xA5, 9, 0, B_(10000101) },
  { "BITA B,Y", 0xA5, 9, 0, B_(10100101) },
  { "BITA B,U", 0xA5, 9, 0, B_(11000101) },
  { "BITA B,S", 0xA5, 9, 0, B_(11100101) },
  { "BITA D,X", 0xA5, 9, 0, B_(10001011) },
  { "BITA D,Y", 0xA5, 9, 0, B_(10101011) },
  { "BITA D,U", 0xA5, 9, 0, B_(11001011) },
  { "BITA D,S", 0xA5, 9, 0, B_(11101011) },
  { "BITA,X+", 0xA5, 9, 0, B_(10000000) },
  { "BITA,Y+", 0xA5, 9, 0, B_(10100000) },
  { "BITA,U+", 0xA5, 9, 0, B_(11000000) },
  { "BITA,S+", 0xA5, 9, 0, B_(11100000) },
  { "BITA,X++", 0xA5, 9, 0, B_(10000001) },
  { "BITA,Y++", 0xA5, 9, 0, B_(10100001) },
  { "BITA,U++", 0xA5, 9, 0, B_(11000001) },
  { "BITA,S++", 0xA5, 9, 0, B_(11100001) },
  { "BITA,-X", 0xA5, 9, 0, B_(10000010) },
  { "BITA,-Y", 0xA5, 9, 0, B_(10100010) },
  { "BITA,-U", 0xA5, 9, 0, B_(11000010) },
  { "BITA,-S", 0xA5, 9, 0, B_(11100010) },
  { "BITA,--X", 0xA5, 9, 0, B_(10000011) },
  { "BITA,--Y", 0xA5, 9, 0, B_(10100011) },
  { "BITA,--U", 0xA5, 9, 0, B_(11000011) },
  { "BITA,--S", 0xA5, 9, 0, B_(11100011) },
  { "BITA (,X)", 0xA5, 9, 0, B_(10010100) },
  { "BITA (,Y)", 0xA5, 9, 0, B_(10110100) },
  { "BITA (,U)", 0xA5, 9, 0, B_(11010100) },
  { "BITA (,S)", 0xA5, 9, 0, B_(11110100) },
  { "BITA (A,X)", 0xA5, 9, 0, B_(10010110) },
  { "BITA (A,Y)", 0xA5, 9, 0, B_(10110110) },
  { "BITA (A,U)", 0xA5, 9, 0, B_(11010110) },
  { "BITA (A,S)", 0xA5, 9, 0, B_(11110110) },
  { "BITA (B,X)", 0xA5, 9, 0, B_(10010101) },
  { "BITA (B,Y)", 0xA5, 9, 0, B_(10110101) },
  { "BITA (B,U)", 0xA5, 9, 0, B_(11010101) },
  { "BITA (B,S)", 0xA5, 9, 0, B_(11110101) },
  { "BITA (D,X)", 0xA5, 9, 0, B_(10011011) },
  { "BITA (D,Y)", 0xA5, 9, 0, B_(10111011) },
  { "BITA (D,U)", 0xA5, 9, 0, B_(11011011) },
  { "BITA (D,S)", 0xA5, 9, 0, B_(11111011) },
  { "BITA (,X++)", 0xA5, 9, 0, B_(10010001) },
  { "BITA (,Y++)", 0xA5, 9, 0, B_(10110001) },
  { "BITA (,U++)", 0xA5, 9, 0, B_(11010001) },
  { "BITA (,S++)", 0xA5, 9, 0, B_(11110001) },
  { "BITA (,--X)", 0xA5, 9, 0, B_(10010011) },
  { "BITA (,--Y)", 0xA5, 9, 0, B_(10110011) },
  { "BITA (,--U)", 0xA5, 9, 0, B_(11010011) },
  { "BITA (,--S)", 0xA5, 9, 0, B_(11110011) },
  { "BITA (x,X)", 0xA5, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "BITA (x,Y)", 0xA5, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "BITA (x,U)", 0xA5, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "BITA (x,S)", 0xA5, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "BITA (?,X)", 0xA5, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "BITA (?,Y)", 0xA5, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "BITA (?,U)", 0xA5, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "BITA (?,S)", 0xA5, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "BITA (x,PCR)", 0xA5, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "BITA (?,PCR)", 0xA5, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "BITA (?)", 0xA5, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "BITA s,X", 0xA5, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "BITA s,Y", 0xA5, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "BITA s,U", 0xA5, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "BITA s,S", 0xA5, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "BITA x,X", 0xA5, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "BITA x,Y", 0xA5, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "BITA x,U", 0xA5, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "BITA x,S", 0xA5, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "BITA ?,X", 0xA5, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "BITA ?,Y", 0xA5, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "BITA ?,U", 0xA5, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "BITA ?,S", 0xA5, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "BITA x,PCR", 0xA5, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "BITA ?,PCR", 0xA5, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "BITA x", 0x95, 4, 1, 0 },
  { "BITA ?", 0xB5, 2, 0, 0 },

  { "BITB #x", 0xC5, 1, 0, 0 },
  { "BITB,X", 0xE5, 9, 0, B_(10000100) },
  { "BITB,Y", 0xE5, 9, 0, B_(10100100) },
  { "BITB,U", 0xE5, 9, 0, B_(11000100) },
  { "BITB,S", 0xE5, 9, 0, B_(11100100) },
  { "BITB A,X", 0xE5, 9, 0, B_(10000110) },
  { "BITB A,Y", 0xE5, 9, 0, B_(10100110) },
  { "BITB A,U", 0xE5, 9, 0, B_(11000110) },
  { "BITB A,S", 0xE5, 9, 0, B_(11100110) },
  { "BITB B,X", 0xE5, 9, 0, B_(10000101) },
  { "BITB B,Y", 0xE5, 9, 0, B_(10100101) },
  { "BITB B,U", 0xE5, 9, 0, B_(11000101) },
  { "BITB B,S", 0xE5, 9, 0, B_(11100101) },
  { "BITB D,X", 0xE5, 9, 0, B_(10001011) },
  { "BITB D,Y", 0xE5, 9, 0, B_(10101011) },
  { "BITB D,U", 0xE5, 9, 0, B_(11001011) },
  { "BITB D,S", 0xE5, 9, 0, B_(11101011) },
  { "BITB,X+", 0xE5, 9, 0, B_(10000000) },
  { "BITB,Y+", 0xE5, 9, 0, B_(10100000) },
  { "BITB,U+", 0xE5, 9, 0, B_(11000000) },
  { "BITB,S+", 0xE5, 9, 0, B_(11100000) },
  { "BITB,X++", 0xE5, 9, 0, B_(10000001) },
  { "BITB,Y++", 0xE5, 9, 0, B_(10100001) },
  { "BITB,U++", 0xE5, 9, 0, B_(11000001) },
  { "BITB,S++", 0xE5, 9, 0, B_(11100001) },
  { "BITB,-X", 0xE5, 9, 0, B_(10000010) },
  { "BITB,-Y", 0xE5, 9, 0, B_(10100010) },
  { "BITB,-U", 0xE5, 9, 0, B_(11000010) },
  { "BITB,-S", 0xE5, 9, 0, B_(11100010) },
  { "BITB,--X", 0xE5, 9, 0, B_(10000011) },
  { "BITB,--Y", 0xE5, 9, 0, B_(10100011) },
  { "BITB,--U", 0xE5, 9, 0, B_(11000011) },
  { "BITB,--S", 0xE5, 9, 0, B_(11100011) },
  { "BITB (,X)", 0xE5, 9, 0, B_(10010100) },
  { "BITB (,Y)", 0xE5, 9, 0, B_(10110100) },
  { "BITB (,U)", 0xE5, 9, 0, B_(11010100) },
  { "BITB (,S)", 0xE5, 9, 0, B_(11110100) },
  { "BITB (A,X)", 0xE5, 9, 0, B_(10010110) },
  { "BITB (A,Y)", 0xE5, 9, 0, B_(10110110) },
  { "BITB (A,U)", 0xE5, 9, 0, B_(11010110) },
  { "BITB (A,S)", 0xE5, 9, 0, B_(11110110) },
  { "BITB (B,X)", 0xE5, 9, 0, B_(10010101) },
  { "BITB (B,Y)", 0xE5, 9, 0, B_(10110101) },
  { "BITB (B,U)", 0xE5, 9, 0, B_(11010101) },
  { "BITB (B,S)", 0xE5, 9, 0, B_(11110101) },
  { "BITB (D,X)", 0xE5, 9, 0, B_(10011011) },
  { "BITB (D,Y)", 0xE5, 9, 0, B_(10111011) },
  { "BITB (D,U)", 0xE5, 9, 0, B_(11011011) },
  { "BITB (D,S)", 0xE5, 9, 0, B_(11111011) },
  { "BITB (,X++)", 0xE5, 9, 0, B_(10010001) },
  { "BITB (,Y++)", 0xE5, 9, 0, B_(10110001) },
  { "BITB (,U++)", 0xE5, 9, 0, B_(11010001) },
  { "BITB (,S++)", 0xE5, 9, 0, B_(11110001) },
  { "BITB (,--X)", 0xE5, 9, 0, B_(10010011) },
  { "BITB (,--Y)", 0xE5, 9, 0, B_(10110011) },
  { "BITB (,--U)", 0xE5, 9, 0, B_(11010011) },
  { "BITB (,--S)", 0xE5, 9, 0, B_(11110011) },
  { "BITB (x,X)", 0xE5, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "BITB (x,Y)", 0xE5, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "BITB (x,U)", 0xE5, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "BITB (x,S)", 0xE5, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "BITB (?,X)", 0xE5, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "BITB (?,Y)", 0xE5, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "BITB (?,U)", 0xE5, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "BITB (?,S)", 0xE5, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "BITB (x,PCR)", 0xE5, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "BITB (?,PCR)", 0xE5, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "BITB (?)", 0xE5, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "BITB s,X", 0xE5, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "BITB s,Y", 0xE5, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "BITB s,U", 0xE5, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "BITB s,S", 0xE5, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "BITB x,X", 0xE5, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "BITB x,Y", 0xE5, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "BITB x,U", 0xE5, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "BITB x,S", 0xE5, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "BITB ?,X", 0xE5, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "BITB ?,Y", 0xE5, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "BITB ?,U", 0xE5, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "BITB ?,S", 0xE5, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "BITB x,PCR", 0xE5, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "BITB ?,PCR", 0xE5, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "BITB x", 0xD5, 4, 1, 0 },
  { "BITB ?", 0xF5, 2, 0, 0 },

  { "BCC x", 0x24, 5, 0, 0 },
  { "BCS x", 0x25, 5, 0, 0 },
  { "BEQ x", 0x27, 5, 0, 0 },
  { "BGE x", 0x2C, 5, 0, 0 },
  { "BGT x", 0x2E, 5, 0, 0 },
  { "BHI x", 0x22, 5, 0, 0 },
  { "BHS x", 0x24, 5, 0, 0 },
  { "BLE x", 0x2F, 5, 0, 0 },
  { "BLO x", 0x25, 5, 0, 0 },
  { "BLS x", 0x23, 5, 0, 0 },
  { "BLT x", 0x2D, 5, 0, 0 },
  { "BMI x", 0x2B, 5, 0, 0 },
  { "BNE x", 0x26, 5, 0, 0 },
  { "BPL x", 0x2A, 5, 0, 0 },
  { "BRA x", 0x20, 5, 0, 0 },
  { "BRN x", 0x21, 5, 0, 0 },
  { "BSR x", 0x8D, 5, 0, 0 },
  { "BVC x", 0x28, 5, 0, 0 },
  { "BVS x", 0x29, 5, 0, 0 },

  { "CLRA", 0x4F, 0, 0, 0 },
  { "CLRB", 0x5F, 0, 0, 0 },
  { "CLR,X", 0x6F, 9, 0, B_(10000100) },
  { "CLR,Y", 0x6F, 9, 0, B_(10100100) },
  { "CLR,U", 0x6F, 9, 0, B_(11000100) },
  { "CLR,S", 0x6F, 9, 0, B_(11100100) },
  { "CLR A,X", 0x6F, 9, 0, B_(10000110) },
  { "CLR A,Y", 0x6F, 9, 0, B_(10100110) },
  { "CLR A,U", 0x6F, 9, 0, B_(11000110) },
  { "CLR A,S", 0x6F, 9, 0, B_(11100110) },
  { "CLR B,X", 0x6F, 9, 0, B_(10000101) },
  { "CLR B,Y", 0x6F, 9, 0, B_(10100101) },
  { "CLR B,U", 0x6F, 9, 0, B_(11000101) },
  { "CLR B,S", 0x6F, 9, 0, B_(11100101) },
  { "CLR D,X", 0x6F, 9, 0, B_(10001011) },
  { "CLR D,Y", 0x6F, 9, 0, B_(10101011) },
  { "CLR D,U", 0x6F, 9, 0, B_(11001011) },
  { "CLR D,S", 0x6F, 9, 0, B_(11101011) },
  { "CLR,X+", 0x6F, 9, 0, B_(10000000) },
  { "CLR,Y+", 0x6F, 9, 0, B_(10100000) },
  { "CLR,U+", 0x6F, 9, 0, B_(11000000) },
  { "CLR,S+", 0x6F, 9, 0, B_(11100000) },
  { "CLR,X++", 0x6F, 9, 0, B_(10000001) },
  { "CLR,Y++", 0x6F, 9, 0, B_(10100001) },
  { "CLR,U++", 0x6F, 9, 0, B_(11000001) },
  { "CLR,S++", 0x6F, 9, 0, B_(11100001) },
  { "CLR,-X", 0x6F, 9, 0, B_(10000010) },
  { "CLR,-Y", 0x6F, 9, 0, B_(10100010) },
  { "CLR,-U", 0x6F, 9, 0, B_(11000010) },
  { "CLR,-S", 0x6F, 9, 0, B_(11100010) },
  { "CLR,--X", 0x6F, 9, 0, B_(10000011) },
  { "CLR,--Y", 0x6F, 9, 0, B_(10100011) },
  { "CLR,--U", 0x6F, 9, 0, B_(11000011) },
  { "CLR,--S", 0x6F, 9, 0, B_(11100011) },
  { "CLR (,X)", 0x6F, 9, 0, B_(10010100) },
  { "CLR (,Y)", 0x6F, 9, 0, B_(10110100) },
  { "CLR (,U)", 0x6F, 9, 0, B_(11010100) },
  { "CLR (,S)", 0x6F, 9, 0, B_(11110100) },
  { "CLR (A,X)", 0x6F, 9, 0, B_(10010110) },
  { "CLR (A,Y)", 0x6F, 9, 0, B_(10110110) },
  { "CLR (A,U)", 0x6F, 9, 0, B_(11010110) },
  { "CLR (A,S)", 0x6F, 9, 0, B_(11110110) },
  { "CLR (B,X)", 0x6F, 9, 0, B_(10010101) },
  { "CLR (B,Y)", 0x6F, 9, 0, B_(10110101) },
  { "CLR (B,U)", 0x6F, 9, 0, B_(11010101) },
  { "CLR (B,S)", 0x6F, 9, 0, B_(11110101) },
  { "CLR (D,X)", 0x6F, 9, 0, B_(10011011) },
  { "CLR (D,Y)", 0x6F, 9, 0, B_(10111011) },
  { "CLR (D,U)", 0x6F, 9, 0, B_(11011011) },
  { "CLR (D,S)", 0x6F, 9, 0, B_(11111011) },
  { "CLR (,X++)", 0x6F, 9, 0, B_(10010001) },
  { "CLR (,Y++)", 0x6F, 9, 0, B_(10110001) },
  { "CLR (,U++)", 0x6F, 9, 0, B_(11010001) },
  { "CLR (,S++)", 0x6F, 9, 0, B_(11110001) },
  { "CLR (,--X)", 0x6F, 9, 0, B_(10010011) },
  { "CLR (,--Y)", 0x6F, 9, 0, B_(10110011) },
  { "CLR (,--U)", 0x6F, 9, 0, B_(11010011) },
  { "CLR (,--S)", 0x6F, 9, 0, B_(11110011) },
  { "CLR (x,X)", 0x6F, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "CLR (x,Y)", 0x6F, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "CLR (x,U)", 0x6F, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "CLR (x,S)", 0x6F, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "CLR (?,X)", 0x6F, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "CLR (?,Y)", 0x6F, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "CLR (?,U)", 0x6F, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "CLR (?,S)", 0x6F, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "CLR (x,PCR)", 0x6F, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "CLR (?,PCR)", 0x6F, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "CLR (?)", 0x6F, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "CLR s,X", 0x6F, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "CLR s,Y", 0x6F, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "CLR s,U", 0x6F, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "CLR s,S", 0x6F, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "CLR x,X", 0x6F, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "CLR x,Y", 0x6F, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "CLR x,U", 0x6F, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "CLR x,S", 0x6F, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "CLR ?,X", 0x6F, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "CLR ?,Y", 0x6F, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "CLR ?,U", 0x6F, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "CLR ?,S", 0x6F, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "CLR x,PCR", 0x6F, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "CLR ?,PCR", 0x6F, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "CLR x", 0x0F, 4, 1, 0 },
  { "CLR ?", 0x7F, 2, 0, 0 },

  { "CMPA #x", 0x81, 1, 0, 0 },
  { "CMPA,X", 0xA1, 9, 0, B_(10000100) },
  { "CMPA,Y", 0xA1, 9, 0, B_(10100100) },
  { "CMPA,U", 0xA1, 9, 0, B_(11000100) },
  { "CMPA,S", 0xA1, 9, 0, B_(11100100) },
  { "CMPA A,X", 0xA1, 9, 0, B_(10000110) },
  { "CMPA A,Y", 0xA1, 9, 0, B_(10100110) },
  { "CMPA A,U", 0xA1, 9, 0, B_(11000110) },
  { "CMPA A,S", 0xA1, 9, 0, B_(11100110) },
  { "CMPA B,X", 0xA1, 9, 0, B_(10000101) },
  { "CMPA B,Y", 0xA1, 9, 0, B_(10100101) },
  { "CMPA B,U", 0xA1, 9, 0, B_(11000101) },
  { "CMPA B,S", 0xA1, 9, 0, B_(11100101) },
  { "CMPA D,X", 0xA1, 9, 0, B_(10001011) },
  { "CMPA D,Y", 0xA1, 9, 0, B_(10101011) },
  { "CMPA D,U", 0xA1, 9, 0, B_(11001011) },
  { "CMPA D,S", 0xA1, 9, 0, B_(11101011) },
  { "CMPA,X+", 0xA1, 9, 0, B_(10000000) },
  { "CMPA,Y+", 0xA1, 9, 0, B_(10100000) },
  { "CMPA,U+", 0xA1, 9, 0, B_(11000000) },
  { "CMPA,S+", 0xA1, 9, 0, B_(11100000) },
  { "CMPA,X++", 0xA1, 9, 0, B_(10000001) },
  { "CMPA,Y++", 0xA1, 9, 0, B_(10100001) },
  { "CMPA,U++", 0xA1, 9, 0, B_(11000001) },
  { "CMPA,S++", 0xA1, 9, 0, B_(11100001) },
  { "CMPA,-X", 0xA1, 9, 0, B_(10000010) },
  { "CMPA,-Y", 0xA1, 9, 0, B_(10100010) },
  { "CMPA,-U", 0xA1, 9, 0, B_(11000010) },
  { "CMPA,-S", 0xA1, 9, 0, B_(11100010) },
  { "CMPA,--X", 0xA1, 9, 0, B_(10000011) },
  { "CMPA,--Y", 0xA1, 9, 0, B_(10100011) },
  { "CMPA,--U", 0xA1, 9, 0, B_(11000011) },
  { "CMPA,--S", 0xA1, 9, 0, B_(11100011) },
  { "CMPA (,X)", 0xA1, 9, 0, B_(10010100) },
  { "CMPA (,Y)", 0xA1, 9, 0, B_(10110100) },
  { "CMPA (,U)", 0xA1, 9, 0, B_(11010100) },
  { "CMPA (,S)", 0xA1, 9, 0, B_(11110100) },
  { "CMPA (A,X)", 0xA1, 9, 0, B_(10010110) },
  { "CMPA (A,Y)", 0xA1, 9, 0, B_(10110110) },
  { "CMPA (A,U)", 0xA1, 9, 0, B_(11010110) },
  { "CMPA (A,S)", 0xA1, 9, 0, B_(11110110) },
  { "CMPA (B,X)", 0xA1, 9, 0, B_(10010101) },
  { "CMPA (B,Y)", 0xA1, 9, 0, B_(10110101) },
  { "CMPA (B,U)", 0xA1, 9, 0, B_(11010101) },
  { "CMPA (B,S)", 0xA1, 9, 0, B_(11110101) },
  { "CMPA (D,X)", 0xA1, 9, 0, B_(10011011) },
  { "CMPA (D,Y)", 0xA1, 9, 0, B_(10111011) },
  { "CMPA (D,U)", 0xA1, 9, 0, B_(11011011) },
  { "CMPA (D,S)", 0xA1, 9, 0, B_(11111011) },
  { "CMPA (,X++)", 0xA1, 9, 0, B_(10010001) },
  { "CMPA (,Y++)", 0xA1, 9, 0, B_(10110001) },
  { "CMPA (,U++)", 0xA1, 9, 0, B_(11010001) },
  { "CMPA (,S++)", 0xA1, 9, 0, B_(11110001) },
  { "CMPA (,--X)", 0xA1, 9, 0, B_(10010011) },
  { "CMPA (,--Y)", 0xA1, 9, 0, B_(10110011) },
  { "CMPA (,--U)", 0xA1, 9, 0, B_(11010011) },
  { "CMPA (,--S)", 0xA1, 9, 0, B_(11110011) },
  { "CMPA (x,X)", 0xA1, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "CMPA (x,Y)", 0xA1, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "CMPA (x,U)", 0xA1, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "CMPA (x,S)", 0xA1, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "CMPA (?,X)", 0xA1, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "CMPA (?,Y)", 0xA1, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "CMPA (?,U)", 0xA1, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "CMPA (?,S)", 0xA1, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "CMPA (x,PCR)", 0xA1, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "CMPA (?,PCR)", 0xA1, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "CMPA (?)", 0xA1, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "CMPA s,X", 0xA1, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "CMPA s,Y", 0xA1, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "CMPA s,U", 0xA1, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "CMPA s,S", 0xA1, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "CMPA x,X", 0xA1, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "CMPA x,Y", 0xA1, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "CMPA x,U", 0xA1, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "CMPA x,S", 0xA1, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "CMPA ?,X", 0xA1, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "CMPA ?,Y", 0xA1, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "CMPA ?,U", 0xA1, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "CMPA ?,S", 0xA1, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "CMPA x,PCR", 0xA1, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "CMPA ?,PCR", 0xA1, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "CMPA x", 0x91, 4, 1, 0 },
  { "CMPA ?", 0xB1, 2, 0, 0 },

  { "CMPB #x", 0xC1, 1, 0, 0 },
  { "CMPB,X", 0xE1, 9, 0, B_(10000100) },
  { "CMPB,Y", 0xE1, 9, 0, B_(10100100) },
  { "CMPB,U", 0xE1, 9, 0, B_(11000100) },
  { "CMPB,S", 0xE1, 9, 0, B_(11100100) },
  { "CMPB A,X", 0xE1, 9, 0, B_(10000110) },
  { "CMPB A,Y", 0xE1, 9, 0, B_(10100110) },
  { "CMPB A,U", 0xE1, 9, 0, B_(11000110) },
  { "CMPB A,S", 0xE1, 9, 0, B_(11100110) },
  { "CMPB B,X", 0xE1, 9, 0, B_(10000101) },
  { "CMPB B,Y", 0xE1, 9, 0, B_(10100101) },
  { "CMPB B,U", 0xE1, 9, 0, B_(11000101) },
  { "CMPB B,S", 0xE1, 9, 0, B_(11100101) },
  { "CMPB D,X", 0xE1, 9, 0, B_(10001011) },
  { "CMPB D,Y", 0xE1, 9, 0, B_(10101011) },
  { "CMPB D,U", 0xE1, 9, 0, B_(11001011) },
  { "CMPB D,S", 0xE1, 9, 0, B_(11101011) },
  { "CMPB,X+", 0xE1, 9, 0, B_(10000000) },
  { "CMPB,Y+", 0xE1, 9, 0, B_(10100000) },
  { "CMPB,U+", 0xE1, 9, 0, B_(11000000) },
  { "CMPB,S+", 0xE1, 9, 0, B_(11100000) },
  { "CMPB,X++", 0xE1, 9, 0, B_(10000001) },
  { "CMPB,Y++", 0xE1, 9, 0, B_(10100001) },
  { "CMPB,U++", 0xE1, 9, 0, B_(11000001) },
  { "CMPB,S++", 0xE1, 9, 0, B_(11100001) },
  { "CMPB,-X", 0xE1, 9, 0, B_(10000010) },
  { "CMPB,-Y", 0xE1, 9, 0, B_(10100010) },
  { "CMPB,-U", 0xE1, 9, 0, B_(11000010) },
  { "CMPB,-S", 0xE1, 9, 0, B_(11100010) },
  { "CMPB,--X", 0xE1, 9, 0, B_(10000011) },
  { "CMPB,--Y", 0xE1, 9, 0, B_(10100011) },
  { "CMPB,--U", 0xE1, 9, 0, B_(11000011) },
  { "CMPB,--S", 0xE1, 9, 0, B_(11100011) },
  { "CMPB (,X)", 0xE1, 9, 0, B_(10010100) },
  { "CMPB (,Y)", 0xE1, 9, 0, B_(10110100) },
  { "CMPB (,U)", 0xE1, 9, 0, B_(11010100) },
  { "CMPB (,S)", 0xE1, 9, 0, B_(11110100) },
  { "CMPB (A,X)", 0xE1, 9, 0, B_(10010110) },
  { "CMPB (A,Y)", 0xE1, 9, 0, B_(10110110) },
  { "CMPB (A,U)", 0xE1, 9, 0, B_(11010110) },
  { "CMPB (A,S)", 0xE1, 9, 0, B_(11110110) },
  { "CMPB (B,X)", 0xE1, 9, 0, B_(10010101) },
  { "CMPB (B,Y)", 0xE1, 9, 0, B_(10110101) },
  { "CMPB (B,U)", 0xE1, 9, 0, B_(11010101) },
  { "CMPB (B,S)", 0xE1, 9, 0, B_(11110101) },
  { "CMPB (D,X)", 0xE1, 9, 0, B_(10011011) },
  { "CMPB (D,Y)", 0xE1, 9, 0, B_(10111011) },
  { "CMPB (D,U)", 0xE1, 9, 0, B_(11011011) },
  { "CMPB (D,S)", 0xE1, 9, 0, B_(11111011) },
  { "CMPB (,X++)", 0xE1, 9, 0, B_(10010001) },
  { "CMPB (,Y++)", 0xE1, 9, 0, B_(10110001) },
  { "CMPB (,U++)", 0xE1, 9, 0, B_(11010001) },
  { "CMPB (,S++)", 0xE1, 9, 0, B_(11110001) },
  { "CMPB (,--X)", 0xE1, 9, 0, B_(10010011) },
  { "CMPB (,--Y)", 0xE1, 9, 0, B_(10110011) },
  { "CMPB (,--U)", 0xE1, 9, 0, B_(11010011) },
  { "CMPB (,--S)", 0xE1, 9, 0, B_(11110011) },
  { "CMPB (x,X)", 0xE1, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "CMPB (x,Y)", 0xE1, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "CMPB (x,U)", 0xE1, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "CMPB (x,S)", 0xE1, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "CMPB (?,X)", 0xE1, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "CMPB (?,Y)", 0xE1, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "CMPB (?,U)", 0xE1, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "CMPB (?,S)", 0xE1, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "CMPB (x,PCR)", 0xE1, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "CMPB (?,PCR)", 0xE1, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "CMPB (?)", 0xE1, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "CMPB s,X", 0xE1, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "CMPB s,Y", 0xE1, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "CMPB s,U", 0xE1, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "CMPB s,S", 0xE1, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "CMPB x,X", 0xE1, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "CMPB x,Y", 0xE1, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "CMPB x,U", 0xE1, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "CMPB x,S", 0xE1, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "CMPB ?,X", 0xE1, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "CMPB ?,Y", 0xE1, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "CMPB ?,U", 0xE1, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "CMPB ?,S", 0xE1, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "CMPB x,PCR", 0xE1, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "CMPB ?,PCR", 0xE1, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "CMPB x", 0xD1, 4, 1, 0 },
  { "CMPB ?", 0xF1, 2, 0, 0 },

  { "CMPX #x", 0x8C, 1, 0, 0 },
  { "CMPX,X", 0xAC, 9, 0, B_(10000100) },
  { "CMPX,Y", 0xAC, 9, 0, B_(10100100) },
  { "CMPX,U", 0xAC, 9, 0, B_(11000100) },
  { "CMPX,S", 0xAC, 9, 0, B_(11100100) },
  { "CMPX A,X", 0xAC, 9, 0, B_(10000110) },
  { "CMPX A,Y", 0xAC, 9, 0, B_(10100110) },
  { "CMPX A,U", 0xAC, 9, 0, B_(11000110) },
  { "CMPX A,S", 0xAC, 9, 0, B_(11100110) },
  { "CMPX B,X", 0xAC, 9, 0, B_(10000101) },
  { "CMPX B,Y", 0xAC, 9, 0, B_(10100101) },
  { "CMPX B,U", 0xAC, 9, 0, B_(11000101) },
  { "CMPX B,S", 0xAC, 9, 0, B_(11100101) },
  { "CMPX D,X", 0xAC, 9, 0, B_(10001011) },
  { "CMPX D,Y", 0xAC, 9, 0, B_(10101011) },
  { "CMPX D,U", 0xAC, 9, 0, B_(11001011) },
  { "CMPX D,S", 0xAC, 9, 0, B_(11101011) },
  { "CMPX,X+", 0xAC, 9, 0, B_(10000000) },
  { "CMPX,Y+", 0xAC, 9, 0, B_(10100000) },
  { "CMPX,U+", 0xAC, 9, 0, B_(11000000) },
  { "CMPX,S+", 0xAC, 9, 0, B_(11100000) },
  { "CMPX,X++", 0xAC, 9, 0, B_(10000001) },
  { "CMPX,Y++", 0xAC, 9, 0, B_(10100001) },
  { "CMPX,U++", 0xAC, 9, 0, B_(11000001) },
  { "CMPX,S++", 0xAC, 9, 0, B_(11100001) },
  { "CMPX,-X", 0xAC, 9, 0, B_(10000010) },
  { "CMPX,-Y", 0xAC, 9, 0, B_(10100010) },
  { "CMPX,-U", 0xAC, 9, 0, B_(11000010) },
  { "CMPX,-S", 0xAC, 9, 0, B_(11100010) },
  { "CMPX,--X", 0xAC, 9, 0, B_(10000011) },
  { "CMPX,--Y", 0xAC, 9, 0, B_(10100011) },
  { "CMPX,--U", 0xAC, 9, 0, B_(11000011) },
  { "CMPX,--S", 0xAC, 9, 0, B_(11100011) },
  { "CMPX (,X)", 0xAC, 9, 0, B_(10010100) },
  { "CMPX (,Y)", 0xAC, 9, 0, B_(10110100) },
  { "CMPX (,U)", 0xAC, 9, 0, B_(11010100) },
  { "CMPX (,S)", 0xAC, 9, 0, B_(11110100) },
  { "CMPX (A,X)", 0xAC, 9, 0, B_(10010110) },
  { "CMPX (A,Y)", 0xAC, 9, 0, B_(10110110) },
  { "CMPX (A,U)", 0xAC, 9, 0, B_(11010110) },
  { "CMPX (A,S)", 0xAC, 9, 0, B_(11110110) },
  { "CMPX (B,X)", 0xAC, 9, 0, B_(10010101) },
  { "CMPX (B,Y)", 0xAC, 9, 0, B_(10110101) },
  { "CMPX (B,U)", 0xAC, 9, 0, B_(11010101) },
  { "CMPX (B,S)", 0xAC, 9, 0, B_(11110101) },
  { "CMPX (D,X)", 0xAC, 9, 0, B_(10011011) },
  { "CMPX (D,Y)", 0xAC, 9, 0, B_(10111011) },
  { "CMPX (D,U)", 0xAC, 9, 0, B_(11011011) },
  { "CMPX (D,S)", 0xAC, 9, 0, B_(11111011) },
  { "CMPX (,X++)", 0xAC, 9, 0, B_(10010001) },
  { "CMPX (,Y++)", 0xAC, 9, 0, B_(10110001) },
  { "CMPX (,U++)", 0xAC, 9, 0, B_(11010001) },
  { "CMPX (,S++)", 0xAC, 9, 0, B_(11110001) },
  { "CMPX (,--X)", 0xAC, 9, 0, B_(10010011) },
  { "CMPX (,--Y)", 0xAC, 9, 0, B_(10110011) },
  { "CMPX (,--U)", 0xAC, 9, 0, B_(11010011) },
  { "CMPX (,--S)", 0xAC, 9, 0, B_(11110011) },
  { "CMPX (x,X)", 0xAC, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "CMPX (x,Y)", 0xAC, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "CMPX (x,U)", 0xAC, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "CMPX (x,S)", 0xAC, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "CMPX (?,X)", 0xAC, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "CMPX (?,Y)", 0xAC, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "CMPX (?,U)", 0xAC, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "CMPX (?,S)", 0xAC, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "CMPX (x,PCR)", 0xAC, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "CMPX (?,PCR)", 0xAC, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "CMPX (?)", 0xAC, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "CMPX s,X", 0xAC, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "CMPX s,Y", 0xAC, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "CMPX s,U", 0xAC, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "CMPX s,S", 0xAC, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "CMPX x,X", 0xAC, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "CMPX x,Y", 0xAC, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "CMPX x,U", 0xAC, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "CMPX x,S", 0xAC, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "CMPX ?,X", 0xAC, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "CMPX ?,Y", 0xAC, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "CMPX ?,U", 0xAC, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "CMPX ?,S", 0xAC, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "CMPX x,PCR", 0xAC, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "CMPX ?,PCR", 0xAC, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "CMPX x", 0x9C, 4, 1, 0 },
  { "CMPX ?", 0xBC, 2, 0, 0 },

  { "CMPD #x", 0x1083, 1, 0, 0 },
  { "CMPD,X", 0x10A3, 9, 0, B_(10000100) },
  { "CMPD,Y", 0x10A3, 9, 0, B_(10100100) },
  { "CMPD,U", 0x10A3, 9, 0, B_(11000100) },
  { "CMPD,S", 0x10A3, 9, 0, B_(11100100) },
  { "CMPD A,X", 0x10A3, 9, 0, B_(10000110) },
  { "CMPD A,Y", 0x10A3, 9, 0, B_(10100110) },
  { "CMPD A,U", 0x10A3, 9, 0, B_(11000110) },
  { "CMPD A,S", 0x10A3, 9, 0, B_(11100110) },
  { "CMPD B,X", 0x10A3, 9, 0, B_(10000101) },
  { "CMPD B,Y", 0x10A3, 9, 0, B_(10100101) },
  { "CMPD B,U", 0x10A3, 9, 0, B_(11000101) },
  { "CMPD B,S", 0x10A3, 9, 0, B_(11100101) },
  { "CMPD D,X", 0x10A3, 9, 0, B_(10001011) },
  { "CMPD D,Y", 0x10A3, 9, 0, B_(10101011) },
  { "CMPD D,U", 0x10A3, 9, 0, B_(11001011) },
  { "CMPD D,S", 0x10A3, 9, 0, B_(11101011) },
  { "CMPD,X+", 0x10A3, 9, 0, B_(10000000) },
  { "CMPD,Y+", 0x10A3, 9, 0, B_(10100000) },
  { "CMPD,U+", 0x10A3, 9, 0, B_(11000000) },
  { "CMPD,S+", 0x10A3, 9, 0, B_(11100000) },
  { "CMPD,X++", 0x10A3, 9, 0, B_(10000001) },
  { "CMPD,Y++", 0x10A3, 9, 0, B_(10100001) },
  { "CMPD,U++", 0x10A3, 9, 0, B_(11000001) },
  { "CMPD,S++", 0x10A3, 9, 0, B_(11100001) },
  { "CMPD,-X", 0x10A3, 9, 0, B_(10000010) },
  { "CMPD,-Y", 0x10A3, 9, 0, B_(10100010) },
  { "CMPD,-U", 0x10A3, 9, 0, B_(11000010) },
  { "CMPD,-S", 0x10A3, 9, 0, B_(11100010) },
  { "CMPD,--X", 0x10A3, 9, 0, B_(10000011) },
  { "CMPD,--Y", 0x10A3, 9, 0, B_(10100011) },
  { "CMPD,--U", 0x10A3, 9, 0, B_(11000011) },
  { "CMPD,--S", 0x10A3, 9, 0, B_(11100011) },
  { "CMPD (,X)", 0x10A3, 9, 0, B_(10010100) },
  { "CMPD (,Y)", 0x10A3, 9, 0, B_(10110100) },
  { "CMPD (,U)", 0x10A3, 9, 0, B_(11010100) },
  { "CMPD (,S)", 0x10A3, 9, 0, B_(11110100) },
  { "CMPD (A,X)", 0x10A3, 9, 0, B_(10010110) },
  { "CMPD (A,Y)", 0x10A3, 9, 0, B_(10110110) },
  { "CMPD (A,U)", 0x10A3, 9, 0, B_(11010110) },
  { "CMPD (A,S)", 0x10A3, 9, 0, B_(11110110) },
  { "CMPD (B,X)", 0x10A3, 9, 0, B_(10010101) },
  { "CMPD (B,Y)", 0x10A3, 9, 0, B_(10110101) },
  { "CMPD (B,U)", 0x10A3, 9, 0, B_(11010101) },
  { "CMPD (B,S)", 0x10A3, 9, 0, B_(11110101) },
  { "CMPD (D,X)", 0x10A3, 9, 0, B_(10011011) },
  { "CMPD (D,Y)", 0x10A3, 9, 0, B_(10111011) },
  { "CMPD (D,U)", 0x10A3, 9, 0, B_(11011011) },
  { "CMPD (D,S)", 0x10A3, 9, 0, B_(11111011) },
  { "CMPD (,X++)", 0x10A3, 9, 0, B_(10010001) },
  { "CMPD (,Y++)", 0x10A3, 9, 0, B_(10110001) },
  { "CMPD (,U++)", 0x10A3, 9, 0, B_(11010001) },
  { "CMPD (,S++)", 0x10A3, 9, 0, B_(11110001) },
  { "CMPD (,--X)", 0x10A3, 9, 0, B_(10010011) },
  { "CMPD (,--Y)", 0x10A3, 9, 0, B_(10110011) },
  { "CMPD (,--U)", 0x10A3, 9, 0, B_(11010011) },
  { "CMPD (,--S)", 0x10A3, 9, 0, B_(11110011) },
  { "CMPD (x,X)", 0x10A3, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "CMPD (x,Y)", 0x10A3, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "CMPD (x,U)", 0x10A3, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "CMPD (x,S)", 0x10A3, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "CMPD (?,X)", 0x10A3, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "CMPD (?,Y)", 0x10A3, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "CMPD (?,U)", 0x10A3, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "CMPD (?,S)", 0x10A3, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "CMPD (x,PCR)", 0x10A3, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "CMPD (?,PCR)", 0x10A3, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "CMPD (?)", 0x10A3, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "CMPD s,X", 0x10A3, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "CMPD s,Y", 0x10A3, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "CMPD s,U", 0x10A3, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "CMPD s,S", 0x10A3, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "CMPD x,X", 0x10A3, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "CMPD x,Y", 0x10A3, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "CMPD x,U", 0x10A3, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "CMPD x,S", 0x10A3, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "CMPD ?,X", 0x10A3, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "CMPD ?,Y", 0x10A3, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "CMPD ?,U", 0x10A3, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "CMPD ?,S", 0x10A3, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "CMPD x,PCR", 0x10A3, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "CMPD ?,PCR", 0x10A3, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "CMPD x", 0x1093, 4, 1, 0 },
  { "CMPD ?", 0x10B3, 2, 0, 0 },

  { "CMPS #x", 0x118C, 1, 0, 0 },
  { "CMPS,X", 0x11AC, 9, 0, B_(10000100) },
  { "CMPS,Y", 0x11AC, 9, 0, B_(10100100) },
  { "CMPS,U", 0x11AC, 9, 0, B_(11000100) },
  { "CMPS,S", 0x11AC, 9, 0, B_(11100100) },
  { "CMPS A,X", 0x11AC, 9, 0, B_(10000110) },
  { "CMPS A,Y", 0x11AC, 9, 0, B_(10100110) },
  { "CMPS A,U", 0x11AC, 9, 0, B_(11000110) },
  { "CMPS A,S", 0x11AC, 9, 0, B_(11100110) },
  { "CMPS B,X", 0x11AC, 9, 0, B_(10000101) },
  { "CMPS B,Y", 0x11AC, 9, 0, B_(10100101) },
  { "CMPS B,U", 0x11AC, 9, 0, B_(11000101) },
  { "CMPS B,S", 0x11AC, 9, 0, B_(11100101) },
  { "CMPS D,X", 0x11AC, 9, 0, B_(10001011) },
  { "CMPS D,Y", 0x11AC, 9, 0, B_(10101011) },
  { "CMPS D,U", 0x11AC, 9, 0, B_(11001011) },
  { "CMPS D,S", 0x11AC, 9, 0, B_(11101011) },
  { "CMPS,X+", 0x11AC, 9, 0, B_(10000000) },
  { "CMPS,Y+", 0x11AC, 9, 0, B_(10100000) },
  { "CMPS,U+", 0x11AC, 9, 0, B_(11000000) },
  { "CMPS,S+", 0x11AC, 9, 0, B_(11100000) },
  { "CMPS,X++", 0x11AC, 9, 0, B_(10000001) },
  { "CMPS,Y++", 0x11AC, 9, 0, B_(10100001) },
  { "CMPS,U++", 0x11AC, 9, 0, B_(11000001) },
  { "CMPS,S++", 0x11AC, 9, 0, B_(11100001) },
  { "CMPS,-X", 0x11AC, 9, 0, B_(10000010) },
  { "CMPS,-Y", 0x11AC, 9, 0, B_(10100010) },
  { "CMPS,-U", 0x11AC, 9, 0, B_(11000010) },
  { "CMPS,-S", 0x11AC, 9, 0, B_(11100010) },
  { "CMPS,--X", 0x11AC, 9, 0, B_(10000011) },
  { "CMPS,--Y", 0x11AC, 9, 0, B_(10100011) },
  { "CMPS,--U", 0x11AC, 9, 0, B_(11000011) },
  { "CMPS,--S", 0x11AC, 9, 0, B_(11100011) },
  { "CMPS (,X)", 0x11AC, 9, 0, B_(10010100) },
  { "CMPS (,Y)", 0x11AC, 9, 0, B_(10110100) },
  { "CMPS (,U)", 0x11AC, 9, 0, B_(11010100) },
  { "CMPS (,S)", 0x11AC, 9, 0, B_(11110100) },
  { "CMPS (A,X)", 0x11AC, 9, 0, B_(10010110) },
  { "CMPS (A,Y)", 0x11AC, 9, 0, B_(10110110) },
  { "CMPS (A,U)", 0x11AC, 9, 0, B_(11010110) },
  { "CMPS (A,S)", 0x11AC, 9, 0, B_(11110110) },
  { "CMPS (B,X)", 0x11AC, 9, 0, B_(10010101) },
  { "CMPS (B,Y)", 0x11AC, 9, 0, B_(10110101) },
  { "CMPS (B,U)", 0x11AC, 9, 0, B_(11010101) },
  { "CMPS (B,S)", 0x11AC, 9, 0, B_(11110101) },
  { "CMPS (D,X)", 0x11AC, 9, 0, B_(10011011) },
  { "CMPS (D,Y)", 0x11AC, 9, 0, B_(10111011) },
  { "CMPS (D,U)", 0x11AC, 9, 0, B_(11011011) },
  { "CMPS (D,S)", 0x11AC, 9, 0, B_(11111011) },
  { "CMPS (,X++)", 0x11AC, 9, 0, B_(10010001) },
  { "CMPS (,Y++)", 0x11AC, 9, 0, B_(10110001) },
  { "CMPS (,U++)", 0x11AC, 9, 0, B_(11010001) },
  { "CMPS (,S++)", 0x11AC, 9, 0, B_(11110001) },
  { "CMPS (,--X)", 0x11AC, 9, 0, B_(10010011) },
  { "CMPS (,--Y)", 0x11AC, 9, 0, B_(10110011) },
  { "CMPS (,--U)", 0x11AC, 9, 0, B_(11010011) },
  { "CMPS (,--S)", 0x11AC, 9, 0, B_(11110011) },
  { "CMPS (x,X)", 0x11AC, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "CMPS (x,Y)", 0x11AC, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "CMPS (x,U)", 0x11AC, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "CMPS (x,S)", 0x11AC, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "CMPS (?,X)", 0x11AC, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "CMPS (?,Y)", 0x11AC, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "CMPS (?,U)", 0x11AC, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "CMPS (?,S)", 0x11AC, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "CMPS (x,PCR)", 0x11AC, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "CMPS (?,PCR)", 0x11AC, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "CMPS (?)", 0x11AC, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "CMPS s,X", 0x11AC, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "CMPS s,Y", 0x11AC, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "CMPS s,U", 0x11AC, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "CMPS s,S", 0x11AC, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "CMPS x,X", 0x11AC, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "CMPS x,Y", 0x11AC, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "CMPS x,U", 0x11AC, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "CMPS x,S", 0x11AC, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "CMPS ?,X", 0x11AC, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "CMPS ?,Y", 0x11AC, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "CMPS ?,U", 0x11AC, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "CMPS ?,S", 0x11AC, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "CMPS x,PCR", 0x11AC, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "CMPS ?,PCR", 0x11AC, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "CMPS x", 0x119C, 4, 1, 0 },
  { "CMPS ?", 0x11BC, 2, 0, 0 },

  { "CMPU #x", 0x1183, 1, 0, 0 },
  { "CMPU,X", 0x11A3, 9, 0, B_(10000100) },
  { "CMPU,Y", 0x11A3, 9, 0, B_(10100100) },
  { "CMPU,U", 0x11A3, 9, 0, B_(11000100) },
  { "CMPU,S", 0x11A3, 9, 0, B_(11100100) },
  { "CMPU A,X", 0x11A3, 9, 0, B_(10000110) },
  { "CMPU A,Y", 0x11A3, 9, 0, B_(10100110) },
  { "CMPU A,U", 0x11A3, 9, 0, B_(11000110) },
  { "CMPU A,S", 0x11A3, 9, 0, B_(11100110) },
  { "CMPU B,X", 0x11A3, 9, 0, B_(10000101) },
  { "CMPU B,Y", 0x11A3, 9, 0, B_(10100101) },
  { "CMPU B,U", 0x11A3, 9, 0, B_(11000101) },
  { "CMPU B,S", 0x11A3, 9, 0, B_(11100101) },
  { "CMPU D,X", 0x11A3, 9, 0, B_(10001011) },
  { "CMPU D,Y", 0x11A3, 9, 0, B_(10101011) },
  { "CMPU D,U", 0x11A3, 9, 0, B_(11001011) },
  { "CMPU D,S", 0x11A3, 9, 0, B_(11101011) },
  { "CMPU,X+", 0x11A3, 9, 0, B_(10000000) },
  { "CMPU,Y+", 0x11A3, 9, 0, B_(10100000) },
  { "CMPU,U+", 0x11A3, 9, 0, B_(11000000) },
  { "CMPU,S+", 0x11A3, 9, 0, B_(11100000) },
  { "CMPU,X++", 0x11A3, 9, 0, B_(10000001) },
  { "CMPU,Y++", 0x11A3, 9, 0, B_(10100001) },
  { "CMPU,U++", 0x11A3, 9, 0, B_(11000001) },
  { "CMPU,S++", 0x11A3, 9, 0, B_(11100001) },
  { "CMPU,-X", 0x11A3, 9, 0, B_(10000010) },
  { "CMPU,-Y", 0x11A3, 9, 0, B_(10100010) },
  { "CMPU,-U", 0x11A3, 9, 0, B_(11000010) },
  { "CMPU,-S", 0x11A3, 9, 0, B_(11100010) },
  { "CMPU,--X", 0x11A3, 9, 0, B_(10000011) },
  { "CMPU,--Y", 0x11A3, 9, 0, B_(10100011) },
  { "CMPU,--U", 0x11A3, 9, 0, B_(11000011) },
  { "CMPU,--S", 0x11A3, 9, 0, B_(11100011) },
  { "CMPU (,X)", 0x11A3, 9, 0, B_(10010100) },
  { "CMPU (,Y)", 0x11A3, 9, 0, B_(10110100) },
  { "CMPU (,U)", 0x11A3, 9, 0, B_(11010100) },
  { "CMPU (,S)", 0x11A3, 9, 0, B_(11110100) },
  { "CMPU (A,X)", 0x11A3, 9, 0, B_(10010110) },
  { "CMPU (A,Y)", 0x11A3, 9, 0, B_(10110110) },
  { "CMPU (A,U)", 0x11A3, 9, 0, B_(11010110) },
  { "CMPU (A,S)", 0x11A3, 9, 0, B_(11110110) },
  { "CMPU (B,X)", 0x11A3, 9, 0, B_(10010101) },
  { "CMPU (B,Y)", 0x11A3, 9, 0, B_(10110101) },
  { "CMPU (B,U)", 0x11A3, 9, 0, B_(11010101) },
  { "CMPU (B,S)", 0x11A3, 9, 0, B_(11110101) },
  { "CMPU (D,X)", 0x11A3, 9, 0, B_(10011011) },
  { "CMPU (D,Y)", 0x11A3, 9, 0, B_(10111011) },
  { "CMPU (D,U)", 0x11A3, 9, 0, B_(11011011) },
  { "CMPU (D,S)", 0x11A3, 9, 0, B_(11111011) },
  { "CMPU (,X++)", 0x11A3, 9, 0, B_(10010001) },
  { "CMPU (,Y++)", 0x11A3, 9, 0, B_(10110001) },
  { "CMPU (,U++)", 0x11A3, 9, 0, B_(11010001) },
  { "CMPU (,S++)", 0x11A3, 9, 0, B_(11110001) },
  { "CMPU (,--X)", 0x11A3, 9, 0, B_(10010011) },
  { "CMPU (,--Y)", 0x11A3, 9, 0, B_(10110011) },
  { "CMPU (,--U)", 0x11A3, 9, 0, B_(11010011) },
  { "CMPU (,--S)", 0x11A3, 9, 0, B_(11110011) },
  { "CMPU (x,X)", 0x11A3, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "CMPU (x,Y)", 0x11A3, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "CMPU (x,U)", 0x11A3, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "CMPU (x,S)", 0x11A3, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "CMPU (?,X)", 0x11A3, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "CMPU (?,Y)", 0x11A3, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "CMPU (?,U)", 0x11A3, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "CMPU (?,S)", 0x11A3, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "CMPU (x,PCR)", 0x11A3, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "CMPU (?,PCR)", 0x11A3, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "CMPU (?)", 0x11A3, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "CMPU s,X", 0x11A3, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "CMPU s,Y", 0x11A3, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "CMPU s,U", 0x11A3, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "CMPU s,S", 0x11A3, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "CMPU x,X", 0x11A3, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "CMPU x,Y", 0x11A3, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "CMPU x,U", 0x11A3, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "CMPU x,S", 0x11A3, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "CMPU ?,X", 0x11A3, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "CMPU ?,Y", 0x11A3, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "CMPU ?,U", 0x11A3, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "CMPU ?,S", 0x11A3, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "CMPU x,PCR", 0x11A3, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "CMPU ?,PCR", 0x11A3, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "CMPU x", 0x1193, 4, 1, 0 },
  { "CMPU ?", 0x11B3, 2, 0, 0 },

  { "CMPY #x", 0x108C, 1, 0, 0 },
  { "CMPY,X", 0x10AC, 9, 0, B_(10000100) },
  { "CMPY,Y", 0x10AC, 9, 0, B_(10100100) },
  { "CMPY,U", 0x10AC, 9, 0, B_(11000100) },
  { "CMPY,S", 0x10AC, 9, 0, B_(11100100) },
  { "CMPY A,X", 0x10AC, 9, 0, B_(10000110) },
  { "CMPY A,Y", 0x10AC, 9, 0, B_(10100110) },
  { "CMPY A,U", 0x10AC, 9, 0, B_(11000110) },
  { "CMPY A,S", 0x10AC, 9, 0, B_(11100110) },
  { "CMPY B,X", 0x10AC, 9, 0, B_(10000101) },
  { "CMPY B,Y", 0x10AC, 9, 0, B_(10100101) },
  { "CMPY B,U", 0x10AC, 9, 0, B_(11000101) },
  { "CMPY B,S", 0x10AC, 9, 0, B_(11100101) },
  { "CMPY D,X", 0x10AC, 9, 0, B_(10001011) },
  { "CMPY D,Y", 0x10AC, 9, 0, B_(10101011) },
  { "CMPY D,U", 0x10AC, 9, 0, B_(11001011) },
  { "CMPY D,S", 0x10AC, 9, 0, B_(11101011) },
  { "CMPY,X+", 0x10AC, 9, 0, B_(10000000) },
  { "CMPY,Y+", 0x10AC, 9, 0, B_(10100000) },
  { "CMPY,U+", 0x10AC, 9, 0, B_(11000000) },
  { "CMPY,S+", 0x10AC, 9, 0, B_(11100000) },
  { "CMPY,X++", 0x10AC, 9, 0, B_(10000001) },
  { "CMPY,Y++", 0x10AC, 9, 0, B_(10100001) },
  { "CMPY,U++", 0x10AC, 9, 0, B_(11000001) },
  { "CMPY,S++", 0x10AC, 9, 0, B_(11100001) },
  { "CMPY,-X", 0x10AC, 9, 0, B_(10000010) },
  { "CMPY,-Y", 0x10AC, 9, 0, B_(10100010) },
  { "CMPY,-U", 0x10AC, 9, 0, B_(11000010) },
  { "CMPY,-S", 0x10AC, 9, 0, B_(11100010) },
  { "CMPY,--X", 0x10AC, 9, 0, B_(10000011) },
  { "CMPY,--Y", 0x10AC, 9, 0, B_(10100011) },
  { "CMPY,--U", 0x10AC, 9, 0, B_(11000011) },
  { "CMPY,--S", 0x10AC, 9, 0, B_(11100011) },
  { "CMPY (,X)", 0x10AC, 9, 0, B_(10010100) },
  { "CMPY (,Y)", 0x10AC, 9, 0, B_(10110100) },
  { "CMPY (,U)", 0x10AC, 9, 0, B_(11010100) },
  { "CMPY (,S)", 0x10AC, 9, 0, B_(11110100) },
  { "CMPY (A,X)", 0x10AC, 9, 0, B_(10010110) },
  { "CMPY (A,Y)", 0x10AC, 9, 0, B_(10110110) },
  { "CMPY (A,U)", 0x10AC, 9, 0, B_(11010110) },
  { "CMPY (A,S)", 0x10AC, 9, 0, B_(11110110) },
  { "CMPY (B,X)", 0x10AC, 9, 0, B_(10010101) },
  { "CMPY (B,Y)", 0x10AC, 9, 0, B_(10110101) },
  { "CMPY (B,U)", 0x10AC, 9, 0, B_(11010101) },
  { "CMPY (B,S)", 0x10AC, 9, 0, B_(11110101) },
  { "CMPY (D,X)", 0x10AC, 9, 0, B_(10011011) },
  { "CMPY (D,Y)", 0x10AC, 9, 0, B_(10111011) },
  { "CMPY (D,U)", 0x10AC, 9, 0, B_(11011011) },
  { "CMPY (D,S)", 0x10AC, 9, 0, B_(11111011) },
  { "CMPY (,X++)", 0x10AC, 9, 0, B_(10010001) },
  { "CMPY (,Y++)", 0x10AC, 9, 0, B_(10110001) },
  { "CMPY (,U++)", 0x10AC, 9, 0, B_(11010001) },
  { "CMPY (,S++)", 0x10AC, 9, 0, B_(11110001) },
  { "CMPY (,--X)", 0x10AC, 9, 0, B_(10010011) },
  { "CMPY (,--Y)", 0x10AC, 9, 0, B_(10110011) },
  { "CMPY (,--U)", 0x10AC, 9, 0, B_(11010011) },
  { "CMPY (,--S)", 0x10AC, 9, 0, B_(11110011) },
  { "CMPY (x,X)", 0x10AC, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "CMPY (x,Y)", 0x10AC, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "CMPY (x,U)", 0x10AC, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "CMPY (x,S)", 0x10AC, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "CMPY (?,X)", 0x10AC, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "CMPY (?,Y)", 0x10AC, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "CMPY (?,U)", 0x10AC, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "CMPY (?,S)", 0x10AC, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "CMPY (x,PCR)", 0x10AC, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "CMPY (?,PCR)", 0x10AC, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "CMPY (?)", 0x10AC, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "CMPY s,X", 0x10AC, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "CMPY s,Y", 0x10AC, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "CMPY s,U", 0x10AC, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "CMPY s,S", 0x10AC, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "CMPY x,X", 0x10AC, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "CMPY x,Y", 0x10AC, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "CMPY x,U", 0x10AC, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "CMPY x,S", 0x10AC, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "CMPY ?,X", 0x10AC, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "CMPY ?,Y", 0x10AC, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "CMPY ?,U", 0x10AC, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "CMPY ?,S", 0x10AC, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "CMPY x,PCR", 0x10AC, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "CMPY ?,PCR", 0x10AC, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "CMPY x", 0x109C, 4, 1, 0 },
  { "CMPY ?", 0x10BC, 2, 0, 0 },

  { "COMA", 0x43, 0, 0, 0 },
  { "COMB", 0x53, 0, 0, 0 },
  { "COM,X", 0x63, 9, 0, B_(10000100) },
  { "COM,Y", 0x63, 9, 0, B_(10100100) },
  { "COM,U", 0x63, 9, 0, B_(11000100) },
  { "COM,S", 0x63, 9, 0, B_(11100100) },
  { "COM A,X", 0x63, 9, 0, B_(10000110) },
  { "COM A,Y", 0x63, 9, 0, B_(10100110) },
  { "COM A,U", 0x63, 9, 0, B_(11000110) },
  { "COM A,S", 0x63, 9, 0, B_(11100110) },
  { "COM B,X", 0x63, 9, 0, B_(10000101) },
  { "COM B,Y", 0x63, 9, 0, B_(10100101) },
  { "COM B,U", 0x63, 9, 0, B_(11000101) },
  { "COM B,S", 0x63, 9, 0, B_(11100101) },
  { "COM D,X", 0x63, 9, 0, B_(10001011) },
  { "COM D,Y", 0x63, 9, 0, B_(10101011) },
  { "COM D,U", 0x63, 9, 0, B_(11001011) },
  { "COM D,S", 0x63, 9, 0, B_(11101011) },
  { "COM,X+", 0x63, 9, 0, B_(10000000) },
  { "COM,Y+", 0x63, 9, 0, B_(10100000) },
  { "COM,U+", 0x63, 9, 0, B_(11000000) },
  { "COM,S+", 0x63, 9, 0, B_(11100000) },
  { "COM,X++", 0x63, 9, 0, B_(10000001) },
  { "COM,Y++", 0x63, 9, 0, B_(10100001) },
  { "COM,U++", 0x63, 9, 0, B_(11000001) },
  { "COM,S++", 0x63, 9, 0, B_(11100001) },
  { "COM,-X", 0x63, 9, 0, B_(10000010) },
  { "COM,-Y", 0x63, 9, 0, B_(10100010) },
  { "COM,-U", 0x63, 9, 0, B_(11000010) },
  { "COM,-S", 0x63, 9, 0, B_(11100010) },
  { "COM,--X", 0x63, 9, 0, B_(10000011) },
  { "COM,--Y", 0x63, 9, 0, B_(10100011) },
  { "COM,--U", 0x63, 9, 0, B_(11000011) },
  { "COM,--S", 0x63, 9, 0, B_(11100011) },
  { "COM (,X)", 0x63, 9, 0, B_(10010100) },
  { "COM (,Y)", 0x63, 9, 0, B_(10110100) },
  { "COM (,U)", 0x63, 9, 0, B_(11010100) },
  { "COM (,S)", 0x63, 9, 0, B_(11110100) },
  { "COM (A,X)", 0x63, 9, 0, B_(10010110) },
  { "COM (A,Y)", 0x63, 9, 0, B_(10110110) },
  { "COM (A,U)", 0x63, 9, 0, B_(11010110) },
  { "COM (A,S)", 0x63, 9, 0, B_(11110110) },
  { "COM (B,X)", 0x63, 9, 0, B_(10010101) },
  { "COM (B,Y)", 0x63, 9, 0, B_(10110101) },
  { "COM (B,U)", 0x63, 9, 0, B_(11010101) },
  { "COM (B,S)", 0x63, 9, 0, B_(11110101) },
  { "COM (D,X)", 0x63, 9, 0, B_(10011011) },
  { "COM (D,Y)", 0x63, 9, 0, B_(10111011) },
  { "COM (D,U)", 0x63, 9, 0, B_(11011011) },
  { "COM (D,S)", 0x63, 9, 0, B_(11111011) },
  { "COM (,X++)", 0x63, 9, 0, B_(10010001) },
  { "COM (,Y++)", 0x63, 9, 0, B_(10110001) },
  { "COM (,U++)", 0x63, 9, 0, B_(11010001) },
  { "COM (,S++)", 0x63, 9, 0, B_(11110001) },
  { "COM (,--X)", 0x63, 9, 0, B_(10010011) },
  { "COM (,--Y)", 0x63, 9, 0, B_(10110011) },
  { "COM (,--U)", 0x63, 9, 0, B_(11010011) },
  { "COM (,--S)", 0x63, 9, 0, B_(11110011) },
  { "COM (x,X)", 0x63, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "COM (x,Y)", 0x63, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "COM (x,U)", 0x63, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "COM (x,S)", 0x63, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "COM (?,X)", 0x63, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "COM (?,Y)", 0x63, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "COM (?,U)", 0x63, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "COM (?,S)", 0x63, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "COM (x,PCR)", 0x63, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "COM (?,PCR)", 0x63, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "COM (?)", 0x63, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "COM s,X", 0x63, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "COM s,Y", 0x63, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "COM s,U", 0x63, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "COM s,S", 0x63, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "COM x,X", 0x63, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "COM x,Y", 0x63, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "COM x,U", 0x63, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "COM x,S", 0x63, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "COM ?,X", 0x63, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "COM ?,Y", 0x63, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "COM ?,U", 0x63, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "COM ?,S", 0x63, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "COM x,PCR", 0x63, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "COM ?,PCR", 0x63, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "COM x", 0x03, 4, 1, 0 },
  { "COM ?", 0x73, 2, 0, 0 },

  { "CWAI #x", 0x3C, 1, 0, 0 },

  { "DAA", 0x19, 0, 0, 0 },

  { "DECA", 0x4A, 0, 0, 0 },
  { "DECB", 0x5A, 0, 0, 0 },
  { "DEC,X", 0x6A, 9, 0, B_(10000100) },
  { "DEC,Y", 0x6A, 9, 0, B_(10100100) },
  { "DEC,U", 0x6A, 9, 0, B_(11000100) },
  { "DEC,S", 0x6A, 9, 0, B_(11100100) },
  { "DEC A,X", 0x6A, 9, 0, B_(10000110) },
  { "DEC A,Y", 0x6A, 9, 0, B_(10100110) },
  { "DEC A,U", 0x6A, 9, 0, B_(11000110) },
  { "DEC A,S", 0x6A, 9, 0, B_(11100110) },
  { "DEC B,X", 0x6A, 9, 0, B_(10000101) },
  { "DEC B,Y", 0x6A, 9, 0, B_(10100101) },
  { "DEC B,U", 0x6A, 9, 0, B_(11000101) },
  { "DEC B,S", 0x6A, 9, 0, B_(11100101) },
  { "DEC D,X", 0x6A, 9, 0, B_(10001011) },
  { "DEC D,Y", 0x6A, 9, 0, B_(10101011) },
  { "DEC D,U", 0x6A, 9, 0, B_(11001011) },
  { "DEC D,S", 0x6A, 9, 0, B_(11101011) },
  { "DEC,X+", 0x6A, 9, 0, B_(10000000) },
  { "DEC,Y+", 0x6A, 9, 0, B_(10100000) },
  { "DEC,U+", 0x6A, 9, 0, B_(11000000) },
  { "DEC,S+", 0x6A, 9, 0, B_(11100000) },
  { "DEC,X++", 0x6A, 9, 0, B_(10000001) },
  { "DEC,Y++", 0x6A, 9, 0, B_(10100001) },
  { "DEC,U++", 0x6A, 9, 0, B_(11000001) },
  { "DEC,S++", 0x6A, 9, 0, B_(11100001) },
  { "DEC,-X", 0x6A, 9, 0, B_(10000010) },
  { "DEC,-Y", 0x6A, 9, 0, B_(10100010) },
  { "DEC,-U", 0x6A, 9, 0, B_(11000010) },
  { "DEC,-S", 0x6A, 9, 0, B_(11100010) },
  { "DEC,--X", 0x6A, 9, 0, B_(10000011) },
  { "DEC,--Y", 0x6A, 9, 0, B_(10100011) },
  { "DEC,--U", 0x6A, 9, 0, B_(11000011) },
  { "DEC,--S", 0x6A, 9, 0, B_(11100011) },
  { "DEC (,X)", 0x6A, 9, 0, B_(10010100) },
  { "DEC (,Y)", 0x6A, 9, 0, B_(10110100) },
  { "DEC (,U)", 0x6A, 9, 0, B_(11010100) },
  { "DEC (,S)", 0x6A, 9, 0, B_(11110100) },
  { "DEC (A,X)", 0x6A, 9, 0, B_(10010110) },
  { "DEC (A,Y)", 0x6A, 9, 0, B_(10110110) },
  { "DEC (A,U)", 0x6A, 9, 0, B_(11010110) },
  { "DEC (A,S)", 0x6A, 9, 0, B_(11110110) },
  { "DEC (B,X)", 0x6A, 9, 0, B_(10010101) },
  { "DEC (B,Y)", 0x6A, 9, 0, B_(10110101) },
  { "DEC (B,U)", 0x6A, 9, 0, B_(11010101) },
  { "DEC (B,S)", 0x6A, 9, 0, B_(11110101) },
  { "DEC (D,X)", 0x6A, 9, 0, B_(10011011) },
  { "DEC (D,Y)", 0x6A, 9, 0, B_(10111011) },
  { "DEC (D,U)", 0x6A, 9, 0, B_(11011011) },
  { "DEC (D,S)", 0x6A, 9, 0, B_(11111011) },
  { "DEC (,X++)", 0x6A, 9, 0, B_(10010001) },
  { "DEC (,Y++)", 0x6A, 9, 0, B_(10110001) },
  { "DEC (,U++)", 0x6A, 9, 0, B_(11010001) },
  { "DEC (,S++)", 0x6A, 9, 0, B_(11110001) },
  { "DEC (,--X)", 0x6A, 9, 0, B_(10010011) },
  { "DEC (,--Y)", 0x6A, 9, 0, B_(10110011) },
  { "DEC (,--U)", 0x6A, 9, 0, B_(11010011) },
  { "DEC (,--S)", 0x6A, 9, 0, B_(11110011) },
  { "DEC (x,X)", 0x6A, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "DEC (x,Y)", 0x6A, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "DEC (x,U)", 0x6A, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "DEC (x,S)", 0x6A, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "DEC (?,X)", 0x6A, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "DEC (?,Y)", 0x6A, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "DEC (?,U)", 0x6A, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "DEC (?,S)", 0x6A, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "DEC (x,PCR)", 0x6A, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "DEC (?,PCR)", 0x6A, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "DEC (?)", 0x6A, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "DEC s,X", 0x6A, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "DEC s,Y", 0x6A, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "DEC s,U", 0x6A, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "DEC s,S", 0x6A, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "DEC x,X", 0x6A, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "DEC x,Y", 0x6A, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "DEC x,U", 0x6A, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "DEC x,S", 0x6A, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "DEC ?,X", 0x6A, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "DEC ?,Y", 0x6A, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "DEC ?,U", 0x6A, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "DEC ?,S", 0x6A, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "DEC x,PCR", 0x6A, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "DEC ?,PCR", 0x6A, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "DEC x", 0x0A, 4, 1, 0 },
  { "DEC ?", 0x7A, 2, 0, 0 },

  { "EORA #x", 0x88, 1, 0, 0 },
  { "EORA,X", 0xA8, 9, 0, B_(10000100) },
  { "EORA,Y", 0xA8, 9, 0, B_(10100100) },
  { "EORA,U", 0xA8, 9, 0, B_(11000100) },
  { "EORA,S", 0xA8, 9, 0, B_(11100100) },
  { "EORA A,X", 0xA8, 9, 0, B_(10000110) },
  { "EORA A,Y", 0xA8, 9, 0, B_(10100110) },
  { "EORA A,U", 0xA8, 9, 0, B_(11000110) },
  { "EORA A,S", 0xA8, 9, 0, B_(11100110) },
  { "EORA B,X", 0xA8, 9, 0, B_(10000101) },
  { "EORA B,Y", 0xA8, 9, 0, B_(10100101) },
  { "EORA B,U", 0xA8, 9, 0, B_(11000101) },
  { "EORA B,S", 0xA8, 9, 0, B_(11100101) },
  { "EORA D,X", 0xA8, 9, 0, B_(10001011) },
  { "EORA D,Y", 0xA8, 9, 0, B_(10101011) },
  { "EORA D,U", 0xA8, 9, 0, B_(11001011) },
  { "EORA D,S", 0xA8, 9, 0, B_(11101011) },
  { "EORA,X+", 0xA8, 9, 0, B_(10000000) },
  { "EORA,Y+", 0xA8, 9, 0, B_(10100000) },
  { "EORA,U+", 0xA8, 9, 0, B_(11000000) },
  { "EORA,S+", 0xA8, 9, 0, B_(11100000) },
  { "EORA,X++", 0xA8, 9, 0, B_(10000001) },
  { "EORA,Y++", 0xA8, 9, 0, B_(10100001) },
  { "EORA,U++", 0xA8, 9, 0, B_(11000001) },
  { "EORA,S++", 0xA8, 9, 0, B_(11100001) },
  { "EORA,-X", 0xA8, 9, 0, B_(10000010) },
  { "EORA,-Y", 0xA8, 9, 0, B_(10100010) },
  { "EORA,-U", 0xA8, 9, 0, B_(11000010) },
  { "EORA,-S", 0xA8, 9, 0, B_(11100010) },
  { "EORA,--X", 0xA8, 9, 0, B_(10000011) },
  { "EORA,--Y", 0xA8, 9, 0, B_(10100011) },
  { "EORA,--U", 0xA8, 9, 0, B_(11000011) },
  { "EORA,--S", 0xA8, 9, 0, B_(11100011) },
  { "EORA (,X)", 0xA8, 9, 0, B_(10010100) },
  { "EORA (,Y)", 0xA8, 9, 0, B_(10110100) },
  { "EORA (,U)", 0xA8, 9, 0, B_(11010100) },
  { "EORA (,S)", 0xA8, 9, 0, B_(11110100) },
  { "EORA (A,X)", 0xA8, 9, 0, B_(10010110) },
  { "EORA (A,Y)", 0xA8, 9, 0, B_(10110110) },
  { "EORA (A,U)", 0xA8, 9, 0, B_(11010110) },
  { "EORA (A,S)", 0xA8, 9, 0, B_(11110110) },
  { "EORA (B,X)", 0xA8, 9, 0, B_(10010101) },
  { "EORA (B,Y)", 0xA8, 9, 0, B_(10110101) },
  { "EORA (B,U)", 0xA8, 9, 0, B_(11010101) },
  { "EORA (B,S)", 0xA8, 9, 0, B_(11110101) },
  { "EORA (D,X)", 0xA8, 9, 0, B_(10011011) },
  { "EORA (D,Y)", 0xA8, 9, 0, B_(10111011) },
  { "EORA (D,U)", 0xA8, 9, 0, B_(11011011) },
  { "EORA (D,S)", 0xA8, 9, 0, B_(11111011) },
  { "EORA (,X++)", 0xA8, 9, 0, B_(10010001) },
  { "EORA (,Y++)", 0xA8, 9, 0, B_(10110001) },
  { "EORA (,U++)", 0xA8, 9, 0, B_(11010001) },
  { "EORA (,S++)", 0xA8, 9, 0, B_(11110001) },
  { "EORA (,--X)", 0xA8, 9, 0, B_(10010011) },
  { "EORA (,--Y)", 0xA8, 9, 0, B_(10110011) },
  { "EORA (,--U)", 0xA8, 9, 0, B_(11010011) },
  { "EORA (,--S)", 0xA8, 9, 0, B_(11110011) },
  { "EORA (x,X)", 0xA8, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "EORA (x,Y)", 0xA8, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "EORA (x,U)", 0xA8, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "EORA (x,S)", 0xA8, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "EORA (?,X)", 0xA8, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "EORA (?,Y)", 0xA8, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "EORA (?,U)", 0xA8, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "EORA (?,S)", 0xA8, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "EORA (x,PCR)", 0xA8, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "EORA (?,PCR)", 0xA8, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "EORA (?)", 0xA8, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "EORA s,X", 0xA8, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "EORA s,Y", 0xA8, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "EORA s,U", 0xA8, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "EORA s,S", 0xA8, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "EORA x,X", 0xA8, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "EORA x,Y", 0xA8, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "EORA x,U", 0xA8, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "EORA x,S", 0xA8, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "EORA ?,X", 0xA8, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "EORA ?,Y", 0xA8, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "EORA ?,U", 0xA8, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "EORA ?,S", 0xA8, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "EORA x,PCR", 0xA8, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "EORA ?,PCR", 0xA8, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "EORA x", 0x98, 4, 1, 0 },
  { "EORA ?", 0xB8, 2, 0, 0 },

  { "EORB #x", 0xC8, 1, 0, 0 },
  { "EORB,X", 0xE8, 9, 0, B_(10000100) },
  { "EORB,Y", 0xE8, 9, 0, B_(10100100) },
  { "EORB,U", 0xE8, 9, 0, B_(11000100) },
  { "EORB,S", 0xE8, 9, 0, B_(11100100) },
  { "EORB A,X", 0xE8, 9, 0, B_(10000110) },
  { "EORB A,Y", 0xE8, 9, 0, B_(10100110) },
  { "EORB A,U", 0xE8, 9, 0, B_(11000110) },
  { "EORB A,S", 0xE8, 9, 0, B_(11100110) },
  { "EORB B,X", 0xE8, 9, 0, B_(10000101) },
  { "EORB B,Y", 0xE8, 9, 0, B_(10100101) },
  { "EORB B,U", 0xE8, 9, 0, B_(11000101) },
  { "EORB B,S", 0xE8, 9, 0, B_(11100101) },
  { "EORB D,X", 0xE8, 9, 0, B_(10001011) },
  { "EORB D,Y", 0xE8, 9, 0, B_(10101011) },
  { "EORB D,U", 0xE8, 9, 0, B_(11001011) },
  { "EORB D,S", 0xE8, 9, 0, B_(11101011) },
  { "EORB,X+", 0xE8, 9, 0, B_(10000000) },
  { "EORB,Y+", 0xE8, 9, 0, B_(10100000) },
  { "EORB,U+", 0xE8, 9, 0, B_(11000000) },
  { "EORB,S+", 0xE8, 9, 0, B_(11100000) },
  { "EORB,X++", 0xE8, 9, 0, B_(10000001) },
  { "EORB,Y++", 0xE8, 9, 0, B_(10100001) },
  { "EORB,U++", 0xE8, 9, 0, B_(11000001) },
  { "EORB,S++", 0xE8, 9, 0, B_(11100001) },
  { "EORB,-X", 0xE8, 9, 0, B_(10000010) },
  { "EORB,-Y", 0xE8, 9, 0, B_(10100010) },
  { "EORB,-U", 0xE8, 9, 0, B_(11000010) },
  { "EORB,-S", 0xE8, 9, 0, B_(11100010) },
  { "EORB,--X", 0xE8, 9, 0, B_(10000011) },
  { "EORB,--Y", 0xE8, 9, 0, B_(10100011) },
  { "EORB,--U", 0xE8, 9, 0, B_(11000011) },
  { "EORB,--S", 0xE8, 9, 0, B_(11100011) },
  { "EORB (,X)", 0xE8, 9, 0, B_(10010100) },
  { "EORB (,Y)", 0xE8, 9, 0, B_(10110100) },
  { "EORB (,U)", 0xE8, 9, 0, B_(11010100) },
  { "EORB (,S)", 0xE8, 9, 0, B_(11110100) },
  { "EORB (A,X)", 0xE8, 9, 0, B_(10010110) },
  { "EORB (A,Y)", 0xE8, 9, 0, B_(10110110) },
  { "EORB (A,U)", 0xE8, 9, 0, B_(11010110) },
  { "EORB (A,S)", 0xE8, 9, 0, B_(11110110) },
  { "EORB (B,X)", 0xE8, 9, 0, B_(10010101) },
  { "EORB (B,Y)", 0xE8, 9, 0, B_(10110101) },
  { "EORB (B,U)", 0xE8, 9, 0, B_(11010101) },
  { "EORB (B,S)", 0xE8, 9, 0, B_(11110101) },
  { "EORB (D,X)", 0xE8, 9, 0, B_(10011011) },
  { "EORB (D,Y)", 0xE8, 9, 0, B_(10111011) },
  { "EORB (D,U)", 0xE8, 9, 0, B_(11011011) },
  { "EORB (D,S)", 0xE8, 9, 0, B_(11111011) },
  { "EORB (,X++)", 0xE8, 9, 0, B_(10010001) },
  { "EORB (,Y++)", 0xE8, 9, 0, B_(10110001) },
  { "EORB (,U++)", 0xE8, 9, 0, B_(11010001) },
  { "EORB (,S++)", 0xE8, 9, 0, B_(11110001) },
  { "EORB (,--X)", 0xE8, 9, 0, B_(10010011) },
  { "EORB (,--Y)", 0xE8, 9, 0, B_(10110011) },
  { "EORB (,--U)", 0xE8, 9, 0, B_(11010011) },
  { "EORB (,--S)", 0xE8, 9, 0, B_(11110011) },
  { "EORB (x,X)", 0xE8, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "EORB (x,Y)", 0xE8, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "EORB (x,U)", 0xE8, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "EORB (x,S)", 0xE8, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "EORB (?,X)", 0xE8, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "EORB (?,Y)", 0xE8, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "EORB (?,U)", 0xE8, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "EORB (?,S)", 0xE8, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "EORB (x,PCR)", 0xE8, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "EORB (?,PCR)", 0xE8, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "EORB (?)", 0xE8, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "EORB s,X", 0xE8, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "EORB s,Y", 0xE8, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "EORB s,U", 0xE8, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "EORB s,S", 0xE8, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "EORB x,X", 0xE8, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "EORB x,Y", 0xE8, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "EORB x,U", 0xE8, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "EORB x,S", 0xE8, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "EORB ?,X", 0xE8, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "EORB ?,Y", 0xE8, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "EORB ?,U", 0xE8, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "EORB ?,S", 0xE8, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "EORB x,PCR", 0xE8, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "EORB ?,PCR", 0xE8, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "EORB x", 0xD8, 4, 1, 0 },
  { "EORB ?", 0xF8, 2, 0, 0 },

  { "EXG r", 0x1E, 10, 0, 0 },

  { "INCA", 0x4C, 0, 0, 0 },
  { "INCB", 0x5C, 0, 0, 0 },
  { "INC,X", 0x6C, 9, 0, B_(10000100) },
  { "INC,Y", 0x6C, 9, 0, B_(10100100) },
  { "INC,U", 0x6C, 9, 0, B_(11000100) },
  { "INC,S", 0x6C, 9, 0, B_(11100100) },
  { "INC A,X", 0x6C, 9, 0, B_(10000110) },
  { "INC A,Y", 0x6C, 9, 0, B_(10100110) },
  { "INC A,U", 0x6C, 9, 0, B_(11000110) },
  { "INC A,S", 0x6C, 9, 0, B_(11100110) },
  { "INC B,X", 0x6C, 9, 0, B_(10000101) },
  { "INC B,Y", 0x6C, 9, 0, B_(10100101) },
  { "INC B,U", 0x6C, 9, 0, B_(11000101) },
  { "INC B,S", 0x6C, 9, 0, B_(11100101) },
  { "INC D,X", 0x6C, 9, 0, B_(10001011) },
  { "INC D,Y", 0x6C, 9, 0, B_(10101011) },
  { "INC D,U", 0x6C, 9, 0, B_(11001011) },
  { "INC D,S", 0x6C, 9, 0, B_(11101011) },
  { "INC,X+", 0x6C, 9, 0, B_(10000000) },
  { "INC,Y+", 0x6C, 9, 0, B_(10100000) },
  { "INC,U+", 0x6C, 9, 0, B_(11000000) },
  { "INC,S+", 0x6C, 9, 0, B_(11100000) },
  { "INC,X++", 0x6C, 9, 0, B_(10000001) },
  { "INC,Y++", 0x6C, 9, 0, B_(10100001) },
  { "INC,U++", 0x6C, 9, 0, B_(11000001) },
  { "INC,S++", 0x6C, 9, 0, B_(11100001) },
  { "INC,-X", 0x6C, 9, 0, B_(10000010) },
  { "INC,-Y", 0x6C, 9, 0, B_(10100010) },
  { "INC,-U", 0x6C, 9, 0, B_(11000010) },
  { "INC,-S", 0x6C, 9, 0, B_(11100010) },
  { "INC,--X", 0x6C, 9, 0, B_(10000011) },
  { "INC,--Y", 0x6C, 9, 0, B_(10100011) },
  { "INC,--U", 0x6C, 9, 0, B_(11000011) },
  { "INC,--S", 0x6C, 9, 0, B_(11100011) },
  { "INC (,X)", 0x6C, 9, 0, B_(10010100) },
  { "INC (,Y)", 0x6C, 9, 0, B_(10110100) },
  { "INC (,U)", 0x6C, 9, 0, B_(11010100) },
  { "INC (,S)", 0x6C, 9, 0, B_(11110100) },
  { "INC (A,X)", 0x6C, 9, 0, B_(10010110) },
  { "INC (A,Y)", 0x6C, 9, 0, B_(10110110) },
  { "INC (A,U)", 0x6C, 9, 0, B_(11010110) },
  { "INC (A,S)", 0x6C, 9, 0, B_(11110110) },
  { "INC (B,X)", 0x6C, 9, 0, B_(10010101) },
  { "INC (B,Y)", 0x6C, 9, 0, B_(10110101) },
  { "INC (B,U)", 0x6C, 9, 0, B_(11010101) },
  { "INC (B,S)", 0x6C, 9, 0, B_(11110101) },
  { "INC (D,X)", 0x6C, 9, 0, B_(10011011) },
  { "INC (D,Y)", 0x6C, 9, 0, B_(10111011) },
  { "INC (D,U)", 0x6C, 9, 0, B_(11011011) },
  { "INC (D,S)", 0x6C, 9, 0, B_(11111011) },
  { "INC (,X++)", 0x6C, 9, 0, B_(10010001) },
  { "INC (,Y++)", 0x6C, 9, 0, B_(10110001) },
  { "INC (,U++)", 0x6C, 9, 0, B_(11010001) },
  { "INC (,S++)", 0x6C, 9, 0, B_(11110001) },
  { "INC (,--X)", 0x6C, 9, 0, B_(10010011) },
  { "INC (,--Y)", 0x6C, 9, 0, B_(10110011) },
  { "INC (,--U)", 0x6C, 9, 0, B_(11010011) },
  { "INC (,--S)", 0x6C, 9, 0, B_(11110011) },
  { "INC (x,X)", 0x6C, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "INC (x,Y)", 0x6C, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "INC (x,U)", 0x6C, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "INC (x,S)", 0x6C, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "INC (?,X)", 0x6C, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "INC (?,Y)", 0x6C, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "INC (?,U)", 0x6C, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "INC (?,S)", 0x6C, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "INC (x,PCR)", 0x6C, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "INC (?,PCR)", 0x6C, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "INC (?)", 0x6C, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "INC s,X", 0x6C, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "INC s,Y", 0x6C, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "INC s,U", 0x6C, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "INC s,S", 0x6C, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "INC x,X", 0x6C, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "INC x,Y", 0x6C, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "INC x,U", 0x6C, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "INC x,S", 0x6C, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "INC ?,X", 0x6C, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "INC ?,Y", 0x6C, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "INC ?,U", 0x6C, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "INC ?,S", 0x6C, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "INC x,PCR", 0x6C, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "INC ?,PCR", 0x6C, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "INC x", 0x0C, 4, 1, 0 },
  { "INC ?", 0x7C, 2, 0, 0 },

  { "JMP,X", 0x6E, 9, 0, B_(10000100) },
  { "JMP,Y", 0x6E, 9, 0, B_(10100100) },
  { "JMP,U", 0x6E, 9, 0, B_(11000100) },
  { "JMP,S", 0x6E, 9, 0, B_(11100100) },
  { "JMP A,X", 0x6E, 9, 0, B_(10000110) },
  { "JMP A,Y", 0x6E, 9, 0, B_(10100110) },
  { "JMP A,U", 0x6E, 9, 0, B_(11000110) },
  { "JMP A,S", 0x6E, 9, 0, B_(11100110) },
  { "JMP B,X", 0x6E, 9, 0, B_(10000101) },
  { "JMP B,Y", 0x6E, 9, 0, B_(10100101) },
  { "JMP B,U", 0x6E, 9, 0, B_(11000101) },
  { "JMP B,S", 0x6E, 9, 0, B_(11100101) },
  { "JMP D,X", 0x6E, 9, 0, B_(10001011) },
  { "JMP D,Y", 0x6E, 9, 0, B_(10101011) },
  { "JMP D,U", 0x6E, 9, 0, B_(11001011) },
  { "JMP D,S", 0x6E, 9, 0, B_(11101011) },
  { "JMP,X+", 0x6E, 9, 0, B_(10000000) },
  { "JMP,Y+", 0x6E, 9, 0, B_(10100000) },
  { "JMP,U+", 0x6E, 9, 0, B_(11000000) },
  { "JMP,S+", 0x6E, 9, 0, B_(11100000) },
  { "JMP,X++", 0x6E, 9, 0, B_(10000001) },
  { "JMP,Y++", 0x6E, 9, 0, B_(10100001) },
  { "JMP,U++", 0x6E, 9, 0, B_(11000001) },
  { "JMP,S++", 0x6E, 9, 0, B_(11100001) },
  { "JMP,-X", 0x6E, 9, 0, B_(10000010) },
  { "JMP,-Y", 0x6E, 9, 0, B_(10100010) },
  { "JMP,-U", 0x6E, 9, 0, B_(11000010) },
  { "JMP,-S", 0x6E, 9, 0, B_(11100010) },
  { "JMP,--X", 0x6E, 9, 0, B_(10000011) },
  { "JMP,--Y", 0x6E, 9, 0, B_(10100011) },
  { "JMP,--U", 0x6E, 9, 0, B_(11000011) },
  { "JMP,--S", 0x6E, 9, 0, B_(11100011) },
  { "JMP (,X)", 0x6E, 9, 0, B_(10010100) },
  { "JMP (,Y)", 0x6E, 9, 0, B_(10110100) },
  { "JMP (,U)", 0x6E, 9, 0, B_(11010100) },
  { "JMP (,S)", 0x6E, 9, 0, B_(11110100) },
  { "JMP (A,X)", 0x6E, 9, 0, B_(10010110) },
  { "JMP (A,Y)", 0x6E, 9, 0, B_(10110110) },
  { "JMP (A,U)", 0x6E, 9, 0, B_(11010110) },
  { "JMP (A,S)", 0x6E, 9, 0, B_(11110110) },
  { "JMP (B,X)", 0x6E, 9, 0, B_(10010101) },
  { "JMP (B,Y)", 0x6E, 9, 0, B_(10110101) },
  { "JMP (B,U)", 0x6E, 9, 0, B_(11010101) },
  { "JMP (B,S)", 0x6E, 9, 0, B_(11110101) },
  { "JMP (D,X)", 0x6E, 9, 0, B_(10011011) },
  { "JMP (D,Y)", 0x6E, 9, 0, B_(10111011) },
  { "JMP (D,U)", 0x6E, 9, 0, B_(11011011) },
  { "JMP (D,S)", 0x6E, 9, 0, B_(11111011) },
  { "JMP (,X++)", 0x6E, 9, 0, B_(10010001) },
  { "JMP (,Y++)", 0x6E, 9, 0, B_(10110001) },
  { "JMP (,U++)", 0x6E, 9, 0, B_(11010001) },
  { "JMP (,S++)", 0x6E, 9, 0, B_(11110001) },
  { "JMP (,--X)", 0x6E, 9, 0, B_(10010011) },
  { "JMP (,--Y)", 0x6E, 9, 0, B_(10110011) },
  { "JMP (,--U)", 0x6E, 9, 0, B_(11010011) },
  { "JMP (,--S)", 0x6E, 9, 0, B_(11110011) },
  { "JMP (x,X)", 0x6E, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "JMP (x,Y)", 0x6E, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "JMP (x,U)", 0x6E, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "JMP (x,S)", 0x6E, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "JMP (?,X)", 0x6E, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "JMP (?,Y)", 0x6E, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "JMP (?,U)", 0x6E, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "JMP (?,S)", 0x6E, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "JMP (x,PCR)", 0x6E, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "JMP (?,PCR)", 0x6E, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "JMP (?)", 0x6E, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "JMP s,X", 0x6E, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "JMP s,Y", 0x6E, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "JMP s,U", 0x6E, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "JMP s,S", 0x6E, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "JMP x,X", 0x6E, 7, 1, B_(10001000) }, /* 8-bit offset */ /* 0x88 */
  { "JMP x,Y", 0x6E, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "JMP x,U", 0x6E, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "JMP x,S", 0x6E, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "JMP ?,X", 0x6E, 8, 0, B_(10001001) }, /* 16-bit offset */ /* 0x89 */
  { "JMP ?,Y", 0x6E, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "JMP ?,U", 0x6E, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "JMP ?,S", 0x6E, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "JMP x,PCR", 0x6E, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "JMP ?,PCR", 0x6E, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "JMP x", 0x0E, 4, 1, 0 },
  { "JMP ?", 0x7E, 2, 0, 0 },

  { "JSR,X", 0xAD, 9, 0, B_(10000100) },
  { "JSR,Y", 0xAD, 9, 0, B_(10100100) },
  { "JSR,U", 0xAD, 9, 0, B_(11000100) },
  { "JSR,S", 0xAD, 9, 0, B_(11100100) },
  { "JSR A,X", 0xAD, 9, 0, B_(10000110) },
  { "JSR A,Y", 0xAD, 9, 0, B_(10100110) },
  { "JSR A,U", 0xAD, 9, 0, B_(11000110) },
  { "JSR A,S", 0xAD, 9, 0, B_(11100110) },
  { "JSR B,X", 0xAD, 9, 0, B_(10000101) },
  { "JSR B,Y", 0xAD, 9, 0, B_(10100101) },
  { "JSR B,U", 0xAD, 9, 0, B_(11000101) },
  { "JSR B,S", 0xAD, 9, 0, B_(11100101) },
  { "JSR D,X", 0xAD, 9, 0, B_(10001011) },
  { "JSR D,Y", 0xAD, 9, 0, B_(10101011) },
  { "JSR D,U", 0xAD, 9, 0, B_(11001011) },
  { "JSR D,S", 0xAD, 9, 0, B_(11101011) },
  { "JSR,X+", 0xAD, 9, 0, B_(10000000) },
  { "JSR,Y+", 0xAD, 9, 0, B_(10100000) },
  { "JSR,U+", 0xAD, 9, 0, B_(11000000) },
  { "JSR,S+", 0xAD, 9, 0, B_(11100000) },
  { "JSR,X++", 0xAD, 9, 0, B_(10000001) },
  { "JSR,Y++", 0xAD, 9, 0, B_(10100001) },
  { "JSR,U++", 0xAD, 9, 0, B_(11000001) },
  { "JSR,S++", 0xAD, 9, 0, B_(11100001) },
  { "JSR,-X", 0xAD, 9, 0, B_(10000010) },
  { "JSR,-Y", 0xAD, 9, 0, B_(10100010) },
  { "JSR,-U", 0xAD, 9, 0, B_(11000010) },
  { "JSR,-S", 0xAD, 9, 0, B_(11100010) },
  { "JSR,--X", 0xAD, 9, 0, B_(10000011) },
  { "JSR,--Y", 0xAD, 9, 0, B_(10100011) },
  { "JSR,--U", 0xAD, 9, 0, B_(11000011) },
  { "JSR,--S", 0xAD, 9, 0, B_(11100011) },
  { "JSR (,X)", 0xAD, 9, 0, B_(10010100) },
  { "JSR (,Y)", 0xAD, 9, 0, B_(10110100) },
  { "JSR (,U)", 0xAD, 9, 0, B_(11010100) },
  { "JSR (,S)", 0xAD, 9, 0, B_(11110100) },
  { "JSR (A,X)", 0xAD, 9, 0, B_(10010110) },
  { "JSR (A,Y)", 0xAD, 9, 0, B_(10110110) },
  { "JSR (A,U)", 0xAD, 9, 0, B_(11010110) },
  { "JSR (A,S)", 0xAD, 9, 0, B_(11110110) },
  { "JSR (B,X)", 0xAD, 9, 0, B_(10010101) },
  { "JSR (B,Y)", 0xAD, 9, 0, B_(10110101) },
  { "JSR (B,U)", 0xAD, 9, 0, B_(11010101) },
  { "JSR (B,S)", 0xAD, 9, 0, B_(11110101) },
  { "JSR (D,X)", 0xAD, 9, 0, B_(10011011) },
  { "JSR (D,Y)", 0xAD, 9, 0, B_(10111011) },
  { "JSR (D,U)", 0xAD, 9, 0, B_(11011011) },
  { "JSR (D,S)", 0xAD, 9, 0, B_(11111011) },
  { "JSR (,X++)", 0xAD, 9, 0, B_(10010001) },
  { "JSR (,Y++)", 0xAD, 9, 0, B_(10110001) },
  { "JSR (,U++)", 0xAD, 9, 0, B_(11010001) },
  { "JSR (,S++)", 0xAD, 9, 0, B_(11110001) },
  { "JSR (,--X)", 0xAD, 9, 0, B_(10010011) },
  { "JSR (,--Y)", 0xAD, 9, 0, B_(10110011) },
  { "JSR (,--U)", 0xAD, 9, 0, B_(11010011) },
  { "JSR (,--S)", 0xAD, 9, 0, B_(11110011) },
  { "JSR (x,X)", 0xAD, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "JSR (x,Y)", 0xAD, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "JSR (x,U)", 0xAD, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "JSR (x,S)", 0xAD, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "JSR (?,X)", 0xAD, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "JSR (?,Y)", 0xAD, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "JSR (?,U)", 0xAD, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "JSR (?,S)", 0xAD, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "JSR (x,PCR)", 0xAD, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "JSR (?,PCR)", 0xAD, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "JSR (?)", 0xAD, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "JSR s,X", 0xAD, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "JSR s,Y", 0xAD, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "JSR s,U", 0xAD, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "JSR s,S", 0xAD, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "JSR x,X", 0xAD, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "JSR x,Y", 0xAD, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "JSR x,U", 0xAD, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "JSR x,S", 0xAD, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "JSR ?,X", 0xAD, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "JSR ?,Y", 0xAD, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "JSR ?,U", 0xAD, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "JSR ?,S", 0xAD, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "JSR x,PCR", 0xAD, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "JSR ?,PCR", 0xAD, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "JSR x", 0x9D, 4, 1, 0 },
  { "JSR ?", 0xBD, 2, 0, 0 },

  { "LBCC ?", 0x1024, 12, 0, 0 },
  { "LBCS ?", 0x1025, 12, 0, 0 },
  { "LBEQ ?", 0x1027, 12, 0, 0 },
  { "LBGE ?", 0x102C, 12, 0, 0 },
  { "LBGT ?", 0x102E, 12, 0, 0 },
  { "LBHI ?", 0x1022, 12, 0, 0 },
  { "LBHS ?", 0x1024, 12, 0, 0 },
  { "LBLE ?", 0x102F, 12, 0, 0 },
  { "LBLO ?", 0x1025, 12, 0, 0 },
  { "LBLS ?", 0x1023, 12, 0, 0 },
  { "LBLT ?", 0x102D, 12, 0, 0 },
  { "LBMI ?", 0x102B, 12, 0, 0 },
  { "LBNE ?", 0x1026, 12, 0, 0 },
  { "LBPL ?", 0x102A, 12, 0, 0 },
  { "LBRA ?", 0x16, 12, 0, 0 },
  { "LBRN ?", 0x1021, 12, 0, 0 },
  { "LBSR ?", 0x17, 12, 0, 0 },
  { "LBVC ?", 0x1028, 12, 0, 0 },
  { "LBVS ?", 0x1029, 12, 0, 0 },
  
  { "LDA #x", 0x86, 1, 0, 0 },
  { "LDA,X", 0xA6, 9, 0, B_(10000100) },
  { "LDA,Y", 0xA6, 9, 0, B_(10100100) },
  { "LDA,U", 0xA6, 9, 0, B_(11000100) },
  { "LDA,S", 0xA6, 9, 0, B_(11100100) },
  { "LDA A,X", 0xA6, 9, 0, B_(10000110) },
  { "LDA A,Y", 0xA6, 9, 0, B_(10100110) },
  { "LDA A,U", 0xA6, 9, 0, B_(11000110) },
  { "LDA A,S", 0xA6, 9, 0, B_(11100110) },
  { "LDA B,X", 0xA6, 9, 0, B_(10000101) },
  { "LDA B,Y", 0xA6, 9, 0, B_(10100101) },
  { "LDA B,U", 0xA6, 9, 0, B_(11000101) },
  { "LDA B,S", 0xA6, 9, 0, B_(11100101) },
  { "LDA D,X", 0xA6, 9, 0, B_(10001011) },
  { "LDA D,Y", 0xA6, 9, 0, B_(10101011) },
  { "LDA D,U", 0xA6, 9, 0, B_(11001011) },
  { "LDA D,S", 0xA6, 9, 0, B_(11101011) },
  { "LDA,X+", 0xA6, 9, 0, B_(10000000) },
  { "LDA,Y+", 0xA6, 9, 0, B_(10100000) },
  { "LDA,U+", 0xA6, 9, 0, B_(11000000) },
  { "LDA,S+", 0xA6, 9, 0, B_(11100000) },
  { "LDA,X++", 0xA6, 9, 0, B_(10000001) },
  { "LDA,Y++", 0xA6, 9, 0, B_(10100001) },
  { "LDA,U++", 0xA6, 9, 0, B_(11000001) },
  { "LDA,S++", 0xA6, 9, 0, B_(11100001) },
  { "LDA,-X", 0xA6, 9, 0, B_(10000010) },
  { "LDA,-Y", 0xA6, 9, 0, B_(10100010) },
  { "LDA,-U", 0xA6, 9, 0, B_(11000010) },
  { "LDA,-S", 0xA6, 9, 0, B_(11100010) },
  { "LDA,--X", 0xA6, 9, 0, B_(10000011) },
  { "LDA,--Y", 0xA6, 9, 0, B_(10100011) },
  { "LDA,--U", 0xA6, 9, 0, B_(11000011) },
  { "LDA,--S", 0xA6, 9, 0, B_(11100011) },
  { "LDA (,X)", 0xA6, 9, 0, B_(10010100) },
  { "LDA (,Y)", 0xA6, 9, 0, B_(10110100) },
  { "LDA (,U)", 0xA6, 9, 0, B_(11010100) },
  { "LDA (,S)", 0xA6, 9, 0, B_(11110100) },
  { "LDA (A,X)", 0xA6, 9, 0, B_(10010110) },
  { "LDA (A,Y)", 0xA6, 9, 0, B_(10110110) },
  { "LDA (A,U)", 0xA6, 9, 0, B_(11010110) },
  { "LDA (A,S)", 0xA6, 9, 0, B_(11110110) },
  { "LDA (B,X)", 0xA6, 9, 0, B_(10010101) },
  { "LDA (B,Y)", 0xA6, 9, 0, B_(10110101) },
  { "LDA (B,U)", 0xA6, 9, 0, B_(11010101) },
  { "LDA (B,S)", 0xA6, 9, 0, B_(11110101) },
  { "LDA (D,X)", 0xA6, 9, 0, B_(10011011) },
  { "LDA (D,Y)", 0xA6, 9, 0, B_(10111011) },
  { "LDA (D,U)", 0xA6, 9, 0, B_(11011011) },
  { "LDA (D,S)", 0xA6, 9, 0, B_(11111011) },
  { "LDA (,X++)", 0xA6, 9, 0, B_(10010001) },
  { "LDA (,Y++)", 0xA6, 9, 0, B_(10110001) },
  { "LDA (,U++)", 0xA6, 9, 0, B_(11010001) },
  { "LDA (,S++)", 0xA6, 9, 0, B_(11110001) },
  { "LDA (,--X)", 0xA6, 9, 0, B_(10010011) },
  { "LDA (,--Y)", 0xA6, 9, 0, B_(10110011) },
  { "LDA (,--U)", 0xA6, 9, 0, B_(11010011) },
  { "LDA (,--S)", 0xA6, 9, 0, B_(11110011) },
  { "LDA (x,X)", 0xA6, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LDA (x,Y)", 0xA6, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LDA (x,U)", 0xA6, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LDA (x,S)", 0xA6, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LDA (?,X)", 0xA6, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LDA (?,Y)", 0xA6, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LDA (?,U)", 0xA6, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LDA (?,S)", 0xA6, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LDA (x,PCR)", 0xA6, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LDA (?,PCR)", 0xA6, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LDA (?)", 0xA6, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LDA s,X", 0xA6, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LDA s,Y", 0xA6, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LDA s,U", 0xA6, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LDA s,S", 0xA6, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LDA x,X", 0xA6, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LDA x,Y", 0xA6, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LDA x,U", 0xA6, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LDA x,S", 0xA6, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LDA ?,X", 0xA6, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LDA ?,Y", 0xA6, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LDA ?,U", 0xA6, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LDA ?,S", 0xA6, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LDA x,PCR", 0xA6, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LDA ?,PCR", 0xA6, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "LDA x", 0x96, 4, 1, 0 },
  { "LDA ?", 0xB6, 2, 0, 0 },

  { "LDB #x", 0xC6, 1, 0, 0 },
  { "LDB,X", 0xE6, 9, 0, B_(10000100) },
  { "LDB,Y", 0xE6, 9, 0, B_(10100100) },
  { "LDB,U", 0xE6, 9, 0, B_(11000100) },
  { "LDB,S", 0xE6, 9, 0, B_(11100100) },
  { "LDB A,X", 0xE6, 9, 0, B_(10000110) },
  { "LDB A,Y", 0xE6, 9, 0, B_(10100110) },
  { "LDB A,U", 0xE6, 9, 0, B_(11000110) },
  { "LDB A,S", 0xE6, 9, 0, B_(11100110) },
  { "LDB B,X", 0xE6, 9, 0, B_(10000101) },
  { "LDB B,Y", 0xE6, 9, 0, B_(10100101) },
  { "LDB B,U", 0xE6, 9, 0, B_(11000101) },
  { "LDB B,S", 0xE6, 9, 0, B_(11100101) },
  { "LDB D,X", 0xE6, 9, 0, B_(10001011) },
  { "LDB D,Y", 0xE6, 9, 0, B_(10101011) },
  { "LDB D,U", 0xE6, 9, 0, B_(11001011) },
  { "LDB D,S", 0xE6, 9, 0, B_(11101011) },
  { "LDB,X+", 0xE6, 9, 0, B_(10000000) },
  { "LDB,Y+", 0xE6, 9, 0, B_(10100000) },
  { "LDB,U+", 0xE6, 9, 0, B_(11000000) },
  { "LDB,S+", 0xE6, 9, 0, B_(11100000) },
  { "LDB,X++", 0xE6, 9, 0, B_(10000001) },
  { "LDB,Y++", 0xE6, 9, 0, B_(10100001) },
  { "LDB,U++", 0xE6, 9, 0, B_(11000001) },
  { "LDB,S++", 0xE6, 9, 0, B_(11100001) },
  { "LDB,-X", 0xE6, 9, 0, B_(10000010) },
  { "LDB,-Y", 0xE6, 9, 0, B_(10100010) },
  { "LDB,-U", 0xE6, 9, 0, B_(11000010) },
  { "LDB,-S", 0xE6, 9, 0, B_(11100010) },
  { "LDB,--X", 0xE6, 9, 0, B_(10000011) },
  { "LDB,--Y", 0xE6, 9, 0, B_(10100011) },
  { "LDB,--U", 0xE6, 9, 0, B_(11000011) },
  { "LDB,--S", 0xE6, 9, 0, B_(11100011) },
  { "LDB (,X)", 0xE6, 9, 0, B_(10010100) },
  { "LDB (,Y)", 0xE6, 9, 0, B_(10110100) },
  { "LDB (,U)", 0xE6, 9, 0, B_(11010100) },
  { "LDB (,S)", 0xE6, 9, 0, B_(11110100) },
  { "LDB (A,X)", 0xE6, 9, 0, B_(10010110) },
  { "LDB (A,Y)", 0xE6, 9, 0, B_(10110110) },
  { "LDB (A,U)", 0xE6, 9, 0, B_(11010110) },
  { "LDB (A,S)", 0xE6, 9, 0, B_(11110110) },
  { "LDB (B,X)", 0xE6, 9, 0, B_(10010101) },
  { "LDB (B,Y)", 0xE6, 9, 0, B_(10110101) },
  { "LDB (B,U)", 0xE6, 9, 0, B_(11010101) },
  { "LDB (B,S)", 0xE6, 9, 0, B_(11110101) },
  { "LDB (D,X)", 0xE6, 9, 0, B_(10011011) },
  { "LDB (D,Y)", 0xE6, 9, 0, B_(10111011) },
  { "LDB (D,U)", 0xE6, 9, 0, B_(11011011) },
  { "LDB (D,S)", 0xE6, 9, 0, B_(11111011) },
  { "LDB (,X++)", 0xE6, 9, 0, B_(10010001) },
  { "LDB (,Y++)", 0xE6, 9, 0, B_(10110001) },
  { "LDB (,U++)", 0xE6, 9, 0, B_(11010001) },
  { "LDB (,S++)", 0xE6, 9, 0, B_(11110001) },
  { "LDB (,--X)", 0xE6, 9, 0, B_(10010011) },
  { "LDB (,--Y)", 0xE6, 9, 0, B_(10110011) },
  { "LDB (,--U)", 0xE6, 9, 0, B_(11010011) },
  { "LDB (,--S)", 0xE6, 9, 0, B_(11110011) },
  { "LDB (x,X)", 0xE6, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LDB (x,Y)", 0xE6, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LDB (x,U)", 0xE6, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LDB (x,S)", 0xE6, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LDB (?,X)", 0xE6, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LDB (?,Y)", 0xE6, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LDB (?,U)", 0xE6, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LDB (?,S)", 0xE6, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LDB (x,PCR)", 0xE6, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LDB (?,PCR)", 0xE6, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LDB (?)", 0xE6, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LDB s,X", 0xE6, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LDB s,Y", 0xE6, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LDB s,U", 0xE6, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LDB s,S", 0xE6, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LDB x,X", 0xE6, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LDB x,Y", 0xE6, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LDB x,U", 0xE6, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LDB x,S", 0xE6, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LDB ?,X", 0xE6, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LDB ?,Y", 0xE6, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LDB ?,U", 0xE6, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LDB ?,S", 0xE6, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LDB x,PCR", 0xE6, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LDB ?,PCR", 0xE6, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "LDB x", 0xD6, 4, 1, 0 },
  { "LDB ?", 0xF6, 2, 0, 0 },

  { "LDD #x", 0xCC, 1, 0, 0 },
  { "LDD,X", 0xEC, 9, 0, B_(10000100) },
  { "LDD,Y", 0xEC, 9, 0, B_(10100100) },
  { "LDD,U", 0xEC, 9, 0, B_(11000100) },
  { "LDD,S", 0xEC, 9, 0, B_(11100100) },
  { "LDD A,X", 0xEC, 9, 0, B_(10000110) },
  { "LDD A,Y", 0xEC, 9, 0, B_(10100110) },
  { "LDD A,U", 0xEC, 9, 0, B_(11000110) },
  { "LDD A,S", 0xEC, 9, 0, B_(11100110) },
  { "LDD B,X", 0xEC, 9, 0, B_(10000101) },
  { "LDD B,Y", 0xEC, 9, 0, B_(10100101) },
  { "LDD B,U", 0xEC, 9, 0, B_(11000101) },
  { "LDD B,S", 0xEC, 9, 0, B_(11100101) },
  { "LDD D,X", 0xEC, 9, 0, B_(10001011) },
  { "LDD D,Y", 0xEC, 9, 0, B_(10101011) },
  { "LDD D,U", 0xEC, 9, 0, B_(11001011) },
  { "LDD D,S", 0xEC, 9, 0, B_(11101011) },
  { "LDD,X+", 0xEC, 9, 0, B_(10000000) },
  { "LDD,Y+", 0xEC, 9, 0, B_(10100000) },
  { "LDD,U+", 0xEC, 9, 0, B_(11000000) },
  { "LDD,S+", 0xEC, 9, 0, B_(11100000) },
  { "LDD,X++", 0xEC, 9, 0, B_(10000001) },
  { "LDD,Y++", 0xEC, 9, 0, B_(10100001) },
  { "LDD,U++", 0xEC, 9, 0, B_(11000001) },
  { "LDD,S++", 0xEC, 9, 0, B_(11100001) },
  { "LDD,-X", 0xEC, 9, 0, B_(10000010) },
  { "LDD,-Y", 0xEC, 9, 0, B_(10100010) },
  { "LDD,-U", 0xEC, 9, 0, B_(11000010) },
  { "LDD,-S", 0xEC, 9, 0, B_(11100010) },
  { "LDD,--X", 0xEC, 9, 0, B_(10000011) },
  { "LDD,--Y", 0xEC, 9, 0, B_(10100011) },
  { "LDD,--U", 0xEC, 9, 0, B_(11000011) },
  { "LDD,--S", 0xEC, 9, 0, B_(11100011) },
  { "LDD (,X)", 0xEC, 9, 0, B_(10010100) },
  { "LDD (,Y)", 0xEC, 9, 0, B_(10110100) },
  { "LDD (,U)", 0xEC, 9, 0, B_(11010100) },
  { "LDD (,S)", 0xEC, 9, 0, B_(11110100) },
  { "LDD (A,X)", 0xEC, 9, 0, B_(10010110) },
  { "LDD (A,Y)", 0xEC, 9, 0, B_(10110110) },
  { "LDD (A,U)", 0xEC, 9, 0, B_(11010110) },
  { "LDD (A,S)", 0xEC, 9, 0, B_(11110110) },
  { "LDD (B,X)", 0xEC, 9, 0, B_(10010101) },
  { "LDD (B,Y)", 0xEC, 9, 0, B_(10110101) },
  { "LDD (B,U)", 0xEC, 9, 0, B_(11010101) },
  { "LDD (B,S)", 0xEC, 9, 0, B_(11110101) },
  { "LDD (D,X)", 0xEC, 9, 0, B_(10011011) },
  { "LDD (D,Y)", 0xEC, 9, 0, B_(10111011) },
  { "LDD (D,U)", 0xEC, 9, 0, B_(11011011) },
  { "LDD (D,S)", 0xEC, 9, 0, B_(11111011) },
  { "LDD (,X++)", 0xEC, 9, 0, B_(10010001) },
  { "LDD (,Y++)", 0xEC, 9, 0, B_(10110001) },
  { "LDD (,U++)", 0xEC, 9, 0, B_(11010001) },
  { "LDD (,S++)", 0xEC, 9, 0, B_(11110001) },
  { "LDD (,--X)", 0xEC, 9, 0, B_(10010011) },
  { "LDD (,--Y)", 0xEC, 9, 0, B_(10110011) },
  { "LDD (,--U)", 0xEC, 9, 0, B_(11010011) },
  { "LDD (,--S)", 0xEC, 9, 0, B_(11110011) },
  { "LDD (x,X)", 0xEC, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LDD (x,Y)", 0xEC, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LDD (x,U)", 0xEC, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LDD (x,S)", 0xEC, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LDD (?,X)", 0xEC, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LDD (?,Y)", 0xEC, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LDD (?,U)", 0xEC, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LDD (?,S)", 0xEC, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LDD (x,PCR)", 0xEC, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LDD (?,PCR)", 0xEC, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LDD (?)", 0xEC, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LDD s,X", 0xEC, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LDD s,Y", 0xEC, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LDD s,U", 0xEC, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LDD s,S", 0xEC, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LDD x,X", 0xEC, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LDD x,Y", 0xEC, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LDD x,U", 0xEC, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LDD x,S", 0xEC, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LDD ?,X", 0xEC, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LDD ?,Y", 0xEC, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LDD ?,U", 0xEC, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LDD ?,S", 0xEC, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LDD x,PCR", 0xEC, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LDD ?,PCR", 0xEC, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "LDD x", 0xDC, 4, 1, 0 },
  { "LDD ?", 0xFC, 2, 0, 0 },

  { "LDS #x", 0x10CE, 1, 0, 0 },
  { "LDS,X", 0x10EE, 9, 0, B_(10000100) },
  { "LDS,Y", 0x10EE, 9, 0, B_(10100100) },
  { "LDS,U", 0x10EE, 9, 0, B_(11000100) },
  { "LDS,S", 0x10EE, 9, 0, B_(11100100) },
  { "LDS A,X", 0x10EE, 9, 0, B_(10000110) },
  { "LDS A,Y", 0x10EE, 9, 0, B_(10100110) },
  { "LDS A,U", 0x10EE, 9, 0, B_(11000110) },
  { "LDS A,S", 0x10EE, 9, 0, B_(11100110) },
  { "LDS B,X", 0x10EE, 9, 0, B_(10000101) },
  { "LDS B,Y", 0x10EE, 9, 0, B_(10100101) },
  { "LDS B,U", 0x10EE, 9, 0, B_(11000101) },
  { "LDS B,S", 0x10EE, 9, 0, B_(11100101) },
  { "LDS D,X", 0x10EE, 9, 0, B_(10001011) },
  { "LDS D,Y", 0x10EE, 9, 0, B_(10101011) },
  { "LDS D,U", 0x10EE, 9, 0, B_(11001011) },
  { "LDS D,S", 0x10EE, 9, 0, B_(11101011) },
  { "LDS,X+", 0x10EE, 9, 0, B_(10000000) },
  { "LDS,Y+", 0x10EE, 9, 0, B_(10100000) },
  { "LDS,U+", 0x10EE, 9, 0, B_(11000000) },
  { "LDS,S+", 0x10EE, 9, 0, B_(11100000) },
  { "LDS,X++", 0x10EE, 9, 0, B_(10000001) },
  { "LDS,Y++", 0x10EE, 9, 0, B_(10100001) },
  { "LDS,U++", 0x10EE, 9, 0, B_(11000001) },
  { "LDS,S++", 0x10EE, 9, 0, B_(11100001) },
  { "LDS,-X", 0x10EE, 9, 0, B_(10000010) },
  { "LDS,-Y", 0x10EE, 9, 0, B_(10100010) },
  { "LDS,-U", 0x10EE, 9, 0, B_(11000010) },
  { "LDS,-S", 0x10EE, 9, 0, B_(11100010) },
  { "LDS,--X", 0x10EE, 9, 0, B_(10000011) },
  { "LDS,--Y", 0x10EE, 9, 0, B_(10100011) },
  { "LDS,--U", 0x10EE, 9, 0, B_(11000011) },
  { "LDS,--S", 0x10EE, 9, 0, B_(11100011) },
  { "LDS (,X)", 0x10EE, 9, 0, B_(10010100) },
  { "LDS (,Y)", 0x10EE, 9, 0, B_(10110100) },
  { "LDS (,U)", 0x10EE, 9, 0, B_(11010100) },
  { "LDS (,S)", 0x10EE, 9, 0, B_(11110100) },
  { "LDS (A,X)", 0x10EE, 9, 0, B_(10010110) },
  { "LDS (A,Y)", 0x10EE, 9, 0, B_(10110110) },
  { "LDS (A,U)", 0x10EE, 9, 0, B_(11010110) },
  { "LDS (A,S)", 0x10EE, 9, 0, B_(11110110) },
  { "LDS (B,X)", 0x10EE, 9, 0, B_(10010101) },
  { "LDS (B,Y)", 0x10EE, 9, 0, B_(10110101) },
  { "LDS (B,U)", 0x10EE, 9, 0, B_(11010101) },
  { "LDS (B,S)", 0x10EE, 9, 0, B_(11110101) },
  { "LDS (D,X)", 0x10EE, 9, 0, B_(10011011) },
  { "LDS (D,Y)", 0x10EE, 9, 0, B_(10111011) },
  { "LDS (D,U)", 0x10EE, 9, 0, B_(11011011) },
  { "LDS (D,S)", 0x10EE, 9, 0, B_(11111011) },
  { "LDS (,X++)", 0x10EE, 9, 0, B_(10010001) },
  { "LDS (,Y++)", 0x10EE, 9, 0, B_(10110001) },
  { "LDS (,U++)", 0x10EE, 9, 0, B_(11010001) },
  { "LDS (,S++)", 0x10EE, 9, 0, B_(11110001) },
  { "LDS (,--X)", 0x10EE, 9, 0, B_(10010011) },
  { "LDS (,--Y)", 0x10EE, 9, 0, B_(10110011) },
  { "LDS (,--U)", 0x10EE, 9, 0, B_(11010011) },
  { "LDS (,--S)", 0x10EE, 9, 0, B_(11110011) },
  { "LDS (x,X)", 0x10EE, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LDS (x,Y)", 0x10EE, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LDS (x,U)", 0x10EE, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LDS (x,S)", 0x10EE, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LDS (?,X)", 0x10EE, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LDS (?,Y)", 0x10EE, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LDS (?,U)", 0x10EE, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LDS (?,S)", 0x10EE, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LDS (x,PCR)", 0x10EE, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LDS (?,PCR)", 0x10EE, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LDS (?)", 0x10EE, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LDS s,X", 0x10EE, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LDS s,Y", 0x10EE, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LDS s,U", 0x10EE, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LDS s,S", 0x10EE, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LDS x,X", 0x10EE, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LDS x,Y", 0x10EE, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LDS x,U", 0x10EE, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LDS x,S", 0x10EE, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LDS ?,X", 0x10EE, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LDS ?,Y", 0x10EE, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LDS ?,U", 0x10EE, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LDS ?,S", 0x10EE, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LDS x,PCR", 0x10EE, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LDS ?,PCR", 0x10EE, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "LDS x", 0x10DE, 4, 1, 0 },
  { "LDS ?", 0x10FE, 2, 0, 0 },

  { "LDU #x", 0xCE, 1, 0, 0 },
  { "LDU,X", 0xEE, 9, 0, B_(10000100) },
  { "LDU,Y", 0xEE, 9, 0, B_(10100100) },
  { "LDU,U", 0xEE, 9, 0, B_(11000100) },
  { "LDU,S", 0xEE, 9, 0, B_(11100100) },
  { "LDU A,X", 0xEE, 9, 0, B_(10000110) },
  { "LDU A,Y", 0xEE, 9, 0, B_(10100110) },
  { "LDU A,U", 0xEE, 9, 0, B_(11000110) },
  { "LDU A,S", 0xEE, 9, 0, B_(11100110) },
  { "LDU B,X", 0xEE, 9, 0, B_(10000101) },
  { "LDU B,Y", 0xEE, 9, 0, B_(10100101) },
  { "LDU B,U", 0xEE, 9, 0, B_(11000101) },
  { "LDU B,S", 0xEE, 9, 0, B_(11100101) },
  { "LDU D,X", 0xEE, 9, 0, B_(10001011) },
  { "LDU D,Y", 0xEE, 9, 0, B_(10101011) },
  { "LDU D,U", 0xEE, 9, 0, B_(11001011) },
  { "LDU D,S", 0xEE, 9, 0, B_(11101011) },
  { "LDU,X+", 0xEE, 9, 0, B_(10000000) },
  { "LDU,Y+", 0xEE, 9, 0, B_(10100000) },
  { "LDU,U+", 0xEE, 9, 0, B_(11000000) },
  { "LDU,S+", 0xEE, 9, 0, B_(11100000) },
  { "LDU,X++", 0xEE, 9, 0, B_(10000001) },
  { "LDU,Y++", 0xEE, 9, 0, B_(10100001) },
  { "LDU,U++", 0xEE, 9, 0, B_(11000001) },
  { "LDU,S++", 0xEE, 9, 0, B_(11100001) },
  { "LDU,-X", 0xEE, 9, 0, B_(10000010) },
  { "LDU,-Y", 0xEE, 9, 0, B_(10100010) },
  { "LDU,-U", 0xEE, 9, 0, B_(11000010) },
  { "LDU,-S", 0xEE, 9, 0, B_(11100010) },
  { "LDU,--X", 0xEE, 9, 0, B_(10000011) },
  { "LDU,--Y", 0xEE, 9, 0, B_(10100011) },
  { "LDU,--U", 0xEE, 9, 0, B_(11000011) },
  { "LDU,--S", 0xEE, 9, 0, B_(11100011) },
  { "LDU (,X)", 0xEE, 9, 0, B_(10010100) },
  { "LDU (,Y)", 0xEE, 9, 0, B_(10110100) },
  { "LDU (,U)", 0xEE, 9, 0, B_(11010100) },
  { "LDU (,S)", 0xEE, 9, 0, B_(11110100) },
  { "LDU (A,X)", 0xEE, 9, 0, B_(10010110) },
  { "LDU (A,Y)", 0xEE, 9, 0, B_(10110110) },
  { "LDU (A,U)", 0xEE, 9, 0, B_(11010110) },
  { "LDU (A,S)", 0xEE, 9, 0, B_(11110110) },
  { "LDU (B,X)", 0xEE, 9, 0, B_(10010101) },
  { "LDU (B,Y)", 0xEE, 9, 0, B_(10110101) },
  { "LDU (B,U)", 0xEE, 9, 0, B_(11010101) },
  { "LDU (B,S)", 0xEE, 9, 0, B_(11110101) },
  { "LDU (D,X)", 0xEE, 9, 0, B_(10011011) },
  { "LDU (D,Y)", 0xEE, 9, 0, B_(10111011) },
  { "LDU (D,U)", 0xEE, 9, 0, B_(11011011) },
  { "LDU (D,S)", 0xEE, 9, 0, B_(11111011) },
  { "LDU (,X++)", 0xEE, 9, 0, B_(10010001) },
  { "LDU (,Y++)", 0xEE, 9, 0, B_(10110001) },
  { "LDU (,U++)", 0xEE, 9, 0, B_(11010001) },
  { "LDU (,S++)", 0xEE, 9, 0, B_(11110001) },
  { "LDU (,--X)", 0xEE, 9, 0, B_(10010011) },
  { "LDU (,--Y)", 0xEE, 9, 0, B_(10110011) },
  { "LDU (,--U)", 0xEE, 9, 0, B_(11010011) },
  { "LDU (,--S)", 0xEE, 9, 0, B_(11110011) },
  { "LDU (x,X)", 0xEE, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LDU (x,Y)", 0xEE, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LDU (x,U)", 0xEE, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LDU (x,S)", 0xEE, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LDU (?,X)", 0xEE, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LDU (?,Y)", 0xEE, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LDU (?,U)", 0xEE, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LDU (?,S)", 0xEE, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LDU (x,PCR)", 0xEE, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LDU (?,PCR)", 0xEE, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LDU (?)", 0xEE, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LDU s,X", 0xEE, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LDU s,Y", 0xEE, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LDU s,U", 0xEE, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LDU s,S", 0xEE, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LDU x,X", 0xEE, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LDU x,Y", 0xEE, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LDU x,U", 0xEE, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LDU x,S", 0xEE, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LDU ?,X", 0xEE, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LDU ?,Y", 0xEE, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LDU ?,U", 0xEE, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LDU ?,S", 0xEE, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LDU x,PCR", 0xEE, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LDU ?,PCR", 0xEE, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "LDU x", 0xDE, 4, 1, 0 },
  { "LDU ?", 0xFE, 2, 0, 0 },

  { "LDX #x", 0x8E, 1, 0, 0 },
  { "LDX,X", 0xAE, 9, 0, B_(10000100) },
  { "LDX,Y", 0xAE, 9, 0, B_(10100100) },
  { "LDX,U", 0xAE, 9, 0, B_(11000100) },
  { "LDX,S", 0xAE, 9, 0, B_(11100100) },
  { "LDX A,X", 0xAE, 9, 0, B_(10000110) },
  { "LDX A,Y", 0xAE, 9, 0, B_(10100110) },
  { "LDX A,U", 0xAE, 9, 0, B_(11000110) },
  { "LDX A,S", 0xAE, 9, 0, B_(11100110) },
  { "LDX B,X", 0xAE, 9, 0, B_(10000101) },
  { "LDX B,Y", 0xAE, 9, 0, B_(10100101) },
  { "LDX B,U", 0xAE, 9, 0, B_(11000101) },
  { "LDX B,S", 0xAE, 9, 0, B_(11100101) },
  { "LDX D,X", 0xAE, 9, 0, B_(10001011) },
  { "LDX D,Y", 0xAE, 9, 0, B_(10101011) },
  { "LDX D,U", 0xAE, 9, 0, B_(11001011) },
  { "LDX D,S", 0xAE, 9, 0, B_(11101011) },
  { "LDX,X+", 0xAE, 9, 0, B_(10000000) },
  { "LDX,Y+", 0xAE, 9, 0, B_(10100000) },
  { "LDX,U+", 0xAE, 9, 0, B_(11000000) },
  { "LDX,S+", 0xAE, 9, 0, B_(11100000) },
  { "LDX,X++", 0xAE, 9, 0, B_(10000001) },
  { "LDX,Y++", 0xAE, 9, 0, B_(10100001) },
  { "LDX,U++", 0xAE, 9, 0, B_(11000001) },
  { "LDX,S++", 0xAE, 9, 0, B_(11100001) },
  { "LDX,-X", 0xAE, 9, 0, B_(10000010) },
  { "LDX,-Y", 0xAE, 9, 0, B_(10100010) },
  { "LDX,-U", 0xAE, 9, 0, B_(11000010) },
  { "LDX,-S", 0xAE, 9, 0, B_(11100010) },
  { "LDX,--X", 0xAE, 9, 0, B_(10000011) },
  { "LDX,--Y", 0xAE, 9, 0, B_(10100011) },
  { "LDX,--U", 0xAE, 9, 0, B_(11000011) },
  { "LDX,--S", 0xAE, 9, 0, B_(11100011) },
  { "LDX (,X)", 0xAE, 9, 0, B_(10010100) },
  { "LDX (,Y)", 0xAE, 9, 0, B_(10110100) },
  { "LDX (,U)", 0xAE, 9, 0, B_(11010100) },
  { "LDX (,S)", 0xAE, 9, 0, B_(11110100) },
  { "LDX (A,X)", 0xAE, 9, 0, B_(10010110) },
  { "LDX (A,Y)", 0xAE, 9, 0, B_(10110110) },
  { "LDX (A,U)", 0xAE, 9, 0, B_(11010110) },
  { "LDX (A,S)", 0xAE, 9, 0, B_(11110110) },
  { "LDX (B,X)", 0xAE, 9, 0, B_(10010101) },
  { "LDX (B,Y)", 0xAE, 9, 0, B_(10110101) },
  { "LDX (B,U)", 0xAE, 9, 0, B_(11010101) },
  { "LDX (B,S)", 0xAE, 9, 0, B_(11110101) },
  { "LDX (D,X)", 0xAE, 9, 0, B_(10011011) },
  { "LDX (D,Y)", 0xAE, 9, 0, B_(10111011) },
  { "LDX (D,U)", 0xAE, 9, 0, B_(11011011) },
  { "LDX (D,S)", 0xAE, 9, 0, B_(11111011) },
  { "LDX (,X++)", 0xAE, 9, 0, B_(10010001) },
  { "LDX (,Y++)", 0xAE, 9, 0, B_(10110001) },
  { "LDX (,U++)", 0xAE, 9, 0, B_(11010001) },
  { "LDX (,S++)", 0xAE, 9, 0, B_(11110001) },
  { "LDX (,--X)", 0xAE, 9, 0, B_(10010011) },
  { "LDX (,--Y)", 0xAE, 9, 0, B_(10110011) },
  { "LDX (,--U)", 0xAE, 9, 0, B_(11010011) },
  { "LDX (,--S)", 0xAE, 9, 0, B_(11110011) },
  { "LDX (x,X)", 0xAE, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LDX (x,Y)", 0xAE, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LDX (x,U)", 0xAE, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LDX (x,S)", 0xAE, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LDX (?,X)", 0xAE, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LDX (?,Y)", 0xAE, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LDX (?,U)", 0xAE, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LDX (?,S)", 0xAE, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LDX (x,PCR)", 0xAE, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LDX (?,PCR)", 0xAE, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LDX (?)", 0xAE, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LDX s,X", 0xAE, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LDX s,Y", 0xAE, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LDX s,U", 0xAE, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LDX s,S", 0xAE, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LDX x,X", 0xAE, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LDX x,Y", 0xAE, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LDX x,U", 0xAE, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LDX x,S", 0xAE, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LDX ?,X", 0xAE, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LDX ?,Y", 0xAE, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LDX ?,U", 0xAE, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LDX ?,S", 0xAE, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LDX x,PCR", 0xAE, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LDX ?,PCR", 0xAE, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "LDX x", 0x9E, 4, 1, 0 },
  { "LDX ?", 0xBE, 2, 0, 0 },

  { "LDY #x", 0x108E, 1, 0, 0 },
  { "LDY,X", 0x10AE, 9, 0, B_(10000100) },
  { "LDY,Y", 0x10AE, 9, 0, B_(10100100) },
  { "LDY,U", 0x10AE, 9, 0, B_(11000100) },
  { "LDY,S", 0x10AE, 9, 0, B_(11100100) },
  { "LDY A,X", 0x10AE, 9, 0, B_(10000110) },
  { "LDY A,Y", 0x10AE, 9, 0, B_(10100110) },
  { "LDY A,U", 0x10AE, 9, 0, B_(11000110) },
  { "LDY A,S", 0x10AE, 9, 0, B_(11100110) },
  { "LDY B,X", 0x10AE, 9, 0, B_(10000101) },
  { "LDY B,Y", 0x10AE, 9, 0, B_(10100101) },
  { "LDY B,U", 0x10AE, 9, 0, B_(11000101) },
  { "LDY B,S", 0x10AE, 9, 0, B_(11100101) },
  { "LDY D,X", 0x10AE, 9, 0, B_(10001011) },
  { "LDY D,Y", 0x10AE, 9, 0, B_(10101011) },
  { "LDY D,U", 0x10AE, 9, 0, B_(11001011) },
  { "LDY D,S", 0x10AE, 9, 0, B_(11101011) },
  { "LDY,X+", 0x10AE, 9, 0, B_(10000000) },
  { "LDY,Y+", 0x10AE, 9, 0, B_(10100000) },
  { "LDY,U+", 0x10AE, 9, 0, B_(11000000) },
  { "LDY,S+", 0x10AE, 9, 0, B_(11100000) },
  { "LDY,X++", 0x10AE, 9, 0, B_(10000001) },
  { "LDY,Y++", 0x10AE, 9, 0, B_(10100001) },
  { "LDY,U++", 0x10AE, 9, 0, B_(11000001) },
  { "LDY,S++", 0x10AE, 9, 0, B_(11100001) },
  { "LDY,-X", 0x10AE, 9, 0, B_(10000010) },
  { "LDY,-Y", 0x10AE, 9, 0, B_(10100010) },
  { "LDY,-U", 0x10AE, 9, 0, B_(11000010) },
  { "LDY,-S", 0x10AE, 9, 0, B_(11100010) },
  { "LDY,--X", 0x10AE, 9, 0, B_(10000011) },
  { "LDY,--Y", 0x10AE, 9, 0, B_(10100011) },
  { "LDY,--U", 0x10AE, 9, 0, B_(11000011) },
  { "LDY,--S", 0x10AE, 9, 0, B_(11100011) },
  { "LDY (,X)", 0x10AE, 9, 0, B_(10010100) },
  { "LDY (,Y)", 0x10AE, 9, 0, B_(10110100) },
  { "LDY (,U)", 0x10AE, 9, 0, B_(11010100) },
  { "LDY (,S)", 0x10AE, 9, 0, B_(11110100) },
  { "LDY (A,X)", 0x10AE, 9, 0, B_(10010110) },
  { "LDY (A,Y)", 0x10AE, 9, 0, B_(10110110) },
  { "LDY (A,U)", 0x10AE, 9, 0, B_(11010110) },
  { "LDY (A,S)", 0x10AE, 9, 0, B_(11110110) },
  { "LDY (B,X)", 0x10AE, 9, 0, B_(10010101) },
  { "LDY (B,Y)", 0x10AE, 9, 0, B_(10110101) },
  { "LDY (B,U)", 0x10AE, 9, 0, B_(11010101) },
  { "LDY (B,S)", 0x10AE, 9, 0, B_(11110101) },
  { "LDY (D,X)", 0x10AE, 9, 0, B_(10011011) },
  { "LDY (D,Y)", 0x10AE, 9, 0, B_(10111011) },
  { "LDY (D,U)", 0x10AE, 9, 0, B_(11011011) },
  { "LDY (D,S)", 0x10AE, 9, 0, B_(11111011) },
  { "LDY (,X++)", 0x10AE, 9, 0, B_(10010001) },
  { "LDY (,Y++)", 0x10AE, 9, 0, B_(10110001) },
  { "LDY (,U++)", 0x10AE, 9, 0, B_(11010001) },
  { "LDY (,S++)", 0x10AE, 9, 0, B_(11110001) },
  { "LDY (,--X)", 0x10AE, 9, 0, B_(10010011) },
  { "LDY (,--Y)", 0x10AE, 9, 0, B_(10110011) },
  { "LDY (,--U)", 0x10AE, 9, 0, B_(11010011) },
  { "LDY (,--S)", 0x10AE, 9, 0, B_(11110011) },
  { "LDY (x,X)", 0x10AE, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LDY (x,Y)", 0x10AE, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LDY (x,U)", 0x10AE, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LDY (x,S)", 0x10AE, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LDY (?,X)", 0x10AE, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LDY (?,Y)", 0x10AE, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LDY (?,U)", 0x10AE, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LDY (?,S)", 0x10AE, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LDY (x,PCR)", 0x10AE, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LDY (?,PCR)", 0x10AE, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LDY (?)", 0x10AE, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LDY s,X", 0x10AE, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LDY s,Y", 0x10AE, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LDY s,U", 0x10AE, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LDY s,S", 0x10AE, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LDY x,X", 0x10AE, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LDY x,Y", 0x10AE, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LDY x,U", 0x10AE, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LDY x,S", 0x10AE, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LDY ?,X", 0x10AE, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LDY ?,Y", 0x10AE, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LDY ?,U", 0x10AE, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LDY ?,S", 0x10AE, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LDY x,PCR", 0x10AE, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LDY ?,PCR", 0x10AE, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "LDY x", 0x109E, 4, 1, 0 },
  { "LDY ?", 0x10BE, 2, 0, 0 },

  { "LEAS,X", 0x32, 9, 0, B_(10000100) },
  { "LEAS,Y", 0x32, 9, 0, B_(10100100) },
  { "LEAS,U", 0x32, 9, 0, B_(11000100) },
  { "LEAS,S", 0x32, 9, 0, B_(11100100) },
  { "LEAS A,X", 0x32, 9, 0, B_(10000110) },
  { "LEAS A,Y", 0x32, 9, 0, B_(10100110) },
  { "LEAS A,U", 0x32, 9, 0, B_(11000110) },
  { "LEAS A,S", 0x32, 9, 0, B_(11100110) },
  { "LEAS B,X", 0x32, 9, 0, B_(10000101) },
  { "LEAS B,Y", 0x32, 9, 0, B_(10100101) },
  { "LEAS B,U", 0x32, 9, 0, B_(11000101) },
  { "LEAS B,S", 0x32, 9, 0, B_(11100101) },
  { "LEAS D,X", 0x32, 9, 0, B_(10001011) },
  { "LEAS D,Y", 0x32, 9, 0, B_(10101011) },
  { "LEAS D,U", 0x32, 9, 0, B_(11001011) },
  { "LEAS D,S", 0x32, 9, 0, B_(11101011) },
  { "LEAS,X+", 0x32, 9, 0, B_(10000000) },
  { "LEAS,Y+", 0x32, 9, 0, B_(10100000) },
  { "LEAS,U+", 0x32, 9, 0, B_(11000000) },
  { "LEAS,S+", 0x32, 9, 0, B_(11100000) },
  { "LEAS,X++", 0x32, 9, 0, B_(10000001) },
  { "LEAS,Y++", 0x32, 9, 0, B_(10100001) },
  { "LEAS,U++", 0x32, 9, 0, B_(11000001) },
  { "LEAS,S++", 0x32, 9, 0, B_(11100001) },
  { "LEAS,-X", 0x32, 9, 0, B_(10000010) },
  { "LEAS,-Y", 0x32, 9, 0, B_(10100010) },
  { "LEAS,-U", 0x32, 9, 0, B_(11000010) },
  { "LEAS,-S", 0x32, 9, 0, B_(11100010) },
  { "LEAS,--X", 0x32, 9, 0, B_(10000011) },
  { "LEAS,--Y", 0x32, 9, 0, B_(10100011) },
  { "LEAS,--U", 0x32, 9, 0, B_(11000011) },
  { "LEAS,--S", 0x32, 9, 0, B_(11100011) },
  { "LEAS (,X)", 0x32, 9, 0, B_(10010100) },
  { "LEAS (,Y)", 0x32, 9, 0, B_(10110100) },
  { "LEAS (,U)", 0x32, 9, 0, B_(11010100) },
  { "LEAS (,S)", 0x32, 9, 0, B_(11110100) },
  { "LEAS (A,X)", 0x32, 9, 0, B_(10010110) },
  { "LEAS (A,Y)", 0x32, 9, 0, B_(10110110) },
  { "LEAS (A,U)", 0x32, 9, 0, B_(11010110) },
  { "LEAS (A,S)", 0x32, 9, 0, B_(11110110) },
  { "LEAS (B,X)", 0x32, 9, 0, B_(10010101) },
  { "LEAS (B,Y)", 0x32, 9, 0, B_(10110101) },
  { "LEAS (B,U)", 0x32, 9, 0, B_(11010101) },
  { "LEAS (B,S)", 0x32, 9, 0, B_(11110101) },
  { "LEAS (D,X)", 0x32, 9, 0, B_(10011011) },
  { "LEAS (D,Y)", 0x32, 9, 0, B_(10111011) },
  { "LEAS (D,U)", 0x32, 9, 0, B_(11011011) },
  { "LEAS (D,S)", 0x32, 9, 0, B_(11111011) },
  { "LEAS (,X++)", 0x32, 9, 0, B_(10010001) },
  { "LEAS (,Y++)", 0x32, 9, 0, B_(10110001) },
  { "LEAS (,U++)", 0x32, 9, 0, B_(11010001) },
  { "LEAS (,S++)", 0x32, 9, 0, B_(11110001) },
  { "LEAS (,--X)", 0x32, 9, 0, B_(10010011) },
  { "LEAS (,--Y)", 0x32, 9, 0, B_(10110011) },
  { "LEAS (,--U)", 0x32, 9, 0, B_(11010011) },
  { "LEAS (,--S)", 0x32, 9, 0, B_(11110011) },
  { "LEAS (x,X)", 0x32, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LEAS (x,Y)", 0x32, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LEAS (x,U)", 0x32, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LEAS (x,S)", 0x32, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LEAS (?,X)", 0x32, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LEAS (?,Y)", 0x32, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LEAS (?,U)", 0x32, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LEAS (?,S)", 0x32, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LEAS (x,PCR)", 0x32, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LEAS (?,PCR)", 0x32, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LEAS (?)", 0x32, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LEAS s,X", 0x32, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LEAS s,Y", 0x32, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LEAS s,U", 0x32, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LEAS s,S", 0x32, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LEAS x,X", 0x32, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LEAS x,Y", 0x32, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LEAS x,U", 0x32, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LEAS x,S", 0x32, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LEAS ?,X", 0x32, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LEAS ?,Y", 0x32, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LEAS ?,U", 0x32, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LEAS ?,S", 0x32, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LEAS x,PCR", 0x32, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LEAS ?,PCR", 0x32, 8, 0, B_(10001101) }, /* 16-bit offset */

  { "LEAU,X", 0x33, 9, 0, B_(10000100) },
  { "LEAU,Y", 0x33, 9, 0, B_(10100100) },
  { "LEAU,U", 0x33, 9, 0, B_(11000100) },
  { "LEAU,S", 0x33, 9, 0, B_(11100100) },
  { "LEAU A,X", 0x33, 9, 0, B_(10000110) },
  { "LEAU A,Y", 0x33, 9, 0, B_(10100110) },
  { "LEAU A,U", 0x33, 9, 0, B_(11000110) },
  { "LEAU A,S", 0x33, 9, 0, B_(11100110) },
  { "LEAU B,X", 0x33, 9, 0, B_(10000101) },
  { "LEAU B,Y", 0x33, 9, 0, B_(10100101) },
  { "LEAU B,U", 0x33, 9, 0, B_(11000101) },
  { "LEAU B,S", 0x33, 9, 0, B_(11100101) },
  { "LEAU D,X", 0x33, 9, 0, B_(10001011) },
  { "LEAU D,Y", 0x33, 9, 0, B_(10101011) },
  { "LEAU D,U", 0x33, 9, 0, B_(11001011) },
  { "LEAU D,S", 0x33, 9, 0, B_(11101011) },
  { "LEAU,X+", 0x33, 9, 0, B_(10000000) },
  { "LEAU,Y+", 0x33, 9, 0, B_(10100000) },
  { "LEAU,U+", 0x33, 9, 0, B_(11000000) },
  { "LEAU,S+", 0x33, 9, 0, B_(11100000) },
  { "LEAU,X++", 0x33, 9, 0, B_(10000001) },
  { "LEAU,Y++", 0x33, 9, 0, B_(10100001) },
  { "LEAU,U++", 0x33, 9, 0, B_(11000001) },
  { "LEAU,S++", 0x33, 9, 0, B_(11100001) },
  { "LEAU,-X", 0x33, 9, 0, B_(10000010) },
  { "LEAU,-Y", 0x33, 9, 0, B_(10100010) },
  { "LEAU,-U", 0x33, 9, 0, B_(11000010) },
  { "LEAU,-S", 0x33, 9, 0, B_(11100010) },
  { "LEAU,--X", 0x33, 9, 0, B_(10000011) },
  { "LEAU,--Y", 0x33, 9, 0, B_(10100011) },
  { "LEAU,--U", 0x33, 9, 0, B_(11000011) },
  { "LEAU,--S", 0x33, 9, 0, B_(11100011) },
  { "LEAU (,X)", 0x33, 9, 0, B_(10010100) },
  { "LEAU (,Y)", 0x33, 9, 0, B_(10110100) },
  { "LEAU (,U)", 0x33, 9, 0, B_(11010100) },
  { "LEAU (,S)", 0x33, 9, 0, B_(11110100) },
  { "LEAU (A,X)", 0x33, 9, 0, B_(10010110) },
  { "LEAU (A,Y)", 0x33, 9, 0, B_(10110110) },
  { "LEAU (A,U)", 0x33, 9, 0, B_(11010110) },
  { "LEAU (A,S)", 0x33, 9, 0, B_(11110110) },
  { "LEAU (B,X)", 0x33, 9, 0, B_(10010101) },
  { "LEAU (B,Y)", 0x33, 9, 0, B_(10110101) },
  { "LEAU (B,U)", 0x33, 9, 0, B_(11010101) },
  { "LEAU (B,S)", 0x33, 9, 0, B_(11110101) },
  { "LEAU (D,X)", 0x33, 9, 0, B_(10011011) },
  { "LEAU (D,Y)", 0x33, 9, 0, B_(10111011) },
  { "LEAU (D,U)", 0x33, 9, 0, B_(11011011) },
  { "LEAU (D,S)", 0x33, 9, 0, B_(11111011) },
  { "LEAU (,X++)", 0x33, 9, 0, B_(10010001) },
  { "LEAU (,Y++)", 0x33, 9, 0, B_(10110001) },
  { "LEAU (,U++)", 0x33, 9, 0, B_(11010001) },
  { "LEAU (,S++)", 0x33, 9, 0, B_(11110001) },
  { "LEAU (,--X)", 0x33, 9, 0, B_(10010011) },
  { "LEAU (,--Y)", 0x33, 9, 0, B_(10110011) },
  { "LEAU (,--U)", 0x33, 9, 0, B_(11010011) },
  { "LEAU (,--S)", 0x33, 9, 0, B_(11110011) },
  { "LEAU (x,X)", 0x33, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LEAU (x,Y)", 0x33, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LEAU (x,U)", 0x33, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LEAU (x,S)", 0x33, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LEAU (?,X)", 0x33, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LEAU (?,Y)", 0x33, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LEAU (?,U)", 0x33, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LEAU (?,S)", 0x33, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LEAU (x,PCR)", 0x33, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LEAU (?,PCR)", 0x33, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LEAU (?)", 0x33, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LEAU s,X", 0x33, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LEAU s,Y", 0x33, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LEAU s,U", 0x33, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LEAU s,S", 0x33, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LEAU x,X", 0x33, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LEAU x,Y", 0x33, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LEAU x,U", 0x33, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LEAU x,S", 0x33, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LEAU ?,X", 0x33, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LEAU ?,Y", 0x33, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LEAU ?,U", 0x33, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LEAU ?,S", 0x33, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LEAU x,PCR", 0x33, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LEAU ?,PCR", 0x33, 8, 0, B_(10001101) }, /* 16-bit offset */

  { "LEAX,X", 0x30, 9, 0, B_(10000100) },
  { "LEAX,Y", 0x30, 9, 0, B_(10100100) },
  { "LEAX,U", 0x30, 9, 0, B_(11000100) },
  { "LEAX,S", 0x30, 9, 0, B_(11100100) },
  { "LEAX A,X", 0x30, 9, 0, B_(10000110) },
  { "LEAX A,Y", 0x30, 9, 0, B_(10100110) },
  { "LEAX A,U", 0x30, 9, 0, B_(11000110) },
  { "LEAX A,S", 0x30, 9, 0, B_(11100110) },
  { "LEAX B,X", 0x30, 9, 0, B_(10000101) },
  { "LEAX B,Y", 0x30, 9, 0, B_(10100101) },
  { "LEAX B,U", 0x30, 9, 0, B_(11000101) },
  { "LEAX B,S", 0x30, 9, 0, B_(11100101) },
  { "LEAX D,X", 0x30, 9, 0, B_(10001011) },
  { "LEAX D,Y", 0x30, 9, 0, B_(10101011) },
  { "LEAX D,U", 0x30, 9, 0, B_(11001011) },
  { "LEAX D,S", 0x30, 9, 0, B_(11101011) },
  { "LEAX,X+", 0x30, 9, 0, B_(10000000) },
  { "LEAX,Y+", 0x30, 9, 0, B_(10100000) },
  { "LEAX,U+", 0x30, 9, 0, B_(11000000) },
  { "LEAX,S+", 0x30, 9, 0, B_(11100000) },
  { "LEAX,X++", 0x30, 9, 0, B_(10000001) },
  { "LEAX,Y++", 0x30, 9, 0, B_(10100001) },
  { "LEAX,U++", 0x30, 9, 0, B_(11000001) },
  { "LEAX,S++", 0x30, 9, 0, B_(11100001) },
  { "LEAX,-X", 0x30, 9, 0, B_(10000010) },
  { "LEAX,-Y", 0x30, 9, 0, B_(10100010) },
  { "LEAX,-U", 0x30, 9, 0, B_(11000010) },
  { "LEAX,-S", 0x30, 9, 0, B_(11100010) },
  { "LEAX,--X", 0x30, 9, 0, B_(10000011) },
  { "LEAX,--Y", 0x30, 9, 0, B_(10100011) },
  { "LEAX,--U", 0x30, 9, 0, B_(11000011) },
  { "LEAX,--S", 0x30, 9, 0, B_(11100011) },
  { "LEAX (,X)", 0x30, 9, 0, B_(10010100) },
  { "LEAX (,Y)", 0x30, 9, 0, B_(10110100) },
  { "LEAX (,U)", 0x30, 9, 0, B_(11010100) },
  { "LEAX (,S)", 0x30, 9, 0, B_(11110100) },
  { "LEAX (A,X)", 0x30, 9, 0, B_(10010110) },
  { "LEAX (A,Y)", 0x30, 9, 0, B_(10110110) },
  { "LEAX (A,U)", 0x30, 9, 0, B_(11010110) },
  { "LEAX (A,S)", 0x30, 9, 0, B_(11110110) },
  { "LEAX (B,X)", 0x30, 9, 0, B_(10010101) },
  { "LEAX (B,Y)", 0x30, 9, 0, B_(10110101) },
  { "LEAX (B,U)", 0x30, 9, 0, B_(11010101) },
  { "LEAX (B,S)", 0x30, 9, 0, B_(11110101) },
  { "LEAX (D,X)", 0x30, 9, 0, B_(10011011) },
  { "LEAX (D,Y)", 0x30, 9, 0, B_(10111011) },
  { "LEAX (D,U)", 0x30, 9, 0, B_(11011011) },
  { "LEAX (D,S)", 0x30, 9, 0, B_(11111011) },
  { "LEAX (,X++)", 0x30, 9, 0, B_(10010001) },
  { "LEAX (,Y++)", 0x30, 9, 0, B_(10110001) },
  { "LEAX (,U++)", 0x30, 9, 0, B_(11010001) },
  { "LEAX (,S++)", 0x30, 9, 0, B_(11110001) },
  { "LEAX (,--X)", 0x30, 9, 0, B_(10010011) },
  { "LEAX (,--Y)", 0x30, 9, 0, B_(10110011) },
  { "LEAX (,--U)", 0x30, 9, 0, B_(11010011) },
  { "LEAX (,--S)", 0x30, 9, 0, B_(11110011) },
  { "LEAX (x,X)", 0x30, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LEAX (x,Y)", 0x30, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LEAX (x,U)", 0x30, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LEAX (x,S)", 0x30, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LEAX (?,X)", 0x30, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LEAX (?,Y)", 0x30, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LEAX (?,U)", 0x30, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LEAX (?,S)", 0x30, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LEAX (x,PCR)", 0x30, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LEAX (?,PCR)", 0x30, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LEAX (?)", 0x30, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LEAX s,X", 0x30, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LEAX s,Y", 0x30, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LEAX s,U", 0x30, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LEAX s,S", 0x30, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LEAX x,X", 0x30, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LEAX x,Y", 0x30, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LEAX x,U", 0x30, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LEAX x,S", 0x30, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LEAX ?,X", 0x30, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LEAX ?,Y", 0x30, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LEAX ?,U", 0x30, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LEAX ?,S", 0x30, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LEAX x,PCR", 0x30, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LEAX ?,PCR", 0x30, 8, 0, B_(10001101) }, /* 16-bit offset */

  { "LEAY,X", 0x31, 9, 0, B_(10000100) },
  { "LEAY,Y", 0x31, 9, 0, B_(10100100) },
  { "LEAY,U", 0x31, 9, 0, B_(11000100) },
  { "LEAY,S", 0x31, 9, 0, B_(11100100) },
  { "LEAY A,X", 0x31, 9, 0, B_(10000110) },
  { "LEAY A,Y", 0x31, 9, 0, B_(10100110) },
  { "LEAY A,U", 0x31, 9, 0, B_(11000110) },
  { "LEAY A,S", 0x31, 9, 0, B_(11100110) },
  { "LEAY B,X", 0x31, 9, 0, B_(10000101) },
  { "LEAY B,Y", 0x31, 9, 0, B_(10100101) },
  { "LEAY B,U", 0x31, 9, 0, B_(11000101) },
  { "LEAY B,S", 0x31, 9, 0, B_(11100101) },
  { "LEAY D,X", 0x31, 9, 0, B_(10001011) },
  { "LEAY D,Y", 0x31, 9, 0, B_(10101011) },
  { "LEAY D,U", 0x31, 9, 0, B_(11001011) },
  { "LEAY D,S", 0x31, 9, 0, B_(11101011) },
  { "LEAY,X+", 0x31, 9, 0, B_(10000000) },
  { "LEAY,Y+", 0x31, 9, 0, B_(10100000) },
  { "LEAY,U+", 0x31, 9, 0, B_(11000000) },
  { "LEAY,S+", 0x31, 9, 0, B_(11100000) },
  { "LEAY,X++", 0x31, 9, 0, B_(10000001) },
  { "LEAY,Y++", 0x31, 9, 0, B_(10100001) },
  { "LEAY,U++", 0x31, 9, 0, B_(11000001) },
  { "LEAY,S++", 0x31, 9, 0, B_(11100001) },
  { "LEAY,-X", 0x31, 9, 0, B_(10000010) },
  { "LEAY,-Y", 0x31, 9, 0, B_(10100010) },
  { "LEAY,-U", 0x31, 9, 0, B_(11000010) },
  { "LEAY,-S", 0x31, 9, 0, B_(11100010) },
  { "LEAY,--X", 0x31, 9, 0, B_(10000011) },
  { "LEAY,--Y", 0x31, 9, 0, B_(10100011) },
  { "LEAY,--U", 0x31, 9, 0, B_(11000011) },
  { "LEAY,--S", 0x31, 9, 0, B_(11100011) },
  { "LEAY (,X)", 0x31, 9, 0, B_(10010100) },
  { "LEAY (,Y)", 0x31, 9, 0, B_(10110100) },
  { "LEAY (,U)", 0x31, 9, 0, B_(11010100) },
  { "LEAY (,S)", 0x31, 9, 0, B_(11110100) },
  { "LEAY (A,X)", 0x31, 9, 0, B_(10010110) },
  { "LEAY (A,Y)", 0x31, 9, 0, B_(10110110) },
  { "LEAY (A,U)", 0x31, 9, 0, B_(11010110) },
  { "LEAY (A,S)", 0x31, 9, 0, B_(11110110) },
  { "LEAY (B,X)", 0x31, 9, 0, B_(10010101) },
  { "LEAY (B,Y)", 0x31, 9, 0, B_(10110101) },
  { "LEAY (B,U)", 0x31, 9, 0, B_(11010101) },
  { "LEAY (B,S)", 0x31, 9, 0, B_(11110101) },
  { "LEAY (D,X)", 0x31, 9, 0, B_(10011011) },
  { "LEAY (D,Y)", 0x31, 9, 0, B_(10111011) },
  { "LEAY (D,U)", 0x31, 9, 0, B_(11011011) },
  { "LEAY (D,S)", 0x31, 9, 0, B_(11111011) },
  { "LEAY (,X++)", 0x31, 9, 0, B_(10010001) },
  { "LEAY (,Y++)", 0x31, 9, 0, B_(10110001) },
  { "LEAY (,U++)", 0x31, 9, 0, B_(11010001) },
  { "LEAY (,S++)", 0x31, 9, 0, B_(11110001) },
  { "LEAY (,--X)", 0x31, 9, 0, B_(10010011) },
  { "LEAY (,--Y)", 0x31, 9, 0, B_(10110011) },
  { "LEAY (,--U)", 0x31, 9, 0, B_(11010011) },
  { "LEAY (,--S)", 0x31, 9, 0, B_(11110011) },
  { "LEAY (x,X)", 0x31, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LEAY (x,Y)", 0x31, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LEAY (x,U)", 0x31, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LEAY (x,S)", 0x31, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LEAY (?,X)", 0x31, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LEAY (?,Y)", 0x31, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LEAY (?,U)", 0x31, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LEAY (?,S)", 0x31, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LEAY (x,PCR)", 0x31, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LEAY (?,PCR)", 0x31, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LEAY (?)", 0x31, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LEAY s,X", 0x31, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LEAY s,Y", 0x31, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LEAY s,U", 0x31, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LEAY s,S", 0x31, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LEAY x,X", 0x31, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LEAY x,Y", 0x31, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LEAY x,U", 0x31, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LEAY x,S", 0x31, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LEAY ?,X", 0x31, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LEAY ?,Y", 0x31, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LEAY ?,U", 0x31, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LEAY ?,S", 0x31, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LEAY x,PCR", 0x31, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LEAY ?,PCR", 0x31, 8, 0, B_(10001101) }, /* 16-bit offset */

  { "LSLA", 0x48, 0, 0, 0 },
  { "LSLB", 0x58, 0, 0, 0 },
  { "LSL,X", 0x68, 9, 0, B_(10000100) },
  { "LSL,Y", 0x68, 9, 0, B_(10100100) },
  { "LSL,U", 0x68, 9, 0, B_(11000100) },
  { "LSL,S", 0x68, 9, 0, B_(11100100) },
  { "LSL A,X", 0x68, 9, 0, B_(10000110) },
  { "LSL A,Y", 0x68, 9, 0, B_(10100110) },
  { "LSL A,U", 0x68, 9, 0, B_(11000110) },
  { "LSL A,S", 0x68, 9, 0, B_(11100110) },
  { "LSL B,X", 0x68, 9, 0, B_(10000101) },
  { "LSL B,Y", 0x68, 9, 0, B_(10100101) },
  { "LSL B,U", 0x68, 9, 0, B_(11000101) },
  { "LSL B,S", 0x68, 9, 0, B_(11100101) },
  { "LSL D,X", 0x68, 9, 0, B_(10001011) },
  { "LSL D,Y", 0x68, 9, 0, B_(10101011) },
  { "LSL D,U", 0x68, 9, 0, B_(11001011) },
  { "LSL D,S", 0x68, 9, 0, B_(11101011) },
  { "LSL,X+", 0x68, 9, 0, B_(10000000) },
  { "LSL,Y+", 0x68, 9, 0, B_(10100000) },
  { "LSL,U+", 0x68, 9, 0, B_(11000000) },
  { "LSL,S+", 0x68, 9, 0, B_(11100000) },
  { "LSL,X++", 0x68, 9, 0, B_(10000001) },
  { "LSL,Y++", 0x68, 9, 0, B_(10100001) },
  { "LSL,U++", 0x68, 9, 0, B_(11000001) },
  { "LSL,S++", 0x68, 9, 0, B_(11100001) },
  { "LSL,-X", 0x68, 9, 0, B_(10000010) },
  { "LSL,-Y", 0x68, 9, 0, B_(10100010) },
  { "LSL,-U", 0x68, 9, 0, B_(11000010) },
  { "LSL,-S", 0x68, 9, 0, B_(11100010) },
  { "LSL,--X", 0x68, 9, 0, B_(10000011) },
  { "LSL,--Y", 0x68, 9, 0, B_(10100011) },
  { "LSL,--U", 0x68, 9, 0, B_(11000011) },
  { "LSL,--S", 0x68, 9, 0, B_(11100011) },
  { "LSL (,X)", 0x68, 9, 0, B_(10010100) },
  { "LSL (,Y)", 0x68, 9, 0, B_(10110100) },
  { "LSL (,U)", 0x68, 9, 0, B_(11010100) },
  { "LSL (,S)", 0x68, 9, 0, B_(11110100) },
  { "LSL (A,X)", 0x68, 9, 0, B_(10010110) },
  { "LSL (A,Y)", 0x68, 9, 0, B_(10110110) },
  { "LSL (A,U)", 0x68, 9, 0, B_(11010110) },
  { "LSL (A,S)", 0x68, 9, 0, B_(11110110) },
  { "LSL (B,X)", 0x68, 9, 0, B_(10010101) },
  { "LSL (B,Y)", 0x68, 9, 0, B_(10110101) },
  { "LSL (B,U)", 0x68, 9, 0, B_(11010101) },
  { "LSL (B,S)", 0x68, 9, 0, B_(11110101) },
  { "LSL (D,X)", 0x68, 9, 0, B_(10011011) },
  { "LSL (D,Y)", 0x68, 9, 0, B_(10111011) },
  { "LSL (D,U)", 0x68, 9, 0, B_(11011011) },
  { "LSL (D,S)", 0x68, 9, 0, B_(11111011) },
  { "LSL (,X++)", 0x68, 9, 0, B_(10010001) },
  { "LSL (,Y++)", 0x68, 9, 0, B_(10110001) },
  { "LSL (,U++)", 0x68, 9, 0, B_(11010001) },
  { "LSL (,S++)", 0x68, 9, 0, B_(11110001) },
  { "LSL (,--X)", 0x68, 9, 0, B_(10010011) },
  { "LSL (,--Y)", 0x68, 9, 0, B_(10110011) },
  { "LSL (,--U)", 0x68, 9, 0, B_(11010011) },
  { "LSL (,--S)", 0x68, 9, 0, B_(11110011) },
  { "LSL (x,X)", 0x68, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LSL (x,Y)", 0x68, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LSL (x,U)", 0x68, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LSL (x,S)", 0x68, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LSL (?,X)", 0x68, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LSL (?,Y)", 0x68, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LSL (?,U)", 0x68, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LSL (?,S)", 0x68, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LSL (x,PCR)", 0x68, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LSL (?,PCR)", 0x68, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LSL (?)", 0x68, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LSL s,X", 0x68, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LSL s,Y", 0x68, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LSL s,U", 0x68, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LSL s,S", 0x68, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LSL x,X", 0x68, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LSL x,Y", 0x68, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LSL x,U", 0x68, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LSL x,S", 0x68, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LSL ?,X", 0x68, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LSL ?,Y", 0x68, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LSL ?,U", 0x68, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LSL ?,S", 0x68, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LSL x,PCR", 0x68, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LSL ?,PCR", 0x68, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "LSL x", 0x08, 4, 1, 0 },
  { "LSL ?", 0x78, 2, 0, 0 },

  { "LSRA", 0x44, 0, 0, 0 },
  { "LSRB", 0x54, 0, 0, 0 },
  { "LSR,X", 0x64, 9, 0, B_(10000100) },
  { "LSR,Y", 0x64, 9, 0, B_(10100100) },
  { "LSR,U", 0x64, 9, 0, B_(11000100) },
  { "LSR,S", 0x64, 9, 0, B_(11100100) },
  { "LSR A,X", 0x64, 9, 0, B_(10000110) },
  { "LSR A,Y", 0x64, 9, 0, B_(10100110) },
  { "LSR A,U", 0x64, 9, 0, B_(11000110) },
  { "LSR A,S", 0x64, 9, 0, B_(11100110) },
  { "LSR B,X", 0x64, 9, 0, B_(10000101) },
  { "LSR B,Y", 0x64, 9, 0, B_(10100101) },
  { "LSR B,U", 0x64, 9, 0, B_(11000101) },
  { "LSR B,S", 0x64, 9, 0, B_(11100101) },
  { "LSR D,X", 0x64, 9, 0, B_(10001011) },
  { "LSR D,Y", 0x64, 9, 0, B_(10101011) },
  { "LSR D,U", 0x64, 9, 0, B_(11001011) },
  { "LSR D,S", 0x64, 9, 0, B_(11101011) },
  { "LSR,X+", 0x64, 9, 0, B_(10000000) },
  { "LSR,Y+", 0x64, 9, 0, B_(10100000) },
  { "LSR,U+", 0x64, 9, 0, B_(11000000) },
  { "LSR,S+", 0x64, 9, 0, B_(11100000) },
  { "LSR,X++", 0x64, 9, 0, B_(10000001) },
  { "LSR,Y++", 0x64, 9, 0, B_(10100001) },
  { "LSR,U++", 0x64, 9, 0, B_(11000001) },
  { "LSR,S++", 0x64, 9, 0, B_(11100001) },
  { "LSR,-X", 0x64, 9, 0, B_(10000010) },
  { "LSR,-Y", 0x64, 9, 0, B_(10100010) },
  { "LSR,-U", 0x64, 9, 0, B_(11000010) },
  { "LSR,-S", 0x64, 9, 0, B_(11100010) },
  { "LSR,--X", 0x64, 9, 0, B_(10000011) },
  { "LSR,--Y", 0x64, 9, 0, B_(10100011) },
  { "LSR,--U", 0x64, 9, 0, B_(11000011) },
  { "LSR,--S", 0x64, 9, 0, B_(11100011) },
  { "LSR (,X)", 0x64, 9, 0, B_(10010100) },
  { "LSR (,Y)", 0x64, 9, 0, B_(10110100) },
  { "LSR (,U)", 0x64, 9, 0, B_(11010100) },
  { "LSR (,S)", 0x64, 9, 0, B_(11110100) },
  { "LSR (A,X)", 0x64, 9, 0, B_(10010110) },
  { "LSR (A,Y)", 0x64, 9, 0, B_(10110110) },
  { "LSR (A,U)", 0x64, 9, 0, B_(11010110) },
  { "LSR (A,S)", 0x64, 9, 0, B_(11110110) },
  { "LSR (B,X)", 0x64, 9, 0, B_(10010101) },
  { "LSR (B,Y)", 0x64, 9, 0, B_(10110101) },
  { "LSR (B,U)", 0x64, 9, 0, B_(11010101) },
  { "LSR (B,S)", 0x64, 9, 0, B_(11110101) },
  { "LSR (D,X)", 0x64, 9, 0, B_(10011011) },
  { "LSR (D,Y)", 0x64, 9, 0, B_(10111011) },
  { "LSR (D,U)", 0x64, 9, 0, B_(11011011) },
  { "LSR (D,S)", 0x64, 9, 0, B_(11111011) },
  { "LSR (,X++)", 0x64, 9, 0, B_(10010001) },
  { "LSR (,Y++)", 0x64, 9, 0, B_(10110001) },
  { "LSR (,U++)", 0x64, 9, 0, B_(11010001) },
  { "LSR (,S++)", 0x64, 9, 0, B_(11110001) },
  { "LSR (,--X)", 0x64, 9, 0, B_(10010011) },
  { "LSR (,--Y)", 0x64, 9, 0, B_(10110011) },
  { "LSR (,--U)", 0x64, 9, 0, B_(11010011) },
  { "LSR (,--S)", 0x64, 9, 0, B_(11110011) },
  { "LSR (x,X)", 0x64, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "LSR (x,Y)", 0x64, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "LSR (x,U)", 0x64, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "LSR (x,S)", 0x64, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "LSR (?,X)", 0x64, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "LSR (?,Y)", 0x64, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "LSR (?,U)", 0x64, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "LSR (?,S)", 0x64, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "LSR (x,PCR)", 0x64, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "LSR (?,PCR)", 0x64, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "LSR (?)", 0x64, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "LSR s,X", 0x64, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "LSR s,Y", 0x64, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "LSR s,U", 0x64, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "LSR s,S", 0x64, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "LSR x,X", 0x64, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "LSR x,Y", 0x64, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "LSR x,U", 0x64, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "LSR x,S", 0x64, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "LSR ?,X", 0x64, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "LSR ?,Y", 0x64, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "LSR ?,U", 0x64, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "LSR ?,S", 0x64, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "LSR x,PCR", 0x64, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "LSR ?,PCR", 0x64, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "LSR x", 0x04, 4, 1, 0 },
  { "LSR ?", 0x74, 2, 0, 0 },

  { "MUL", 0x3D, 0, 0, 0 },

  { "NEGA", 0x40, 0, 0, 0 },
  { "NEGB", 0x50, 0, 0, 0 },
  { "NEG,X", 0x60, 9, 0, B_(10000100) },
  { "NEG,Y", 0x60, 9, 0, B_(10100100) },
  { "NEG,U", 0x60, 9, 0, B_(11000100) },
  { "NEG,S", 0x60, 9, 0, B_(11100100) },
  { "NEG A,X", 0x60, 9, 0, B_(10000110) },
  { "NEG A,Y", 0x60, 9, 0, B_(10100110) },
  { "NEG A,U", 0x60, 9, 0, B_(11000110) },
  { "NEG A,S", 0x60, 9, 0, B_(11100110) },
  { "NEG B,X", 0x60, 9, 0, B_(10000101) },
  { "NEG B,Y", 0x60, 9, 0, B_(10100101) },
  { "NEG B,U", 0x60, 9, 0, B_(11000101) },
  { "NEG B,S", 0x60, 9, 0, B_(11100101) },
  { "NEG D,X", 0x60, 9, 0, B_(10001011) },
  { "NEG D,Y", 0x60, 9, 0, B_(10101011) },
  { "NEG D,U", 0x60, 9, 0, B_(11001011) },
  { "NEG D,S", 0x60, 9, 0, B_(11101011) },
  { "NEG,X+", 0x60, 9, 0, B_(10000000) },
  { "NEG,Y+", 0x60, 9, 0, B_(10100000) },
  { "NEG,U+", 0x60, 9, 0, B_(11000000) },
  { "NEG,S+", 0x60, 9, 0, B_(11100000) },
  { "NEG,X++", 0x60, 9, 0, B_(10000001) },
  { "NEG,Y++", 0x60, 9, 0, B_(10100001) },
  { "NEG,U++", 0x60, 9, 0, B_(11000001) },
  { "NEG,S++", 0x60, 9, 0, B_(11100001) },
  { "NEG,-X", 0x60, 9, 0, B_(10000010) },
  { "NEG,-Y", 0x60, 9, 0, B_(10100010) },
  { "NEG,-U", 0x60, 9, 0, B_(11000010) },
  { "NEG,-S", 0x60, 9, 0, B_(11100010) },
  { "NEG,--X", 0x60, 9, 0, B_(10000011) },
  { "NEG,--Y", 0x60, 9, 0, B_(10100011) },
  { "NEG,--U", 0x60, 9, 0, B_(11000011) },
  { "NEG,--S", 0x60, 9, 0, B_(11100011) },
  { "NEG (,X)", 0x60, 9, 0, B_(10010100) },
  { "NEG (,Y)", 0x60, 9, 0, B_(10110100) },
  { "NEG (,U)", 0x60, 9, 0, B_(11010100) },
  { "NEG (,S)", 0x60, 9, 0, B_(11110100) },
  { "NEG (A,X)", 0x60, 9, 0, B_(10010110) },
  { "NEG (A,Y)", 0x60, 9, 0, B_(10110110) },
  { "NEG (A,U)", 0x60, 9, 0, B_(11010110) },
  { "NEG (A,S)", 0x60, 9, 0, B_(11110110) },
  { "NEG (B,X)", 0x60, 9, 0, B_(10010101) },
  { "NEG (B,Y)", 0x60, 9, 0, B_(10110101) },
  { "NEG (B,U)", 0x60, 9, 0, B_(11010101) },
  { "NEG (B,S)", 0x60, 9, 0, B_(11110101) },
  { "NEG (D,X)", 0x60, 9, 0, B_(10011011) },
  { "NEG (D,Y)", 0x60, 9, 0, B_(10111011) },
  { "NEG (D,U)", 0x60, 9, 0, B_(11011011) },
  { "NEG (D,S)", 0x60, 9, 0, B_(11111011) },
  { "NEG (,X++)", 0x60, 9, 0, B_(10010001) },
  { "NEG (,Y++)", 0x60, 9, 0, B_(10110001) },
  { "NEG (,U++)", 0x60, 9, 0, B_(11010001) },
  { "NEG (,S++)", 0x60, 9, 0, B_(11110001) },
  { "NEG (,--X)", 0x60, 9, 0, B_(10010011) },
  { "NEG (,--Y)", 0x60, 9, 0, B_(10110011) },
  { "NEG (,--U)", 0x60, 9, 0, B_(11010011) },
  { "NEG (,--S)", 0x60, 9, 0, B_(11110011) },
  { "NEG (x,X)", 0x60, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "NEG (x,Y)", 0x60, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "NEG (x,U)", 0x60, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "NEG (x,S)", 0x60, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "NEG (?,X)", 0x60, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "NEG (?,Y)", 0x60, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "NEG (?,U)", 0x60, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "NEG (?,S)", 0x60, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "NEG (x,PCR)", 0x60, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "NEG (?,PCR)", 0x60, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "NEG (?)", 0x60, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "NEG s,X", 0x60, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "NEG s,Y", 0x60, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "NEG s,U", 0x60, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "NEG s,S", 0x60, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "NEG x,X", 0x60, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "NEG x,Y", 0x60, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "NEG x,U", 0x60, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "NEG x,S", 0x60, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "NEG ?,X", 0x60, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "NEG ?,Y", 0x60, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "NEG ?,U", 0x60, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "NEG ?,S", 0x60, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "NEG x,PCR", 0x60, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "NEG ?,PCR", 0x60, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "NEG x", 0x00, 4, 1, 0 },
  { "NEG ?", 0x70, 2, 0, 0 },

  { "NOP", 0x12, 0, 0, 0 },

  { "ORA #x", 0x8A, 1, 0, 0 },
  { "ORA,X", 0xAA, 9, 0, B_(10000100) },
  { "ORA,Y", 0xAA, 9, 0, B_(10100100) },
  { "ORA,U", 0xAA, 9, 0, B_(11000100) },
  { "ORA,S", 0xAA, 9, 0, B_(11100100) },
  { "ORA A,X", 0xAA, 9, 0, B_(10000110) },
  { "ORA A,Y", 0xAA, 9, 0, B_(10100110) },
  { "ORA A,U", 0xAA, 9, 0, B_(11000110) },
  { "ORA A,S", 0xAA, 9, 0, B_(11100110) },
  { "ORA B,X", 0xAA, 9, 0, B_(10000101) },
  { "ORA B,Y", 0xAA, 9, 0, B_(10100101) },
  { "ORA B,U", 0xAA, 9, 0, B_(11000101) },
  { "ORA B,S", 0xAA, 9, 0, B_(11100101) },
  { "ORA D,X", 0xAA, 9, 0, B_(10001011) },
  { "ORA D,Y", 0xAA, 9, 0, B_(10101011) },
  { "ORA D,U", 0xAA, 9, 0, B_(11001011) },
  { "ORA D,S", 0xAA, 9, 0, B_(11101011) },
  { "ORA,X+", 0xAA, 9, 0, B_(10000000) },
  { "ORA,Y+", 0xAA, 9, 0, B_(10100000) },
  { "ORA,U+", 0xAA, 9, 0, B_(11000000) },
  { "ORA,S+", 0xAA, 9, 0, B_(11100000) },
  { "ORA,X++", 0xAA, 9, 0, B_(10000001) },
  { "ORA,Y++", 0xAA, 9, 0, B_(10100001) },
  { "ORA,U++", 0xAA, 9, 0, B_(11000001) },
  { "ORA,S++", 0xAA, 9, 0, B_(11100001) },
  { "ORA,-X", 0xAA, 9, 0, B_(10000010) },
  { "ORA,-Y", 0xAA, 9, 0, B_(10100010) },
  { "ORA,-U", 0xAA, 9, 0, B_(11000010) },
  { "ORA,-S", 0xAA, 9, 0, B_(11100010) },
  { "ORA,--X", 0xAA, 9, 0, B_(10000011) },
  { "ORA,--Y", 0xAA, 9, 0, B_(10100011) },
  { "ORA,--U", 0xAA, 9, 0, B_(11000011) },
  { "ORA,--S", 0xAA, 9, 0, B_(11100011) },
  { "ORA (,X)", 0xAA, 9, 0, B_(10010100) },
  { "ORA (,Y)", 0xAA, 9, 0, B_(10110100) },
  { "ORA (,U)", 0xAA, 9, 0, B_(11010100) },
  { "ORA (,S)", 0xAA, 9, 0, B_(11110100) },
  { "ORA (A,X)", 0xAA, 9, 0, B_(10010110) },
  { "ORA (A,Y)", 0xAA, 9, 0, B_(10110110) },
  { "ORA (A,U)", 0xAA, 9, 0, B_(11010110) },
  { "ORA (A,S)", 0xAA, 9, 0, B_(11110110) },
  { "ORA (B,X)", 0xAA, 9, 0, B_(10010101) },
  { "ORA (B,Y)", 0xAA, 9, 0, B_(10110101) },
  { "ORA (B,U)", 0xAA, 9, 0, B_(11010101) },
  { "ORA (B,S)", 0xAA, 9, 0, B_(11110101) },
  { "ORA (D,X)", 0xAA, 9, 0, B_(10011011) },
  { "ORA (D,Y)", 0xAA, 9, 0, B_(10111011) },
  { "ORA (D,U)", 0xAA, 9, 0, B_(11011011) },
  { "ORA (D,S)", 0xAA, 9, 0, B_(11111011) },
  { "ORA (,X++)", 0xAA, 9, 0, B_(10010001) },
  { "ORA (,Y++)", 0xAA, 9, 0, B_(10110001) },
  { "ORA (,U++)", 0xAA, 9, 0, B_(11010001) },
  { "ORA (,S++)", 0xAA, 9, 0, B_(11110001) },
  { "ORA (,--X)", 0xAA, 9, 0, B_(10010011) },
  { "ORA (,--Y)", 0xAA, 9, 0, B_(10110011) },
  { "ORA (,--U)", 0xAA, 9, 0, B_(11010011) },
  { "ORA (,--S)", 0xAA, 9, 0, B_(11110011) },
  { "ORA (x,X)", 0xAA, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ORA (x,Y)", 0xAA, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ORA (x,U)", 0xAA, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ORA (x,S)", 0xAA, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ORA (?,X)", 0xAA, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ORA (?,Y)", 0xAA, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ORA (?,U)", 0xAA, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ORA (?,S)", 0xAA, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ORA (x,PCR)", 0xAA, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ORA (?,PCR)", 0xAA, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ORA (?)", 0xAA, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ORA s,X", 0xAA, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ORA s,Y", 0xAA, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ORA s,U", 0xAA, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ORA s,S", 0xAA, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ORA x,X", 0xAA, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ORA x,Y", 0xAA, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ORA x,U", 0xAA, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ORA x,S", 0xAA, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ORA ?,X", 0xAA, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ORA ?,Y", 0xAA, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ORA ?,U", 0xAA, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ORA ?,S", 0xAA, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ORA x,PCR", 0xAA, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ORA ?,PCR", 0xAA, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ORA x", 0x9A, 4, 1, 0 },
  { "ORA ?", 0xBA, 2, 0, 0 },

  { "ORB #x", 0xCA, 1, 0, 0 },
  { "ORB,X", 0xEA, 9, 0, B_(10000100) },
  { "ORB,Y", 0xEA, 9, 0, B_(10100100) },
  { "ORB,U", 0xEA, 9, 0, B_(11000100) },
  { "ORB,S", 0xEA, 9, 0, B_(11100100) },
  { "ORB A,X", 0xEA, 9, 0, B_(10000110) },
  { "ORB A,Y", 0xEA, 9, 0, B_(10100110) },
  { "ORB A,U", 0xEA, 9, 0, B_(11000110) },
  { "ORB A,S", 0xEA, 9, 0, B_(11100110) },
  { "ORB B,X", 0xEA, 9, 0, B_(10000101) },
  { "ORB B,Y", 0xEA, 9, 0, B_(10100101) },
  { "ORB B,U", 0xEA, 9, 0, B_(11000101) },
  { "ORB B,S", 0xEA, 9, 0, B_(11100101) },
  { "ORB D,X", 0xEA, 9, 0, B_(10001011) },
  { "ORB D,Y", 0xEA, 9, 0, B_(10101011) },
  { "ORB D,U", 0xEA, 9, 0, B_(11001011) },
  { "ORB D,S", 0xEA, 9, 0, B_(11101011) },
  { "ORB,X+", 0xEA, 9, 0, B_(10000000) },
  { "ORB,Y+", 0xEA, 9, 0, B_(10100000) },
  { "ORB,U+", 0xEA, 9, 0, B_(11000000) },
  { "ORB,S+", 0xEA, 9, 0, B_(11100000) },
  { "ORB,X++", 0xEA, 9, 0, B_(10000001) },
  { "ORB,Y++", 0xEA, 9, 0, B_(10100001) },
  { "ORB,U++", 0xEA, 9, 0, B_(11000001) },
  { "ORB,S++", 0xEA, 9, 0, B_(11100001) },
  { "ORB,-X", 0xEA, 9, 0, B_(10000010) },
  { "ORB,-Y", 0xEA, 9, 0, B_(10100010) },
  { "ORB,-U", 0xEA, 9, 0, B_(11000010) },
  { "ORB,-S", 0xEA, 9, 0, B_(11100010) },
  { "ORB,--X", 0xEA, 9, 0, B_(10000011) },
  { "ORB,--Y", 0xEA, 9, 0, B_(10100011) },
  { "ORB,--U", 0xEA, 9, 0, B_(11000011) },
  { "ORB,--S", 0xEA, 9, 0, B_(11100011) },
  { "ORB (,X)", 0xEA, 9, 0, B_(10010100) },
  { "ORB (,Y)", 0xEA, 9, 0, B_(10110100) },
  { "ORB (,U)", 0xEA, 9, 0, B_(11010100) },
  { "ORB (,S)", 0xEA, 9, 0, B_(11110100) },
  { "ORB (A,X)", 0xEA, 9, 0, B_(10010110) },
  { "ORB (A,Y)", 0xEA, 9, 0, B_(10110110) },
  { "ORB (A,U)", 0xEA, 9, 0, B_(11010110) },
  { "ORB (A,S)", 0xEA, 9, 0, B_(11110110) },
  { "ORB (B,X)", 0xEA, 9, 0, B_(10010101) },
  { "ORB (B,Y)", 0xEA, 9, 0, B_(10110101) },
  { "ORB (B,U)", 0xEA, 9, 0, B_(11010101) },
  { "ORB (B,S)", 0xEA, 9, 0, B_(11110101) },
  { "ORB (D,X)", 0xEA, 9, 0, B_(10011011) },
  { "ORB (D,Y)", 0xEA, 9, 0, B_(10111011) },
  { "ORB (D,U)", 0xEA, 9, 0, B_(11011011) },
  { "ORB (D,S)", 0xEA, 9, 0, B_(11111011) },
  { "ORB (,X++)", 0xEA, 9, 0, B_(10010001) },
  { "ORB (,Y++)", 0xEA, 9, 0, B_(10110001) },
  { "ORB (,U++)", 0xEA, 9, 0, B_(11010001) },
  { "ORB (,S++)", 0xEA, 9, 0, B_(11110001) },
  { "ORB (,--X)", 0xEA, 9, 0, B_(10010011) },
  { "ORB (,--Y)", 0xEA, 9, 0, B_(10110011) },
  { "ORB (,--U)", 0xEA, 9, 0, B_(11010011) },
  { "ORB (,--S)", 0xEA, 9, 0, B_(11110011) },
  { "ORB (x,X)", 0xEA, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ORB (x,Y)", 0xEA, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ORB (x,U)", 0xEA, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ORB (x,S)", 0xEA, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ORB (?,X)", 0xEA, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ORB (?,Y)", 0xEA, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ORB (?,U)", 0xEA, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ORB (?,S)", 0xEA, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ORB (x,PCR)", 0xEA, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ORB (?,PCR)", 0xEA, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ORB (?)", 0xEA, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ORB s,X", 0xEA, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ORB s,Y", 0xEA, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ORB s,U", 0xEA, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ORB s,S", 0xEA, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ORB x,X", 0xEA, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ORB x,Y", 0xEA, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ORB x,U", 0xEA, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ORB x,S", 0xEA, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ORB ?,X", 0xEA, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ORB ?,Y", 0xEA, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ORB ?,U", 0xEA, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ORB ?,S", 0xEA, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ORB x,PCR", 0xEA, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ORB ?,PCR", 0xEA, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ORB x", 0xDA, 4, 1, 0 },
  { "ORB ?", 0xFA, 2, 0, 0 },

  { "ORCC #x", 0x1A, 1, 0, 0 },

  { "PSHS r", 0x34, 11, 0, 1 },
  { "PSHU r", 0x36, 11, 0, 0 },
  { "PULS r", 0x35, 11, 0, 1 },
  { "PULU r", 0x37, 11, 0, 0 },

  { "ROLA", 0x49, 0, 0, 0 },
  { "ROLB", 0x59, 0, 0, 0 },
  { "ROL,X", 0x69, 9, 0, B_(10000100) },
  { "ROL,Y", 0x69, 9, 0, B_(10100100) },
  { "ROL,U", 0x69, 9, 0, B_(11000100) },
  { "ROL,S", 0x69, 9, 0, B_(11100100) },
  { "ROL A,X", 0x69, 9, 0, B_(10000110) },
  { "ROL A,Y", 0x69, 9, 0, B_(10100110) },
  { "ROL A,U", 0x69, 9, 0, B_(11000110) },
  { "ROL A,S", 0x69, 9, 0, B_(11100110) },
  { "ROL B,X", 0x69, 9, 0, B_(10000101) },
  { "ROL B,Y", 0x69, 9, 0, B_(10100101) },
  { "ROL B,U", 0x69, 9, 0, B_(11000101) },
  { "ROL B,S", 0x69, 9, 0, B_(11100101) },
  { "ROL D,X", 0x69, 9, 0, B_(10001011) },
  { "ROL D,Y", 0x69, 9, 0, B_(10101011) },
  { "ROL D,U", 0x69, 9, 0, B_(11001011) },
  { "ROL D,S", 0x69, 9, 0, B_(11101011) },
  { "ROL,X+", 0x69, 9, 0, B_(10000000) },
  { "ROL,Y+", 0x69, 9, 0, B_(10100000) },
  { "ROL,U+", 0x69, 9, 0, B_(11000000) },
  { "ROL,S+", 0x69, 9, 0, B_(11100000) },
  { "ROL,X++", 0x69, 9, 0, B_(10000001) },
  { "ROL,Y++", 0x69, 9, 0, B_(10100001) },
  { "ROL,U++", 0x69, 9, 0, B_(11000001) },
  { "ROL,S++", 0x69, 9, 0, B_(11100001) },
  { "ROL,-X", 0x69, 9, 0, B_(10000010) },
  { "ROL,-Y", 0x69, 9, 0, B_(10100010) },
  { "ROL,-U", 0x69, 9, 0, B_(11000010) },
  { "ROL,-S", 0x69, 9, 0, B_(11100010) },
  { "ROL,--X", 0x69, 9, 0, B_(10000011) },
  { "ROL,--Y", 0x69, 9, 0, B_(10100011) },
  { "ROL,--U", 0x69, 9, 0, B_(11000011) },
  { "ROL,--S", 0x69, 9, 0, B_(11100011) },
  { "ROL (,X)", 0x69, 9, 0, B_(10010100) },
  { "ROL (,Y)", 0x69, 9, 0, B_(10110100) },
  { "ROL (,U)", 0x69, 9, 0, B_(11010100) },
  { "ROL (,S)", 0x69, 9, 0, B_(11110100) },
  { "ROL (A,X)", 0x69, 9, 0, B_(10010110) },
  { "ROL (A,Y)", 0x69, 9, 0, B_(10110110) },
  { "ROL (A,U)", 0x69, 9, 0, B_(11010110) },
  { "ROL (A,S)", 0x69, 9, 0, B_(11110110) },
  { "ROL (B,X)", 0x69, 9, 0, B_(10010101) },
  { "ROL (B,Y)", 0x69, 9, 0, B_(10110101) },
  { "ROL (B,U)", 0x69, 9, 0, B_(11010101) },
  { "ROL (B,S)", 0x69, 9, 0, B_(11110101) },
  { "ROL (D,X)", 0x69, 9, 0, B_(10011011) },
  { "ROL (D,Y)", 0x69, 9, 0, B_(10111011) },
  { "ROL (D,U)", 0x69, 9, 0, B_(11011011) },
  { "ROL (D,S)", 0x69, 9, 0, B_(11111011) },
  { "ROL (,X++)", 0x69, 9, 0, B_(10010001) },
  { "ROL (,Y++)", 0x69, 9, 0, B_(10110001) },
  { "ROL (,U++)", 0x69, 9, 0, B_(11010001) },
  { "ROL (,S++)", 0x69, 9, 0, B_(11110001) },
  { "ROL (,--X)", 0x69, 9, 0, B_(10010011) },
  { "ROL (,--Y)", 0x69, 9, 0, B_(10110011) },
  { "ROL (,--U)", 0x69, 9, 0, B_(11010011) },
  { "ROL (,--S)", 0x69, 9, 0, B_(11110011) },
  { "ROL (x,X)", 0x69, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ROL (x,Y)", 0x69, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ROL (x,U)", 0x69, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ROL (x,S)", 0x69, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ROL (?,X)", 0x69, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ROL (?,Y)", 0x69, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ROL (?,U)", 0x69, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ROL (?,S)", 0x69, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ROL (x,PCR)", 0x69, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ROL (?,PCR)", 0x69, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ROL (?)", 0x69, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ROL s,X", 0x69, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ROL s,Y", 0x69, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ROL s,U", 0x69, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ROL s,S", 0x69, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ROL x,X", 0x69, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ROL x,Y", 0x69, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ROL x,U", 0x69, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ROL x,S", 0x69, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ROL ?,X", 0x69, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ROL ?,Y", 0x69, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ROL ?,U", 0x69, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ROL ?,S", 0x69, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ROL x,PCR", 0x69, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ROL ?,PCR", 0x69, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ROL x", 0x09, 4, 1, 0 },
  { "ROL ?", 0x79, 2, 0, 0 },

  { "RORA", 0x46, 0, 0, 0 },
  { "RORB", 0x56, 0, 0, 0 },
  { "ROR,X", 0x66, 9, 0, B_(10000100) },
  { "ROR,Y", 0x66, 9, 0, B_(10100100) },
  { "ROR,U", 0x66, 9, 0, B_(11000100) },
  { "ROR,S", 0x66, 9, 0, B_(11100100) },
  { "ROR A,X", 0x66, 9, 0, B_(10000110) },
  { "ROR A,Y", 0x66, 9, 0, B_(10100110) },
  { "ROR A,U", 0x66, 9, 0, B_(11000110) },
  { "ROR A,S", 0x66, 9, 0, B_(11100110) },
  { "ROR B,X", 0x66, 9, 0, B_(10000101) },
  { "ROR B,Y", 0x66, 9, 0, B_(10100101) },
  { "ROR B,U", 0x66, 9, 0, B_(11000101) },
  { "ROR B,S", 0x66, 9, 0, B_(11100101) },
  { "ROR D,X", 0x66, 9, 0, B_(10001011) },
  { "ROR D,Y", 0x66, 9, 0, B_(10101011) },
  { "ROR D,U", 0x66, 9, 0, B_(11001011) },
  { "ROR D,S", 0x66, 9, 0, B_(11101011) },
  { "ROR,X+", 0x66, 9, 0, B_(10000000) },
  { "ROR,Y+", 0x66, 9, 0, B_(10100000) },
  { "ROR,U+", 0x66, 9, 0, B_(11000000) },
  { "ROR,S+", 0x66, 9, 0, B_(11100000) },
  { "ROR,X++", 0x66, 9, 0, B_(10000001) },
  { "ROR,Y++", 0x66, 9, 0, B_(10100001) },
  { "ROR,U++", 0x66, 9, 0, B_(11000001) },
  { "ROR,S++", 0x66, 9, 0, B_(11100001) },
  { "ROR,-X", 0x66, 9, 0, B_(10000010) },
  { "ROR,-Y", 0x66, 9, 0, B_(10100010) },
  { "ROR,-U", 0x66, 9, 0, B_(11000010) },
  { "ROR,-S", 0x66, 9, 0, B_(11100010) },
  { "ROR,--X", 0x66, 9, 0, B_(10000011) },
  { "ROR,--Y", 0x66, 9, 0, B_(10100011) },
  { "ROR,--U", 0x66, 9, 0, B_(11000011) },
  { "ROR,--S", 0x66, 9, 0, B_(11100011) },
  { "ROR (,X)", 0x66, 9, 0, B_(10010100) },
  { "ROR (,Y)", 0x66, 9, 0, B_(10110100) },
  { "ROR (,U)", 0x66, 9, 0, B_(11010100) },
  { "ROR (,S)", 0x66, 9, 0, B_(11110100) },
  { "ROR (A,X)", 0x66, 9, 0, B_(10010110) },
  { "ROR (A,Y)", 0x66, 9, 0, B_(10110110) },
  { "ROR (A,U)", 0x66, 9, 0, B_(11010110) },
  { "ROR (A,S)", 0x66, 9, 0, B_(11110110) },
  { "ROR (B,X)", 0x66, 9, 0, B_(10010101) },
  { "ROR (B,Y)", 0x66, 9, 0, B_(10110101) },
  { "ROR (B,U)", 0x66, 9, 0, B_(11010101) },
  { "ROR (B,S)", 0x66, 9, 0, B_(11110101) },
  { "ROR (D,X)", 0x66, 9, 0, B_(10011011) },
  { "ROR (D,Y)", 0x66, 9, 0, B_(10111011) },
  { "ROR (D,U)", 0x66, 9, 0, B_(11011011) },
  { "ROR (D,S)", 0x66, 9, 0, B_(11111011) },
  { "ROR (,X++)", 0x66, 9, 0, B_(10010001) },
  { "ROR (,Y++)", 0x66, 9, 0, B_(10110001) },
  { "ROR (,U++)", 0x66, 9, 0, B_(11010001) },
  { "ROR (,S++)", 0x66, 9, 0, B_(11110001) },
  { "ROR (,--X)", 0x66, 9, 0, B_(10010011) },
  { "ROR (,--Y)", 0x66, 9, 0, B_(10110011) },
  { "ROR (,--U)", 0x66, 9, 0, B_(11010011) },
  { "ROR (,--S)", 0x66, 9, 0, B_(11110011) },
  { "ROR (x,X)", 0x66, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "ROR (x,Y)", 0x66, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "ROR (x,U)", 0x66, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "ROR (x,S)", 0x66, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "ROR (?,X)", 0x66, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "ROR (?,Y)", 0x66, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "ROR (?,U)", 0x66, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "ROR (?,S)", 0x66, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "ROR (x,PCR)", 0x66, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "ROR (?,PCR)", 0x66, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "ROR (?)", 0x66, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "ROR s,X", 0x66, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "ROR s,Y", 0x66, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "ROR s,U", 0x66, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "ROR s,S", 0x66, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "ROR x,X", 0x66, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "ROR x,Y", 0x66, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "ROR x,U", 0x66, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "ROR x,S", 0x66, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "ROR ?,X", 0x66, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "ROR ?,Y", 0x66, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "ROR ?,U", 0x66, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "ROR ?,S", 0x66, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "ROR x,PCR", 0x66, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "ROR ?,PCR", 0x66, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "ROR x", 0x06, 4, 1, 0 },
  { "ROR ?", 0x76, 2, 0, 0 },

  { "RTI", 0x3B, 0, 0, 0 },
  { "RTS", 0x39, 0, 0, 0 },

  { "SBCA #x", 0x82, 1, 0, 0 },
  { "SBCA,X", 0xA2, 9, 0, B_(10000100) },
  { "SBCA,Y", 0xA2, 9, 0, B_(10100100) },
  { "SBCA,U", 0xA2, 9, 0, B_(11000100) },
  { "SBCA,S", 0xA2, 9, 0, B_(11100100) },
  { "SBCA A,X", 0xA2, 9, 0, B_(10000110) },
  { "SBCA A,Y", 0xA2, 9, 0, B_(10100110) },
  { "SBCA A,U", 0xA2, 9, 0, B_(11000110) },
  { "SBCA A,S", 0xA2, 9, 0, B_(11100110) },
  { "SBCA B,X", 0xA2, 9, 0, B_(10000101) },
  { "SBCA B,Y", 0xA2, 9, 0, B_(10100101) },
  { "SBCA B,U", 0xA2, 9, 0, B_(11000101) },
  { "SBCA B,S", 0xA2, 9, 0, B_(11100101) },
  { "SBCA D,X", 0xA2, 9, 0, B_(10001011) },
  { "SBCA D,Y", 0xA2, 9, 0, B_(10101011) },
  { "SBCA D,U", 0xA2, 9, 0, B_(11001011) },
  { "SBCA D,S", 0xA2, 9, 0, B_(11101011) },
  { "SBCA,X+", 0xA2, 9, 0, B_(10000000) },
  { "SBCA,Y+", 0xA2, 9, 0, B_(10100000) },
  { "SBCA,U+", 0xA2, 9, 0, B_(11000000) },
  { "SBCA,S+", 0xA2, 9, 0, B_(11100000) },
  { "SBCA,X++", 0xA2, 9, 0, B_(10000001) },
  { "SBCA,Y++", 0xA2, 9, 0, B_(10100001) },
  { "SBCA,U++", 0xA2, 9, 0, B_(11000001) },
  { "SBCA,S++", 0xA2, 9, 0, B_(11100001) },
  { "SBCA,-X", 0xA2, 9, 0, B_(10000010) },
  { "SBCA,-Y", 0xA2, 9, 0, B_(10100010) },
  { "SBCA,-U", 0xA2, 9, 0, B_(11000010) },
  { "SBCA,-S", 0xA2, 9, 0, B_(11100010) },
  { "SBCA,--X", 0xA2, 9, 0, B_(10000011) },
  { "SBCA,--Y", 0xA2, 9, 0, B_(10100011) },
  { "SBCA,--U", 0xA2, 9, 0, B_(11000011) },
  { "SBCA,--S", 0xA2, 9, 0, B_(11100011) },
  { "SBCA (,X)", 0xA2, 9, 0, B_(10010100) },
  { "SBCA (,Y)", 0xA2, 9, 0, B_(10110100) },
  { "SBCA (,U)", 0xA2, 9, 0, B_(11010100) },
  { "SBCA (,S)", 0xA2, 9, 0, B_(11110100) },
  { "SBCA (A,X)", 0xA2, 9, 0, B_(10010110) },
  { "SBCA (A,Y)", 0xA2, 9, 0, B_(10110110) },
  { "SBCA (A,U)", 0xA2, 9, 0, B_(11010110) },
  { "SBCA (A,S)", 0xA2, 9, 0, B_(11110110) },
  { "SBCA (B,X)", 0xA2, 9, 0, B_(10010101) },
  { "SBCA (B,Y)", 0xA2, 9, 0, B_(10110101) },
  { "SBCA (B,U)", 0xA2, 9, 0, B_(11010101) },
  { "SBCA (B,S)", 0xA2, 9, 0, B_(11110101) },
  { "SBCA (D,X)", 0xA2, 9, 0, B_(10011011) },
  { "SBCA (D,Y)", 0xA2, 9, 0, B_(10111011) },
  { "SBCA (D,U)", 0xA2, 9, 0, B_(11011011) },
  { "SBCA (D,S)", 0xA2, 9, 0, B_(11111011) },
  { "SBCA (,X++)", 0xA2, 9, 0, B_(10010001) },
  { "SBCA (,Y++)", 0xA2, 9, 0, B_(10110001) },
  { "SBCA (,U++)", 0xA2, 9, 0, B_(11010001) },
  { "SBCA (,S++)", 0xA2, 9, 0, B_(11110001) },
  { "SBCA (,--X)", 0xA2, 9, 0, B_(10010011) },
  { "SBCA (,--Y)", 0xA2, 9, 0, B_(10110011) },
  { "SBCA (,--U)", 0xA2, 9, 0, B_(11010011) },
  { "SBCA (,--S)", 0xA2, 9, 0, B_(11110011) },
  { "SBCA (x,X)", 0xA2, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "SBCA (x,Y)", 0xA2, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "SBCA (x,U)", 0xA2, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "SBCA (x,S)", 0xA2, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "SBCA (?,X)", 0xA2, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "SBCA (?,Y)", 0xA2, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "SBCA (?,U)", 0xA2, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "SBCA (?,S)", 0xA2, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "SBCA (x,PCR)", 0xA2, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "SBCA (?,PCR)", 0xA2, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "SBCA (?)", 0xA2, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "SBCA s,X", 0xA2, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "SBCA s,Y", 0xA2, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "SBCA s,U", 0xA2, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "SBCA s,S", 0xA2, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "SBCA x,X", 0xA2, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "SBCA x,Y", 0xA2, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "SBCA x,U", 0xA2, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "SBCA x,S", 0xA2, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "SBCA ?,X", 0xA2, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "SBCA ?,Y", 0xA2, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "SBCA ?,U", 0xA2, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "SBCA ?,S", 0xA2, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "SBCA x,PCR", 0xA2, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "SBCA ?,PCR", 0xA2, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "SBCA x", 0x92, 4, 1, 0 },
  { "SBCA ?", 0xB2, 2, 0, 0 },

  { "SBCB #x", 0xC2, 1, 0, 0 },
  { "SBCB,X", 0xE2, 9, 0, B_(10000100) },
  { "SBCB,Y", 0xE2, 9, 0, B_(10100100) },
  { "SBCB,U", 0xE2, 9, 0, B_(11000100) },
  { "SBCB,S", 0xE2, 9, 0, B_(11100100) },
  { "SBCB A,X", 0xE2, 9, 0, B_(10000110) },
  { "SBCB A,Y", 0xE2, 9, 0, B_(10100110) },
  { "SBCB A,U", 0xE2, 9, 0, B_(11000110) },
  { "SBCB A,S", 0xE2, 9, 0, B_(11100110) },
  { "SBCB B,X", 0xE2, 9, 0, B_(10000101) },
  { "SBCB B,Y", 0xE2, 9, 0, B_(10100101) },
  { "SBCB B,U", 0xE2, 9, 0, B_(11000101) },
  { "SBCB B,S", 0xE2, 9, 0, B_(11100101) },
  { "SBCB D,X", 0xE2, 9, 0, B_(10001011) },
  { "SBCB D,Y", 0xE2, 9, 0, B_(10101011) },
  { "SBCB D,U", 0xE2, 9, 0, B_(11001011) },
  { "SBCB D,S", 0xE2, 9, 0, B_(11101011) },
  { "SBCB,X+", 0xE2, 9, 0, B_(10000000) },
  { "SBCB,Y+", 0xE2, 9, 0, B_(10100000) },
  { "SBCB,U+", 0xE2, 9, 0, B_(11000000) },
  { "SBCB,S+", 0xE2, 9, 0, B_(11100000) },
  { "SBCB,X++", 0xE2, 9, 0, B_(10000001) },
  { "SBCB,Y++", 0xE2, 9, 0, B_(10100001) },
  { "SBCB,U++", 0xE2, 9, 0, B_(11000001) },
  { "SBCB,S++", 0xE2, 9, 0, B_(11100001) },
  { "SBCB,-X", 0xE2, 9, 0, B_(10000010) },
  { "SBCB,-Y", 0xE2, 9, 0, B_(10100010) },
  { "SBCB,-U", 0xE2, 9, 0, B_(11000010) },
  { "SBCB,-S", 0xE2, 9, 0, B_(11100010) },
  { "SBCB,--X", 0xE2, 9, 0, B_(10000011) },
  { "SBCB,--Y", 0xE2, 9, 0, B_(10100011) },
  { "SBCB,--U", 0xE2, 9, 0, B_(11000011) },
  { "SBCB,--S", 0xE2, 9, 0, B_(11100011) },
  { "SBCB (,X)", 0xE2, 9, 0, B_(10010100) },
  { "SBCB (,Y)", 0xE2, 9, 0, B_(10110100) },
  { "SBCB (,U)", 0xE2, 9, 0, B_(11010100) },
  { "SBCB (,S)", 0xE2, 9, 0, B_(11110100) },
  { "SBCB (A,X)", 0xE2, 9, 0, B_(10010110) },
  { "SBCB (A,Y)", 0xE2, 9, 0, B_(10110110) },
  { "SBCB (A,U)", 0xE2, 9, 0, B_(11010110) },
  { "SBCB (A,S)", 0xE2, 9, 0, B_(11110110) },
  { "SBCB (B,X)", 0xE2, 9, 0, B_(10010101) },
  { "SBCB (B,Y)", 0xE2, 9, 0, B_(10110101) },
  { "SBCB (B,U)", 0xE2, 9, 0, B_(11010101) },
  { "SBCB (B,S)", 0xE2, 9, 0, B_(11110101) },
  { "SBCB (D,X)", 0xE2, 9, 0, B_(10011011) },
  { "SBCB (D,Y)", 0xE2, 9, 0, B_(10111011) },
  { "SBCB (D,U)", 0xE2, 9, 0, B_(11011011) },
  { "SBCB (D,S)", 0xE2, 9, 0, B_(11111011) },
  { "SBCB (,X++)", 0xE2, 9, 0, B_(10010001) },
  { "SBCB (,Y++)", 0xE2, 9, 0, B_(10110001) },
  { "SBCB (,U++)", 0xE2, 9, 0, B_(11010001) },
  { "SBCB (,S++)", 0xE2, 9, 0, B_(11110001) },
  { "SBCB (,--X)", 0xE2, 9, 0, B_(10010011) },
  { "SBCB (,--Y)", 0xE2, 9, 0, B_(10110011) },
  { "SBCB (,--U)", 0xE2, 9, 0, B_(11010011) },
  { "SBCB (,--S)", 0xE2, 9, 0, B_(11110011) },
  { "SBCB (x,X)", 0xE2, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "SBCB (x,Y)", 0xE2, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "SBCB (x,U)", 0xE2, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "SBCB (x,S)", 0xE2, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "SBCB (?,X)", 0xE2, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "SBCB (?,Y)", 0xE2, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "SBCB (?,U)", 0xE2, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "SBCB (?,S)", 0xE2, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "SBCB (x,PCR)", 0xE2, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "SBCB (?,PCR)", 0xE2, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "SBCB (?)", 0xE2, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "SBCB s,X", 0xE2, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "SBCB s,Y", 0xE2, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "SBCB s,U", 0xE2, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "SBCB s,S", 0xE2, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "SBCB x,X", 0xE2, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "SBCB x,Y", 0xE2, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "SBCB x,U", 0xE2, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "SBCB x,S", 0xE2, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "SBCB ?,X", 0xE2, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "SBCB ?,Y", 0xE2, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "SBCB ?,U", 0xE2, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "SBCB ?,S", 0xE2, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "SBCB x,PCR", 0xE2, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "SBCB ?,PCR", 0xE2, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "SBCB x", 0xD2, 4, 1, 0 },
  { "SBCB ?", 0xF2, 2, 0, 0 },

  { "SEX", 0x1D, 0, 0, 0 },
  
  { "STA,X", 0xA7, 9, 0, B_(10000100) },
  { "STA,Y", 0xA7, 9, 0, B_(10100100) },
  { "STA,U", 0xA7, 9, 0, B_(11000100) },
  { "STA,S", 0xA7, 9, 0, B_(11100100) },
  { "STA A,X", 0xA7, 9, 0, B_(10000110) },
  { "STA A,Y", 0xA7, 9, 0, B_(10100110) },
  { "STA A,U", 0xA7, 9, 0, B_(11000110) },
  { "STA A,S", 0xA7, 9, 0, B_(11100110) },
  { "STA B,X", 0xA7, 9, 0, B_(10000101) },
  { "STA B,Y", 0xA7, 9, 0, B_(10100101) },
  { "STA B,U", 0xA7, 9, 0, B_(11000101) },
  { "STA B,S", 0xA7, 9, 0, B_(11100101) },
  { "STA D,X", 0xA7, 9, 0, B_(10001011) },
  { "STA D,Y", 0xA7, 9, 0, B_(10101011) },
  { "STA D,U", 0xA7, 9, 0, B_(11001011) },
  { "STA D,S", 0xA7, 9, 0, B_(11101011) },
  { "STA,X+", 0xA7, 9, 0, B_(10000000) },
  { "STA,Y+", 0xA7, 9, 0, B_(10100000) },
  { "STA,U+", 0xA7, 9, 0, B_(11000000) },
  { "STA,S+", 0xA7, 9, 0, B_(11100000) },
  { "STA,X++", 0xA7, 9, 0, B_(10000001) },
  { "STA,Y++", 0xA7, 9, 0, B_(10100001) },
  { "STA,U++", 0xA7, 9, 0, B_(11000001) },
  { "STA,S++", 0xA7, 9, 0, B_(11100001) },
  { "STA,-X", 0xA7, 9, 0, B_(10000010) },
  { "STA,-Y", 0xA7, 9, 0, B_(10100010) },
  { "STA,-U", 0xA7, 9, 0, B_(11000010) },
  { "STA,-S", 0xA7, 9, 0, B_(11100010) },
  { "STA,--X", 0xA7, 9, 0, B_(10000011) },
  { "STA,--Y", 0xA7, 9, 0, B_(10100011) },
  { "STA,--U", 0xA7, 9, 0, B_(11000011) },
  { "STA,--S", 0xA7, 9, 0, B_(11100011) },
  { "STA (,X)", 0xA7, 9, 0, B_(10010100) },
  { "STA (,Y)", 0xA7, 9, 0, B_(10110100) },
  { "STA (,U)", 0xA7, 9, 0, B_(11010100) },
  { "STA (,S)", 0xA7, 9, 0, B_(11110100) },
  { "STA (A,X)", 0xA7, 9, 0, B_(10010110) },
  { "STA (A,Y)", 0xA7, 9, 0, B_(10110110) },
  { "STA (A,U)", 0xA7, 9, 0, B_(11010110) },
  { "STA (A,S)", 0xA7, 9, 0, B_(11110110) },
  { "STA (B,X)", 0xA7, 9, 0, B_(10010101) },
  { "STA (B,Y)", 0xA7, 9, 0, B_(10110101) },
  { "STA (B,U)", 0xA7, 9, 0, B_(11010101) },
  { "STA (B,S)", 0xA7, 9, 0, B_(11110101) },
  { "STA (D,X)", 0xA7, 9, 0, B_(10011011) },
  { "STA (D,Y)", 0xA7, 9, 0, B_(10111011) },
  { "STA (D,U)", 0xA7, 9, 0, B_(11011011) },
  { "STA (D,S)", 0xA7, 9, 0, B_(11111011) },
  { "STA (,X++)", 0xA7, 9, 0, B_(10010001) },
  { "STA (,Y++)", 0xA7, 9, 0, B_(10110001) },
  { "STA (,U++)", 0xA7, 9, 0, B_(11010001) },
  { "STA (,S++)", 0xA7, 9, 0, B_(11110001) },
  { "STA (,--X)", 0xA7, 9, 0, B_(10010011) },
  { "STA (,--Y)", 0xA7, 9, 0, B_(10110011) },
  { "STA (,--U)", 0xA7, 9, 0, B_(11010011) },
  { "STA (,--S)", 0xA7, 9, 0, B_(11110011) },
  { "STA (x,X)", 0xA7, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "STA (x,Y)", 0xA7, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "STA (x,U)", 0xA7, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "STA (x,S)", 0xA7, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "STA (?,X)", 0xA7, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "STA (?,Y)", 0xA7, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "STA (?,U)", 0xA7, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "STA (?,S)", 0xA7, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "STA (x,PCR)", 0xA7, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "STA (?,PCR)", 0xA7, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "STA (?)", 0xA7, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "STA s,X", 0xA7, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "STA s,Y", 0xA7, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "STA s,U", 0xA7, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "STA s,S", 0xA7, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "STA x,X", 0xA7, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "STA x,Y", 0xA7, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "STA x,U", 0xA7, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "STA x,S", 0xA7, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "STA ?,X", 0xA7, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "STA ?,Y", 0xA7, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "STA ?,U", 0xA7, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "STA ?,S", 0xA7, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "STA x,PCR", 0xA7, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "STA ?,PCR", 0xA7, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "STA x", 0x97, 4, 1, 0 },
  { "STA ?", 0xB7, 2, 0, 0 },

  { "STB,X", 0xE7, 9, 0, B_(10000100) },
  { "STB,Y", 0xE7, 9, 0, B_(10100100) },
  { "STB,U", 0xE7, 9, 0, B_(11000100) },
  { "STB,S", 0xE7, 9, 0, B_(11100100) },
  { "STB A,X", 0xE7, 9, 0, B_(10000110) },
  { "STB A,Y", 0xE7, 9, 0, B_(10100110) },
  { "STB A,U", 0xE7, 9, 0, B_(11000110) },
  { "STB A,S", 0xE7, 9, 0, B_(11100110) },
  { "STB B,X", 0xE7, 9, 0, B_(10000101) },
  { "STB B,Y", 0xE7, 9, 0, B_(10100101) },
  { "STB B,U", 0xE7, 9, 0, B_(11000101) },
  { "STB B,S", 0xE7, 9, 0, B_(11100101) },
  { "STB D,X", 0xE7, 9, 0, B_(10001011) },
  { "STB D,Y", 0xE7, 9, 0, B_(10101011) },
  { "STB D,U", 0xE7, 9, 0, B_(11001011) },
  { "STB D,S", 0xE7, 9, 0, B_(11101011) },
  { "STB,X+", 0xE7, 9, 0, B_(10000000) },
  { "STB,Y+", 0xE7, 9, 0, B_(10100000) },
  { "STB,U+", 0xE7, 9, 0, B_(11000000) },
  { "STB,S+", 0xE7, 9, 0, B_(11100000) },
  { "STB,X++", 0xE7, 9, 0, B_(10000001) },
  { "STB,Y++", 0xE7, 9, 0, B_(10100001) },
  { "STB,U++", 0xE7, 9, 0, B_(11000001) },
  { "STB,S++", 0xE7, 9, 0, B_(11100001) },
  { "STB,-X", 0xE7, 9, 0, B_(10000010) },
  { "STB,-Y", 0xE7, 9, 0, B_(10100010) },
  { "STB,-U", 0xE7, 9, 0, B_(11000010) },
  { "STB,-S", 0xE7, 9, 0, B_(11100010) },
  { "STB,--X", 0xE7, 9, 0, B_(10000011) },
  { "STB,--Y", 0xE7, 9, 0, B_(10100011) },
  { "STB,--U", 0xE7, 9, 0, B_(11000011) },
  { "STB,--S", 0xE7, 9, 0, B_(11100011) },
  { "STB (,X)", 0xE7, 9, 0, B_(10010100) },
  { "STB (,Y)", 0xE7, 9, 0, B_(10110100) },
  { "STB (,U)", 0xE7, 9, 0, B_(11010100) },
  { "STB (,S)", 0xE7, 9, 0, B_(11110100) },
  { "STB (A,X)", 0xE7, 9, 0, B_(10010110) },
  { "STB (A,Y)", 0xE7, 9, 0, B_(10110110) },
  { "STB (A,U)", 0xE7, 9, 0, B_(11010110) },
  { "STB (A,S)", 0xE7, 9, 0, B_(11110110) },
  { "STB (B,X)", 0xE7, 9, 0, B_(10010101) },
  { "STB (B,Y)", 0xE7, 9, 0, B_(10110101) },
  { "STB (B,U)", 0xE7, 9, 0, B_(11010101) },
  { "STB (B,S)", 0xE7, 9, 0, B_(11110101) },
  { "STB (D,X)", 0xE7, 9, 0, B_(10011011) },
  { "STB (D,Y)", 0xE7, 9, 0, B_(10111011) },
  { "STB (D,U)", 0xE7, 9, 0, B_(11011011) },
  { "STB (D,S)", 0xE7, 9, 0, B_(11111011) },
  { "STB (,X++)", 0xE7, 9, 0, B_(10010001) },
  { "STB (,Y++)", 0xE7, 9, 0, B_(10110001) },
  { "STB (,U++)", 0xE7, 9, 0, B_(11010001) },
  { "STB (,S++)", 0xE7, 9, 0, B_(11110001) },
  { "STB (,--X)", 0xE7, 9, 0, B_(10010011) },
  { "STB (,--Y)", 0xE7, 9, 0, B_(10110011) },
  { "STB (,--U)", 0xE7, 9, 0, B_(11010011) },
  { "STB (,--S)", 0xE7, 9, 0, B_(11110011) },
  { "STB (x,X)", 0xE7, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "STB (x,Y)", 0xE7, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "STB (x,U)", 0xE7, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "STB (x,S)", 0xE7, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "STB (?,X)", 0xE7, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "STB (?,Y)", 0xE7, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "STB (?,U)", 0xE7, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "STB (?,S)", 0xE7, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "STB (x,PCR)", 0xE7, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "STB (?,PCR)", 0xE7, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "STB (?)", 0xE7, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "STB s,X", 0xE7, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "STB s,Y", 0xE7, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "STB s,U", 0xE7, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "STB s,S", 0xE7, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "STB x,X", 0xE7, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "STB x,Y", 0xE7, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "STB x,U", 0xE7, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "STB x,S", 0xE7, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "STB ?,X", 0xE7, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "STB ?,Y", 0xE7, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "STB ?,U", 0xE7, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "STB ?,S", 0xE7, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "STB x,PCR", 0xE7, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "STB ?,PCR", 0xE7, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "STB x", 0xD7, 4, 1, 0 },
  { "STB ?", 0xF7, 2, 0, 0 },

  { "STD,X", 0xED, 9, 0, B_(10000100) },
  { "STD,Y", 0xED, 9, 0, B_(10100100) },
  { "STD,U", 0xED, 9, 0, B_(11000100) },
  { "STD,S", 0xED, 9, 0, B_(11100100) },
  { "STD A,X", 0xED, 9, 0, B_(10000110) },
  { "STD A,Y", 0xED, 9, 0, B_(10100110) },
  { "STD A,U", 0xED, 9, 0, B_(11000110) },
  { "STD A,S", 0xED, 9, 0, B_(11100110) },
  { "STD B,X", 0xED, 9, 0, B_(10000101) },
  { "STD B,Y", 0xED, 9, 0, B_(10100101) },
  { "STD B,U", 0xED, 9, 0, B_(11000101) },
  { "STD B,S", 0xED, 9, 0, B_(11100101) },
  { "STD D,X", 0xED, 9, 0, B_(10001011) },
  { "STD D,Y", 0xED, 9, 0, B_(10101011) },
  { "STD D,U", 0xED, 9, 0, B_(11001011) },
  { "STD D,S", 0xED, 9, 0, B_(11101011) },
  { "STD,X+", 0xED, 9, 0, B_(10000000) },
  { "STD,Y+", 0xED, 9, 0, B_(10100000) },
  { "STD,U+", 0xED, 9, 0, B_(11000000) },
  { "STD,S+", 0xED, 9, 0, B_(11100000) },
  { "STD,X++", 0xED, 9, 0, B_(10000001) },
  { "STD,Y++", 0xED, 9, 0, B_(10100001) },
  { "STD,U++", 0xED, 9, 0, B_(11000001) },
  { "STD,S++", 0xED, 9, 0, B_(11100001) },
  { "STD,-X", 0xED, 9, 0, B_(10000010) },
  { "STD,-Y", 0xED, 9, 0, B_(10100010) },
  { "STD,-U", 0xED, 9, 0, B_(11000010) },
  { "STD,-S", 0xED, 9, 0, B_(11100010) },
  { "STD,--X", 0xED, 9, 0, B_(10000011) },
  { "STD,--Y", 0xED, 9, 0, B_(10100011) },
  { "STD,--U", 0xED, 9, 0, B_(11000011) },
  { "STD,--S", 0xED, 9, 0, B_(11100011) },
  { "STD (,X)", 0xED, 9, 0, B_(10010100) },
  { "STD (,Y)", 0xED, 9, 0, B_(10110100) },
  { "STD (,U)", 0xED, 9, 0, B_(11010100) },
  { "STD (,S)", 0xED, 9, 0, B_(11110100) },
  { "STD (A,X)", 0xED, 9, 0, B_(10010110) },
  { "STD (A,Y)", 0xED, 9, 0, B_(10110110) },
  { "STD (A,U)", 0xED, 9, 0, B_(11010110) },
  { "STD (A,S)", 0xED, 9, 0, B_(11110110) },
  { "STD (B,X)", 0xED, 9, 0, B_(10010101) },
  { "STD (B,Y)", 0xED, 9, 0, B_(10110101) },
  { "STD (B,U)", 0xED, 9, 0, B_(11010101) },
  { "STD (B,S)", 0xED, 9, 0, B_(11110101) },
  { "STD (D,X)", 0xED, 9, 0, B_(10011011) },
  { "STD (D,Y)", 0xED, 9, 0, B_(10111011) },
  { "STD (D,U)", 0xED, 9, 0, B_(11011011) },
  { "STD (D,S)", 0xED, 9, 0, B_(11111011) },
  { "STD (,X++)", 0xED, 9, 0, B_(10010001) },
  { "STD (,Y++)", 0xED, 9, 0, B_(10110001) },
  { "STD (,U++)", 0xED, 9, 0, B_(11010001) },
  { "STD (,S++)", 0xED, 9, 0, B_(11110001) },
  { "STD (,--X)", 0xED, 9, 0, B_(10010011) },
  { "STD (,--Y)", 0xED, 9, 0, B_(10110011) },
  { "STD (,--U)", 0xED, 9, 0, B_(11010011) },
  { "STD (,--S)", 0xED, 9, 0, B_(11110011) },
  { "STD (x,X)", 0xED, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "STD (x,Y)", 0xED, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "STD (x,U)", 0xED, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "STD (x,S)", 0xED, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "STD (?,X)", 0xED, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "STD (?,Y)", 0xED, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "STD (?,U)", 0xED, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "STD (?,S)", 0xED, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "STD (x,PCR)", 0xED, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "STD (?,PCR)", 0xED, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "STD (?)", 0xED, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "STD s,X", 0xED, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "STD s,Y", 0xED, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "STD s,U", 0xED, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "STD s,S", 0xED, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "STD x,X", 0xED, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "STD x,Y", 0xED, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "STD x,U", 0xED, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "STD x,S", 0xED, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "STD ?,X", 0xED, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "STD ?,Y", 0xED, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "STD ?,U", 0xED, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "STD ?,S", 0xED, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "STD x,PCR", 0xED, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "STD ?,PCR", 0xED, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "STD x", 0xDD, 4, 1, 0 },
  { "STD ?", 0xFD, 2, 0, 0 },

  { "STS,X", 0x10EF, 9, 0, B_(10000100) },
  { "STS,Y", 0x10EF, 9, 0, B_(10100100) },
  { "STS,U", 0x10EF, 9, 0, B_(11000100) },
  { "STS,S", 0x10EF, 9, 0, B_(11100100) },
  { "STS A,X", 0x10EF, 9, 0, B_(10000110) },
  { "STS A,Y", 0x10EF, 9, 0, B_(10100110) },
  { "STS A,U", 0x10EF, 9, 0, B_(11000110) },
  { "STS A,S", 0x10EF, 9, 0, B_(11100110) },
  { "STS B,X", 0x10EF, 9, 0, B_(10000101) },
  { "STS B,Y", 0x10EF, 9, 0, B_(10100101) },
  { "STS B,U", 0x10EF, 9, 0, B_(11000101) },
  { "STS B,S", 0x10EF, 9, 0, B_(11100101) },
  { "STS D,X", 0x10EF, 9, 0, B_(10001011) },
  { "STS D,Y", 0x10EF, 9, 0, B_(10101011) },
  { "STS D,U", 0x10EF, 9, 0, B_(11001011) },
  { "STS D,S", 0x10EF, 9, 0, B_(11101011) },
  { "STS,X+", 0x10EF, 9, 0, B_(10000000) },
  { "STS,Y+", 0x10EF, 9, 0, B_(10100000) },
  { "STS,U+", 0x10EF, 9, 0, B_(11000000) },
  { "STS,S+", 0x10EF, 9, 0, B_(11100000) },
  { "STS,X++", 0x10EF, 9, 0, B_(10000001) },
  { "STS,Y++", 0x10EF, 9, 0, B_(10100001) },
  { "STS,U++", 0x10EF, 9, 0, B_(11000001) },
  { "STS,S++", 0x10EF, 9, 0, B_(11100001) },
  { "STS,-X", 0x10EF, 9, 0, B_(10000010) },
  { "STS,-Y", 0x10EF, 9, 0, B_(10100010) },
  { "STS,-U", 0x10EF, 9, 0, B_(11000010) },
  { "STS,-S", 0x10EF, 9, 0, B_(11100010) },
  { "STS,--X", 0x10EF, 9, 0, B_(10000011) },
  { "STS,--Y", 0x10EF, 9, 0, B_(10100011) },
  { "STS,--U", 0x10EF, 9, 0, B_(11000011) },
  { "STS,--S", 0x10EF, 9, 0, B_(11100011) },
  { "STS (,X)", 0x10EF, 9, 0, B_(10010100) },
  { "STS (,Y)", 0x10EF, 9, 0, B_(10110100) },
  { "STS (,U)", 0x10EF, 9, 0, B_(11010100) },
  { "STS (,S)", 0x10EF, 9, 0, B_(11110100) },
  { "STS (A,X)", 0x10EF, 9, 0, B_(10010110) },
  { "STS (A,Y)", 0x10EF, 9, 0, B_(10110110) },
  { "STS (A,U)", 0x10EF, 9, 0, B_(11010110) },
  { "STS (A,S)", 0x10EF, 9, 0, B_(11110110) },
  { "STS (B,X)", 0x10EF, 9, 0, B_(10010101) },
  { "STS (B,Y)", 0x10EF, 9, 0, B_(10110101) },
  { "STS (B,U)", 0x10EF, 9, 0, B_(11010101) },
  { "STS (B,S)", 0x10EF, 9, 0, B_(11110101) },
  { "STS (D,X)", 0x10EF, 9, 0, B_(10011011) },
  { "STS (D,Y)", 0x10EF, 9, 0, B_(10111011) },
  { "STS (D,U)", 0x10EF, 9, 0, B_(11011011) },
  { "STS (D,S)", 0x10EF, 9, 0, B_(11111011) },
  { "STS (,X++)", 0x10EF, 9, 0, B_(10010001) },
  { "STS (,Y++)", 0x10EF, 9, 0, B_(10110001) },
  { "STS (,U++)", 0x10EF, 9, 0, B_(11010001) },
  { "STS (,S++)", 0x10EF, 9, 0, B_(11110001) },
  { "STS (,--X)", 0x10EF, 9, 0, B_(10010011) },
  { "STS (,--Y)", 0x10EF, 9, 0, B_(10110011) },
  { "STS (,--U)", 0x10EF, 9, 0, B_(11010011) },
  { "STS (,--S)", 0x10EF, 9, 0, B_(11110011) },
  { "STS (x,X)", 0x10EF, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "STS (x,Y)", 0x10EF, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "STS (x,U)", 0x10EF, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "STS (x,S)", 0x10EF, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "STS (?,X)", 0x10EF, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "STS (?,Y)", 0x10EF, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "STS (?,U)", 0x10EF, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "STS (?,S)", 0x10EF, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "STS (x,PCR)", 0x10EF, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "STS (?,PCR)", 0x10EF, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "STS (?)", 0x10EF, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "STS s,X", 0x10EF, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "STS s,Y", 0x10EF, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "STS s,U", 0x10EF, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "STS s,S", 0x10EF, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "STS x,X", 0x10EF, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "STS x,Y", 0x10EF, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "STS x,U", 0x10EF, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "STS x,S", 0x10EF, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "STS ?,X", 0x10EF, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "STS ?,Y", 0x10EF, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "STS ?,U", 0x10EF, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "STS ?,S", 0x10EF, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "STS x,PCR", 0x10EF, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "STS ?,PCR", 0x10EF, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "STS x", 0x10DF, 4, 1, 0 },
  { "STS ?", 0x10FF, 2, 0, 0 },

  { "STU,X", 0xEF, 9, 0, B_(10000100) },
  { "STU,Y", 0xEF, 9, 0, B_(10100100) },
  { "STU,U", 0xEF, 9, 0, B_(11000100) },
  { "STU,S", 0xEF, 9, 0, B_(11100100) },
  { "STU A,X", 0xEF, 9, 0, B_(10000110) },
  { "STU A,Y", 0xEF, 9, 0, B_(10100110) },
  { "STU A,U", 0xEF, 9, 0, B_(11000110) },
  { "STU A,S", 0xEF, 9, 0, B_(11100110) },
  { "STU B,X", 0xEF, 9, 0, B_(10000101) },
  { "STU B,Y", 0xEF, 9, 0, B_(10100101) },
  { "STU B,U", 0xEF, 9, 0, B_(11000101) },
  { "STU B,S", 0xEF, 9, 0, B_(11100101) },
  { "STU D,X", 0xEF, 9, 0, B_(10001011) },
  { "STU D,Y", 0xEF, 9, 0, B_(10101011) },
  { "STU D,U", 0xEF, 9, 0, B_(11001011) },
  { "STU D,S", 0xEF, 9, 0, B_(11101011) },
  { "STU,X+", 0xEF, 9, 0, B_(10000000) },
  { "STU,Y+", 0xEF, 9, 0, B_(10100000) },
  { "STU,U+", 0xEF, 9, 0, B_(11000000) },
  { "STU,S+", 0xEF, 9, 0, B_(11100000) },
  { "STU,X++", 0xEF, 9, 0, B_(10000001) },
  { "STU,Y++", 0xEF, 9, 0, B_(10100001) },
  { "STU,U++", 0xEF, 9, 0, B_(11000001) },
  { "STU,S++", 0xEF, 9, 0, B_(11100001) },
  { "STU,-X", 0xEF, 9, 0, B_(10000010) },
  { "STU,-Y", 0xEF, 9, 0, B_(10100010) },
  { "STU,-U", 0xEF, 9, 0, B_(11000010) },
  { "STU,-S", 0xEF, 9, 0, B_(11100010) },
  { "STU,--X", 0xEF, 9, 0, B_(10000011) },
  { "STU,--Y", 0xEF, 9, 0, B_(10100011) },
  { "STU,--U", 0xEF, 9, 0, B_(11000011) },
  { "STU,--S", 0xEF, 9, 0, B_(11100011) },
  { "STU (,X)", 0xEF, 9, 0, B_(10010100) },
  { "STU (,Y)", 0xEF, 9, 0, B_(10110100) },
  { "STU (,U)", 0xEF, 9, 0, B_(11010100) },
  { "STU (,S)", 0xEF, 9, 0, B_(11110100) },
  { "STU (A,X)", 0xEF, 9, 0, B_(10010110) },
  { "STU (A,Y)", 0xEF, 9, 0, B_(10110110) },
  { "STU (A,U)", 0xEF, 9, 0, B_(11010110) },
  { "STU (A,S)", 0xEF, 9, 0, B_(11110110) },
  { "STU (B,X)", 0xEF, 9, 0, B_(10010101) },
  { "STU (B,Y)", 0xEF, 9, 0, B_(10110101) },
  { "STU (B,U)", 0xEF, 9, 0, B_(11010101) },
  { "STU (B,S)", 0xEF, 9, 0, B_(11110101) },
  { "STU (D,X)", 0xEF, 9, 0, B_(10011011) },
  { "STU (D,Y)", 0xEF, 9, 0, B_(10111011) },
  { "STU (D,U)", 0xEF, 9, 0, B_(11011011) },
  { "STU (D,S)", 0xEF, 9, 0, B_(11111011) },
  { "STU (,X++)", 0xEF, 9, 0, B_(10010001) },
  { "STU (,Y++)", 0xEF, 9, 0, B_(10110001) },
  { "STU (,U++)", 0xEF, 9, 0, B_(11010001) },
  { "STU (,S++)", 0xEF, 9, 0, B_(11110001) },
  { "STU (,--X)", 0xEF, 9, 0, B_(10010011) },
  { "STU (,--Y)", 0xEF, 9, 0, B_(10110011) },
  { "STU (,--U)", 0xEF, 9, 0, B_(11010011) },
  { "STU (,--S)", 0xEF, 9, 0, B_(11110011) },
  { "STU (x,X)", 0xEF, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "STU (x,Y)", 0xEF, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "STU (x,U)", 0xEF, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "STU (x,S)", 0xEF, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "STU (?,X)", 0xEF, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "STU (?,Y)", 0xEF, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "STU (?,U)", 0xEF, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "STU (?,S)", 0xEF, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "STU (x,PCR)", 0xEF, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "STU (?,PCR)", 0xEF, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "STU (?)", 0xEF, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "STU s,X", 0xEF, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "STU s,Y", 0xEF, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "STU s,U", 0xEF, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "STU s,S", 0xEF, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "STU x,X", 0xEF, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "STU x,Y", 0xEF, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "STU x,U", 0xEF, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "STU x,S", 0xEF, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "STU ?,X", 0xEF, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "STU ?,Y", 0xEF, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "STU ?,U", 0xEF, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "STU ?,S", 0xEF, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "STU x,PCR", 0xEF, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "STU ?,PCR", 0xEF, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "STU x", 0xDF, 4, 1, 0 },
  { "STU ?", 0xFF, 2, 0, 0 },

  { "STX,X", 0xAF, 9, 0, B_(10000100) },
  { "STX,Y", 0xAF, 9, 0, B_(10100100) },
  { "STX,U", 0xAF, 9, 0, B_(11000100) },
  { "STX,S", 0xAF, 9, 0, B_(11100100) },
  { "STX A,X", 0xAF, 9, 0, B_(10000110) },
  { "STX A,Y", 0xAF, 9, 0, B_(10100110) },
  { "STX A,U", 0xAF, 9, 0, B_(11000110) },
  { "STX A,S", 0xAF, 9, 0, B_(11100110) },
  { "STX B,X", 0xAF, 9, 0, B_(10000101) },
  { "STX B,Y", 0xAF, 9, 0, B_(10100101) },
  { "STX B,U", 0xAF, 9, 0, B_(11000101) },
  { "STX B,S", 0xAF, 9, 0, B_(11100101) },
  { "STX D,X", 0xAF, 9, 0, B_(10001011) },
  { "STX D,Y", 0xAF, 9, 0, B_(10101011) },
  { "STX D,U", 0xAF, 9, 0, B_(11001011) },
  { "STX D,S", 0xAF, 9, 0, B_(11101011) },
  { "STX,X+", 0xAF, 9, 0, B_(10000000) },
  { "STX,Y+", 0xAF, 9, 0, B_(10100000) },
  { "STX,U+", 0xAF, 9, 0, B_(11000000) },
  { "STX,S+", 0xAF, 9, 0, B_(11100000) },
  { "STX,X++", 0xAF, 9, 0, B_(10000001) },
  { "STX,Y++", 0xAF, 9, 0, B_(10100001) },
  { "STX,U++", 0xAF, 9, 0, B_(11000001) },
  { "STX,S++", 0xAF, 9, 0, B_(11100001) },
  { "STX,-X", 0xAF, 9, 0, B_(10000010) },
  { "STX,-Y", 0xAF, 9, 0, B_(10100010) },
  { "STX,-U", 0xAF, 9, 0, B_(11000010) },
  { "STX,-S", 0xAF, 9, 0, B_(11100010) },
  { "STX,--X", 0xAF, 9, 0, B_(10000011) },
  { "STX,--Y", 0xAF, 9, 0, B_(10100011) },
  { "STX,--U", 0xAF, 9, 0, B_(11000011) },
  { "STX,--S", 0xAF, 9, 0, B_(11100011) },
  { "STX (,X)", 0xAF, 9, 0, B_(10010100) },
  { "STX (,Y)", 0xAF, 9, 0, B_(10110100) },
  { "STX (,U)", 0xAF, 9, 0, B_(11010100) },
  { "STX (,S)", 0xAF, 9, 0, B_(11110100) },
  { "STX (A,X)", 0xAF, 9, 0, B_(10010110) },
  { "STX (A,Y)", 0xAF, 9, 0, B_(10110110) },
  { "STX (A,U)", 0xAF, 9, 0, B_(11010110) },
  { "STX (A,S)", 0xAF, 9, 0, B_(11110110) },
  { "STX (B,X)", 0xAF, 9, 0, B_(10010101) },
  { "STX (B,Y)", 0xAF, 9, 0, B_(10110101) },
  { "STX (B,U)", 0xAF, 9, 0, B_(11010101) },
  { "STX (B,S)", 0xAF, 9, 0, B_(11110101) },
  { "STX (D,X)", 0xAF, 9, 0, B_(10011011) },
  { "STX (D,Y)", 0xAF, 9, 0, B_(10111011) },
  { "STX (D,U)", 0xAF, 9, 0, B_(11011011) },
  { "STX (D,S)", 0xAF, 9, 0, B_(11111011) },
  { "STX (,X++)", 0xAF, 9, 0, B_(10010001) },
  { "STX (,Y++)", 0xAF, 9, 0, B_(10110001) },
  { "STX (,U++)", 0xAF, 9, 0, B_(11010001) },
  { "STX (,S++)", 0xAF, 9, 0, B_(11110001) },
  { "STX (,--X)", 0xAF, 9, 0, B_(10010011) },
  { "STX (,--Y)", 0xAF, 9, 0, B_(10110011) },
  { "STX (,--U)", 0xAF, 9, 0, B_(11010011) },
  { "STX (,--S)", 0xAF, 9, 0, B_(11110011) },
  { "STX (x,X)", 0xAF, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "STX (x,Y)", 0xAF, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "STX (x,U)", 0xAF, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "STX (x,S)", 0xAF, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "STX (?,X)", 0xAF, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "STX (?,Y)", 0xAF, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "STX (?,U)", 0xAF, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "STX (?,S)", 0xAF, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "STX (x,PCR)", 0xAF, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "STX (?,PCR)", 0xAF, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "STX (?)", 0xAF, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "STX s,X", 0xAF, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "STX s,Y", 0xAF, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "STX s,U", 0xAF, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "STX s,S", 0xAF, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "STX x,X", 0xAF, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "STX x,Y", 0xAF, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "STX x,U", 0xAF, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "STX x,S", 0xAF, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "STX ?,X", 0xAF, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "STX ?,Y", 0xAF, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "STX ?,U", 0xAF, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "STX ?,S", 0xAF, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "STX x,PCR", 0xAF, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "STX ?,PCR", 0xAF, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "STX x", 0x9F, 4, 1, 0 },
  { "STX ?", 0xBF, 2, 0, 0 },

  { "STY,X", 0x10AF, 9, 0, B_(10000100) },
  { "STY,Y", 0x10AF, 9, 0, B_(10100100) },
  { "STY,U", 0x10AF, 9, 0, B_(11000100) },
  { "STY,S", 0x10AF, 9, 0, B_(11100100) },
  { "STY A,X", 0x10AF, 9, 0, B_(10000110) },
  { "STY A,Y", 0x10AF, 9, 0, B_(10100110) },
  { "STY A,U", 0x10AF, 9, 0, B_(11000110) },
  { "STY A,S", 0x10AF, 9, 0, B_(11100110) },
  { "STY B,X", 0x10AF, 9, 0, B_(10000101) },
  { "STY B,Y", 0x10AF, 9, 0, B_(10100101) },
  { "STY B,U", 0x10AF, 9, 0, B_(11000101) },
  { "STY B,S", 0x10AF, 9, 0, B_(11100101) },
  { "STY D,X", 0x10AF, 9, 0, B_(10001011) },
  { "STY D,Y", 0x10AF, 9, 0, B_(10101011) },
  { "STY D,U", 0x10AF, 9, 0, B_(11001011) },
  { "STY D,S", 0x10AF, 9, 0, B_(11101011) },
  { "STY,X+", 0x10AF, 9, 0, B_(10000000) },
  { "STY,Y+", 0x10AF, 9, 0, B_(10100000) },
  { "STY,U+", 0x10AF, 9, 0, B_(11000000) },
  { "STY,S+", 0x10AF, 9, 0, B_(11100000) },
  { "STY,X++", 0x10AF, 9, 0, B_(10000001) },
  { "STY,Y++", 0x10AF, 9, 0, B_(10100001) },
  { "STY,U++", 0x10AF, 9, 0, B_(11000001) },
  { "STY,S++", 0x10AF, 9, 0, B_(11100001) },
  { "STY,-X", 0x10AF, 9, 0, B_(10000010) },
  { "STY,-Y", 0x10AF, 9, 0, B_(10100010) },
  { "STY,-U", 0x10AF, 9, 0, B_(11000010) },
  { "STY,-S", 0x10AF, 9, 0, B_(11100010) },
  { "STY,--X", 0x10AF, 9, 0, B_(10000011) },
  { "STY,--Y", 0x10AF, 9, 0, B_(10100011) },
  { "STY,--U", 0x10AF, 9, 0, B_(11000011) },
  { "STY,--S", 0x10AF, 9, 0, B_(11100011) },
  { "STY (,X)", 0x10AF, 9, 0, B_(10010100) },
  { "STY (,Y)", 0x10AF, 9, 0, B_(10110100) },
  { "STY (,U)", 0x10AF, 9, 0, B_(11010100) },
  { "STY (,S)", 0x10AF, 9, 0, B_(11110100) },
  { "STY (A,X)", 0x10AF, 9, 0, B_(10010110) },
  { "STY (A,Y)", 0x10AF, 9, 0, B_(10110110) },
  { "STY (A,U)", 0x10AF, 9, 0, B_(11010110) },
  { "STY (A,S)", 0x10AF, 9, 0, B_(11110110) },
  { "STY (B,X)", 0x10AF, 9, 0, B_(10010101) },
  { "STY (B,Y)", 0x10AF, 9, 0, B_(10110101) },
  { "STY (B,U)", 0x10AF, 9, 0, B_(11010101) },
  { "STY (B,S)", 0x10AF, 9, 0, B_(11110101) },
  { "STY (D,X)", 0x10AF, 9, 0, B_(10011011) },
  { "STY (D,Y)", 0x10AF, 9, 0, B_(10111011) },
  { "STY (D,U)", 0x10AF, 9, 0, B_(11011011) },
  { "STY (D,S)", 0x10AF, 9, 0, B_(11111011) },
  { "STY (,X++)", 0x10AF, 9, 0, B_(10010001) },
  { "STY (,Y++)", 0x10AF, 9, 0, B_(10110001) },
  { "STY (,U++)", 0x10AF, 9, 0, B_(11010001) },
  { "STY (,S++)", 0x10AF, 9, 0, B_(11110001) },
  { "STY (,--X)", 0x10AF, 9, 0, B_(10010011) },
  { "STY (,--Y)", 0x10AF, 9, 0, B_(10110011) },
  { "STY (,--U)", 0x10AF, 9, 0, B_(11010011) },
  { "STY (,--S)", 0x10AF, 9, 0, B_(11110011) },
  { "STY (x,X)", 0x10AF, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "STY (x,Y)", 0x10AF, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "STY (x,U)", 0x10AF, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "STY (x,S)", 0x10AF, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "STY (?,X)", 0x10AF, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "STY (?,Y)", 0x10AF, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "STY (?,U)", 0x10AF, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "STY (?,S)", 0x10AF, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "STY (x,PCR)", 0x10AF, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "STY (?,PCR)", 0x10AF, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "STY (?)", 0x10AF, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "STY s,X", 0x10AF, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "STY s,Y", 0x10AF, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "STY s,U", 0x10AF, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "STY s,S", 0x10AF, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "STY x,X", 0x10AF, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "STY x,Y", 0x10AF, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "STY x,U", 0x10AF, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "STY x,S", 0x10AF, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "STY ?,X", 0x10AF, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "STY ?,Y", 0x10AF, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "STY ?,U", 0x10AF, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "STY ?,S", 0x10AF, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "STY x,PCR", 0x10AF, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "STY ?,PCR", 0x10AF, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "STY x", 0x109F, 4, 1, 0 },
  { "STY ?", 0x10BF, 2, 0, 0 },

  { "SUBA #x", 0x80, 1, 0, 0 },
  { "SUBA,X", 0xA0, 9, 0, B_(10000100) },
  { "SUBA,Y", 0xA0, 9, 0, B_(10100100) },
  { "SUBA,U", 0xA0, 9, 0, B_(11000100) },
  { "SUBA,S", 0xA0, 9, 0, B_(11100100) },
  { "SUBA A,X", 0xA0, 9, 0, B_(10000110) },
  { "SUBA A,Y", 0xA0, 9, 0, B_(10100110) },
  { "SUBA A,U", 0xA0, 9, 0, B_(11000110) },
  { "SUBA A,S", 0xA0, 9, 0, B_(11100110) },
  { "SUBA B,X", 0xA0, 9, 0, B_(10000101) },
  { "SUBA B,Y", 0xA0, 9, 0, B_(10100101) },
  { "SUBA B,U", 0xA0, 9, 0, B_(11000101) },
  { "SUBA B,S", 0xA0, 9, 0, B_(11100101) },
  { "SUBA D,X", 0xA0, 9, 0, B_(10001011) },
  { "SUBA D,Y", 0xA0, 9, 0, B_(10101011) },
  { "SUBA D,U", 0xA0, 9, 0, B_(11001011) },
  { "SUBA D,S", 0xA0, 9, 0, B_(11101011) },
  { "SUBA,X+", 0xA0, 9, 0, B_(10000000) },
  { "SUBA,Y+", 0xA0, 9, 0, B_(10100000) },
  { "SUBA,U+", 0xA0, 9, 0, B_(11000000) },
  { "SUBA,S+", 0xA0, 9, 0, B_(11100000) },
  { "SUBA,X++", 0xA0, 9, 0, B_(10000001) },
  { "SUBA,Y++", 0xA0, 9, 0, B_(10100001) },
  { "SUBA,U++", 0xA0, 9, 0, B_(11000001) },
  { "SUBA,S++", 0xA0, 9, 0, B_(11100001) },
  { "SUBA,-X", 0xA0, 9, 0, B_(10000010) },
  { "SUBA,-Y", 0xA0, 9, 0, B_(10100010) },
  { "SUBA,-U", 0xA0, 9, 0, B_(11000010) },
  { "SUBA,-S", 0xA0, 9, 0, B_(11100010) },
  { "SUBA,--X", 0xA0, 9, 0, B_(10000011) },
  { "SUBA,--Y", 0xA0, 9, 0, B_(10100011) },
  { "SUBA,--U", 0xA0, 9, 0, B_(11000011) },
  { "SUBA,--S", 0xA0, 9, 0, B_(11100011) },
  { "SUBA (,X)", 0xA0, 9, 0, B_(10010100) },
  { "SUBA (,Y)", 0xA0, 9, 0, B_(10110100) },
  { "SUBA (,U)", 0xA0, 9, 0, B_(11010100) },
  { "SUBA (,S)", 0xA0, 9, 0, B_(11110100) },
  { "SUBA (A,X)", 0xA0, 9, 0, B_(10010110) },
  { "SUBA (A,Y)", 0xA0, 9, 0, B_(10110110) },
  { "SUBA (A,U)", 0xA0, 9, 0, B_(11010110) },
  { "SUBA (A,S)", 0xA0, 9, 0, B_(11110110) },
  { "SUBA (B,X)", 0xA0, 9, 0, B_(10010101) },
  { "SUBA (B,Y)", 0xA0, 9, 0, B_(10110101) },
  { "SUBA (B,U)", 0xA0, 9, 0, B_(11010101) },
  { "SUBA (B,S)", 0xA0, 9, 0, B_(11110101) },
  { "SUBA (D,X)", 0xA0, 9, 0, B_(10011011) },
  { "SUBA (D,Y)", 0xA0, 9, 0, B_(10111011) },
  { "SUBA (D,U)", 0xA0, 9, 0, B_(11011011) },
  { "SUBA (D,S)", 0xA0, 9, 0, B_(11111011) },
  { "SUBA (,X++)", 0xA0, 9, 0, B_(10010001) },
  { "SUBA (,Y++)", 0xA0, 9, 0, B_(10110001) },
  { "SUBA (,U++)", 0xA0, 9, 0, B_(11010001) },
  { "SUBA (,S++)", 0xA0, 9, 0, B_(11110001) },
  { "SUBA (,--X)", 0xA0, 9, 0, B_(10010011) },
  { "SUBA (,--Y)", 0xA0, 9, 0, B_(10110011) },
  { "SUBA (,--U)", 0xA0, 9, 0, B_(11010011) },
  { "SUBA (,--S)", 0xA0, 9, 0, B_(11110011) },
  { "SUBA (x,X)", 0xA0, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "SUBA (x,Y)", 0xA0, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "SUBA (x,U)", 0xA0, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "SUBA (x,S)", 0xA0, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "SUBA (?,X)", 0xA0, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "SUBA (?,Y)", 0xA0, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "SUBA (?,U)", 0xA0, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "SUBA (?,S)", 0xA0, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "SUBA (x,PCR)", 0xA0, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "SUBA (?,PCR)", 0xA0, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "SUBA (?)", 0xA0, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "SUBA s,X", 0xA0, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "SUBA s,Y", 0xA0, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "SUBA s,U", 0xA0, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "SUBA s,S", 0xA0, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "SUBA x,X", 0xA0, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "SUBA x,Y", 0xA0, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "SUBA x,U", 0xA0, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "SUBA x,S", 0xA0, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "SUBA ?,X", 0xA0, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "SUBA ?,Y", 0xA0, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "SUBA ?,U", 0xA0, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "SUBA ?,S", 0xA0, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "SUBA x,PCR", 0xA0, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "SUBA ?,PCR", 0xA0, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "SUBA x", 0x90, 4, 1, 0 },
  { "SUBA ?", 0xB0, 2, 0, 0 },

  { "SUBB #x", 0xC0, 1, 0, 0 },
  { "SUBB,X", 0xE0, 9, 0, B_(10000100) },
  { "SUBB,Y", 0xE0, 9, 0, B_(10100100) },
  { "SUBB,U", 0xE0, 9, 0, B_(11000100) },
  { "SUBB,S", 0xE0, 9, 0, B_(11100100) },
  { "SUBB A,X", 0xE0, 9, 0, B_(10000110) },
  { "SUBB A,Y", 0xE0, 9, 0, B_(10100110) },
  { "SUBB A,U", 0xE0, 9, 0, B_(11000110) },
  { "SUBB A,S", 0xE0, 9, 0, B_(11100110) },
  { "SUBB B,X", 0xE0, 9, 0, B_(10000101) },
  { "SUBB B,Y", 0xE0, 9, 0, B_(10100101) },
  { "SUBB B,U", 0xE0, 9, 0, B_(11000101) },
  { "SUBB B,S", 0xE0, 9, 0, B_(11100101) },
  { "SUBB D,X", 0xE0, 9, 0, B_(10001011) },
  { "SUBB D,Y", 0xE0, 9, 0, B_(10101011) },
  { "SUBB D,U", 0xE0, 9, 0, B_(11001011) },
  { "SUBB D,S", 0xE0, 9, 0, B_(11101011) },
  { "SUBB,X+", 0xE0, 9, 0, B_(10000000) },
  { "SUBB,Y+", 0xE0, 9, 0, B_(10100000) },
  { "SUBB,U+", 0xE0, 9, 0, B_(11000000) },
  { "SUBB,S+", 0xE0, 9, 0, B_(11100000) },
  { "SUBB,X++", 0xE0, 9, 0, B_(10000001) },
  { "SUBB,Y++", 0xE0, 9, 0, B_(10100001) },
  { "SUBB,U++", 0xE0, 9, 0, B_(11000001) },
  { "SUBB,S++", 0xE0, 9, 0, B_(11100001) },
  { "SUBB,-X", 0xE0, 9, 0, B_(10000010) },
  { "SUBB,-Y", 0xE0, 9, 0, B_(10100010) },
  { "SUBB,-U", 0xE0, 9, 0, B_(11000010) },
  { "SUBB,-S", 0xE0, 9, 0, B_(11100010) },
  { "SUBB,--X", 0xE0, 9, 0, B_(10000011) },
  { "SUBB,--Y", 0xE0, 9, 0, B_(10100011) },
  { "SUBB,--U", 0xE0, 9, 0, B_(11000011) },
  { "SUBB,--S", 0xE0, 9, 0, B_(11100011) },
  { "SUBB (,X)", 0xE0, 9, 0, B_(10010100) },
  { "SUBB (,Y)", 0xE0, 9, 0, B_(10110100) },
  { "SUBB (,U)", 0xE0, 9, 0, B_(11010100) },
  { "SUBB (,S)", 0xE0, 9, 0, B_(11110100) },
  { "SUBB (A,X)", 0xE0, 9, 0, B_(10010110) },
  { "SUBB (A,Y)", 0xE0, 9, 0, B_(10110110) },
  { "SUBB (A,U)", 0xE0, 9, 0, B_(11010110) },
  { "SUBB (A,S)", 0xE0, 9, 0, B_(11110110) },
  { "SUBB (B,X)", 0xE0, 9, 0, B_(10010101) },
  { "SUBB (B,Y)", 0xE0, 9, 0, B_(10110101) },
  { "SUBB (B,U)", 0xE0, 9, 0, B_(11010101) },
  { "SUBB (B,S)", 0xE0, 9, 0, B_(11110101) },
  { "SUBB (D,X)", 0xE0, 9, 0, B_(10011011) },
  { "SUBB (D,Y)", 0xE0, 9, 0, B_(10111011) },
  { "SUBB (D,U)", 0xE0, 9, 0, B_(11011011) },
  { "SUBB (D,S)", 0xE0, 9, 0, B_(11111011) },
  { "SUBB (,X++)", 0xE0, 9, 0, B_(10010001) },
  { "SUBB (,Y++)", 0xE0, 9, 0, B_(10110001) },
  { "SUBB (,U++)", 0xE0, 9, 0, B_(11010001) },
  { "SUBB (,S++)", 0xE0, 9, 0, B_(11110001) },
  { "SUBB (,--X)", 0xE0, 9, 0, B_(10010011) },
  { "SUBB (,--Y)", 0xE0, 9, 0, B_(10110011) },
  { "SUBB (,--U)", 0xE0, 9, 0, B_(11010011) },
  { "SUBB (,--S)", 0xE0, 9, 0, B_(11110011) },
  { "SUBB (x,X)", 0xE0, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "SUBB (x,Y)", 0xE0, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "SUBB (x,U)", 0xE0, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "SUBB (x,S)", 0xE0, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "SUBB (?,X)", 0xE0, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "SUBB (?,Y)", 0xE0, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "SUBB (?,U)", 0xE0, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "SUBB (?,S)", 0xE0, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "SUBB (x,PCR)", 0xE0, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "SUBB (?,PCR)", 0xE0, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "SUBB (?)", 0xE0, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "SUBB s,X", 0xE0, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "SUBB s,Y", 0xE0, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "SUBB s,U", 0xE0, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "SUBB s,S", 0xE0, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "SUBB x,X", 0xE0, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "SUBB x,Y", 0xE0, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "SUBB x,U", 0xE0, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "SUBB x,S", 0xE0, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "SUBB ?,X", 0xE0, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "SUBB ?,Y", 0xE0, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "SUBB ?,U", 0xE0, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "SUBB ?,S", 0xE0, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "SUBB x,PCR", 0xE0, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "SUBB ?,PCR", 0xE0, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "SUBB x", 0xD0, 4, 1, 0 },
  { "SUBB ?", 0xF0, 2, 0, 0 },

  { "SUBD #x", 0x83, 1, 0, 0 },
  { "SUBD,X", 0xA3, 9, 0, B_(10000100) },
  { "SUBD,Y", 0xA3, 9, 0, B_(10100100) },
  { "SUBD,U", 0xA3, 9, 0, B_(11000100) },
  { "SUBD,S", 0xA3, 9, 0, B_(11100100) },
  { "SUBD A,X", 0xA3, 9, 0, B_(10000110) },
  { "SUBD A,Y", 0xA3, 9, 0, B_(10100110) },
  { "SUBD A,U", 0xA3, 9, 0, B_(11000110) },
  { "SUBD A,S", 0xA3, 9, 0, B_(11100110) },
  { "SUBD B,X", 0xA3, 9, 0, B_(10000101) },
  { "SUBD B,Y", 0xA3, 9, 0, B_(10100101) },
  { "SUBD B,U", 0xA3, 9, 0, B_(11000101) },
  { "SUBD B,S", 0xA3, 9, 0, B_(11100101) },
  { "SUBD D,X", 0xA3, 9, 0, B_(10001011) },
  { "SUBD D,Y", 0xA3, 9, 0, B_(10101011) },
  { "SUBD D,U", 0xA3, 9, 0, B_(11001011) },
  { "SUBD D,S", 0xA3, 9, 0, B_(11101011) },
  { "SUBD,X+", 0xA3, 9, 0, B_(10000000) },
  { "SUBD,Y+", 0xA3, 9, 0, B_(10100000) },
  { "SUBD,U+", 0xA3, 9, 0, B_(11000000) },
  { "SUBD,S+", 0xA3, 9, 0, B_(11100000) },
  { "SUBD,X++", 0xA3, 9, 0, B_(10000001) },
  { "SUBD,Y++", 0xA3, 9, 0, B_(10100001) },
  { "SUBD,U++", 0xA3, 9, 0, B_(11000001) },
  { "SUBD,S++", 0xA3, 9, 0, B_(11100001) },
  { "SUBD,-X", 0xA3, 9, 0, B_(10000010) },
  { "SUBD,-Y", 0xA3, 9, 0, B_(10100010) },
  { "SUBD,-U", 0xA3, 9, 0, B_(11000010) },
  { "SUBD,-S", 0xA3, 9, 0, B_(11100010) },
  { "SUBD,--X", 0xA3, 9, 0, B_(10000011) },
  { "SUBD,--Y", 0xA3, 9, 0, B_(10100011) },
  { "SUBD,--U", 0xA3, 9, 0, B_(11000011) },
  { "SUBD,--S", 0xA3, 9, 0, B_(11100011) },
  { "SUBD (,X)", 0xA3, 9, 0, B_(10010100) },
  { "SUBD (,Y)", 0xA3, 9, 0, B_(10110100) },
  { "SUBD (,U)", 0xA3, 9, 0, B_(11010100) },
  { "SUBD (,S)", 0xA3, 9, 0, B_(11110100) },
  { "SUBD (A,X)", 0xA3, 9, 0, B_(10010110) },
  { "SUBD (A,Y)", 0xA3, 9, 0, B_(10110110) },
  { "SUBD (A,U)", 0xA3, 9, 0, B_(11010110) },
  { "SUBD (A,S)", 0xA3, 9, 0, B_(11110110) },
  { "SUBD (B,X)", 0xA3, 9, 0, B_(10010101) },
  { "SUBD (B,Y)", 0xA3, 9, 0, B_(10110101) },
  { "SUBD (B,U)", 0xA3, 9, 0, B_(11010101) },
  { "SUBD (B,S)", 0xA3, 9, 0, B_(11110101) },
  { "SUBD (D,X)", 0xA3, 9, 0, B_(10011011) },
  { "SUBD (D,Y)", 0xA3, 9, 0, B_(10111011) },
  { "SUBD (D,U)", 0xA3, 9, 0, B_(11011011) },
  { "SUBD (D,S)", 0xA3, 9, 0, B_(11111011) },
  { "SUBD (,X++)", 0xA3, 9, 0, B_(10010001) },
  { "SUBD (,Y++)", 0xA3, 9, 0, B_(10110001) },
  { "SUBD (,U++)", 0xA3, 9, 0, B_(11010001) },
  { "SUBD (,S++)", 0xA3, 9, 0, B_(11110001) },
  { "SUBD (,--X)", 0xA3, 9, 0, B_(10010011) },
  { "SUBD (,--Y)", 0xA3, 9, 0, B_(10110011) },
  { "SUBD (,--U)", 0xA3, 9, 0, B_(11010011) },
  { "SUBD (,--S)", 0xA3, 9, 0, B_(11110011) },
  { "SUBD (x,X)", 0xA3, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "SUBD (x,Y)", 0xA3, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "SUBD (x,U)", 0xA3, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "SUBD (x,S)", 0xA3, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "SUBD (?,X)", 0xA3, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "SUBD (?,Y)", 0xA3, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "SUBD (?,U)", 0xA3, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "SUBD (?,S)", 0xA3, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "SUBD (x,PCR)", 0xA3, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "SUBD (?,PCR)", 0xA3, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "SUBD (?)", 0xA3, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "SUBD s,X", 0xA3, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "SUBD s,Y", 0xA3, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "SUBD s,U", 0xA3, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "SUBD s,S", 0xA3, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "SUBD x,X", 0xA3, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "SUBD x,Y", 0xA3, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "SUBD x,U", 0xA3, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "SUBD x,S", 0xA3, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "SUBD ?,X", 0xA3, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "SUBD ?,Y", 0xA3, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "SUBD ?,U", 0xA3, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "SUBD ?,S", 0xA3, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "SUBD x,PCR", 0xA3, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "SUBD ?,PCR", 0xA3, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "SUBD x", 0x93, 4, 1, 0 },
  { "SUBD ?", 0xB3, 2, 0, 0 },

  { "SWI1", 0x3F, 0, 0, 0 },
  { "SWI2", 0x103F, 0, 0, 0 },
  { "SWI3", 0x113F, 0, 0, 0 },
  { "SWI", 0x3F, 0, 0, 0 },

  { "SYNC", 0x13, 0, 0, 0 },

  { "TFR r", 0x1F, 10, 0, 0 },

  { "TSTA", 0x4D, 0, 0, 0 },
  { "TSTB", 0x5D, 0, 0, 0 },
  { "TST,X", 0x6D, 9, 0, B_(10000100) },
  { "TST,Y", 0x6D, 9, 0, B_(10100100) },
  { "TST,U", 0x6D, 9, 0, B_(11000100) },
  { "TST,S", 0x6D, 9, 0, B_(11100100) },
  { "TST A,X", 0x6D, 9, 0, B_(10000110) },
  { "TST A,Y", 0x6D, 9, 0, B_(10100110) },
  { "TST A,U", 0x6D, 9, 0, B_(11000110) },
  { "TST A,S", 0x6D, 9, 0, B_(11100110) },
  { "TST B,X", 0x6D, 9, 0, B_(10000101) },
  { "TST B,Y", 0x6D, 9, 0, B_(10100101) },
  { "TST B,U", 0x6D, 9, 0, B_(11000101) },
  { "TST B,S", 0x6D, 9, 0, B_(11100101) },
  { "TST D,X", 0x6D, 9, 0, B_(10001011) },
  { "TST D,Y", 0x6D, 9, 0, B_(10101011) },
  { "TST D,U", 0x6D, 9, 0, B_(11001011) },
  { "TST D,S", 0x6D, 9, 0, B_(11101011) },
  { "TST,X+", 0x6D, 9, 0, B_(10000000) },
  { "TST,Y+", 0x6D, 9, 0, B_(10100000) },
  { "TST,U+", 0x6D, 9, 0, B_(11000000) },
  { "TST,S+", 0x6D, 9, 0, B_(11100000) },
  { "TST,X++", 0x6D, 9, 0, B_(10000001) },
  { "TST,Y++", 0x6D, 9, 0, B_(10100001) },
  { "TST,U++", 0x6D, 9, 0, B_(11000001) },
  { "TST,S++", 0x6D, 9, 0, B_(11100001) },
  { "TST,-X", 0x6D, 9, 0, B_(10000010) },
  { "TST,-Y", 0x6D, 9, 0, B_(10100010) },
  { "TST,-U", 0x6D, 9, 0, B_(11000010) },
  { "TST,-S", 0x6D, 9, 0, B_(11100010) },
  { "TST,--X", 0x6D, 9, 0, B_(10000011) },
  { "TST,--Y", 0x6D, 9, 0, B_(10100011) },
  { "TST,--U", 0x6D, 9, 0, B_(11000011) },
  { "TST,--S", 0x6D, 9, 0, B_(11100011) },
  { "TST (,X)", 0x6D, 9, 0, B_(10010100) },
  { "TST (,Y)", 0x6D, 9, 0, B_(10110100) },
  { "TST (,U)", 0x6D, 9, 0, B_(11010100) },
  { "TST (,S)", 0x6D, 9, 0, B_(11110100) },
  { "TST (A,X)", 0x6D, 9, 0, B_(10010110) },
  { "TST (A,Y)", 0x6D, 9, 0, B_(10110110) },
  { "TST (A,U)", 0x6D, 9, 0, B_(11010110) },
  { "TST (A,S)", 0x6D, 9, 0, B_(11110110) },
  { "TST (B,X)", 0x6D, 9, 0, B_(10010101) },
  { "TST (B,Y)", 0x6D, 9, 0, B_(10110101) },
  { "TST (B,U)", 0x6D, 9, 0, B_(11010101) },
  { "TST (B,S)", 0x6D, 9, 0, B_(11110101) },
  { "TST (D,X)", 0x6D, 9, 0, B_(10011011) },
  { "TST (D,Y)", 0x6D, 9, 0, B_(10111011) },
  { "TST (D,U)", 0x6D, 9, 0, B_(11011011) },
  { "TST (D,S)", 0x6D, 9, 0, B_(11111011) },
  { "TST (,X++)", 0x6D, 9, 0, B_(10010001) },
  { "TST (,Y++)", 0x6D, 9, 0, B_(10110001) },
  { "TST (,U++)", 0x6D, 9, 0, B_(11010001) },
  { "TST (,S++)", 0x6D, 9, 0, B_(11110001) },
  { "TST (,--X)", 0x6D, 9, 0, B_(10010011) },
  { "TST (,--Y)", 0x6D, 9, 0, B_(10110011) },
  { "TST (,--U)", 0x6D, 9, 0, B_(11010011) },
  { "TST (,--S)", 0x6D, 9, 0, B_(11110011) },
  { "TST (x,X)", 0x6D, 7, 1, B_(10011000) }, /* 8-bit offset */
  { "TST (x,Y)", 0x6D, 7, 1, B_(10111000) }, /* 8-bit offset */
  { "TST (x,U)", 0x6D, 7, 1, B_(11011000) }, /* 8-bit offset */
  { "TST (x,S)", 0x6D, 7, 1, B_(11111000) }, /* 8-bit offset */
  { "TST (?,X)", 0x6D, 8, 0, B_(10011001) }, /* 16-bit offset */
  { "TST (?,Y)", 0x6D, 8, 0, B_(10111001) }, /* 16-bit offset */
  { "TST (?,U)", 0x6D, 8, 0, B_(11011001) }, /* 16-bit offset */
  { "TST (?,S)", 0x6D, 8, 0, B_(11111001) }, /* 16-bit offset */
  { "TST (x,PCR)", 0x6D, 7, 1, B_(10011100) }, /* 8-bit offset */
  { "TST (?,PCR)", 0x6D, 8, 0, B_(10011101) }, /* 16-bit offset */
  { "TST (?)", 0x6D, 8, 0, B_(10011111) }, /* 16-bit offset */
  { "TST s,X", 0x6D, 6, 1, B_(00000000) }, /* 5-bit offset */
  { "TST s,Y", 0x6D, 6, 1, B_(00100000) }, /* 5-bit offset */
  { "TST s,U", 0x6D, 6, 1, B_(01000000) }, /* 5-bit offset */
  { "TST s,S", 0x6D, 6, 1, B_(01100000) }, /* 5-bit offset */
  { "TST x,X", 0x6D, 7, 1, B_(10001000) }, /* 8-bit offset */
  { "TST x,Y", 0x6D, 7, 1, B_(10101000) }, /* 8-bit offset */
  { "TST x,U", 0x6D, 7, 1, B_(11001000) }, /* 8-bit offset */
  { "TST x,S", 0x6D, 7, 1, B_(11101000) }, /* 8-bit offset */
  { "TST ?,X", 0x6D, 8, 0, B_(10001001) }, /* 16-bit offset */
  { "TST ?,Y", 0x6D, 8, 0, B_(10101001) }, /* 16-bit offset */
  { "TST ?,U", 0x6D, 8, 0, B_(11001001) }, /* 16-bit offset */
  { "TST ?,S", 0x6D, 8, 0, B_(11101001) }, /* 16-bit offset */
  { "TST x,PCR", 0x6D, 7, 1, B_(10001100) }, /* 8-bit offset */
  { "TST ?,PCR", 0x6D, 8, 0, B_(10001101) }, /* 16-bit offset */
  { "TST x", 0x0D, 4, 1, 0 },
  { "TST ?", 0x7D, 2, 0, 0 },
  
  { "E", 0x100, 0xFF, 0, 0 }
};
